/* App.c generated by valac 0.56.17, the Vala compiler
 * generated from App.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. <https://elementary.io>
 * Copyright 2021 Corentin Noël <tintou@noel.tf>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <gio/gdesktopappinfo.h>
#include <glib.h>
#include <meta/window.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <meta/meta-startup-notification.h>
#include <glib-object.h>
#include <sys/types.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_APP_0_PROPERTY,
	GALA_APP_ID_PROPERTY,
	GALA_APP_APP_INFO_PROPERTY,
	GALA_APP_ICON_PROPERTY,
	GALA_APP_NAME_PROPERTY,
	GALA_APP_DESCRIPTION_PROPERTY,
	GALA_APP_STATE_PROPERTY,
	GALA_APP_NUM_PROPERTIES
};
static GParamSpec* gala_app_properties[GALA_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaAppPrivate {
	GDesktopAppInfo* _app_info;
	GalaAppState _state;
	GSList* windows;
	guint interesting_windows;
	gchar* window_id_string;
	GIcon* fallback_icon;
	gint started_on_workspace;
};

static gint GalaApp_private_offset;
static gpointer gala_app_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void gala_app_sync_running_state (GalaApp* self);
static void gala_app_set_state (GalaApp* self,
                         GalaAppState value);
static MetaWindow* gala_app_get_backing_window (GalaApp* self);
static pid_t* _pid_t_dup (pid_t* self);
static void gala_app_finalize (GObject * obj);
static GType gala_app_get_type_once (void);
static void _vala_gala_app_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_gala_app_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
gala_app_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_APP_STATE_STOPPED, "GALA_APP_STATE_STOPPED", "stopped"}, {GALA_APP_STATE_STARTING, "GALA_APP_STATE_STARTING", "starting"}, {GALA_APP_STATE_RUNNING, "GALA_APP_STATE_RUNNING", "running"}, {0, NULL, NULL}};
	GType gala_app_state_type_id;
	gala_app_state_type_id = g_enum_register_static ("GalaAppState", values);
	return gala_app_state_type_id;
}

GType
gala_app_state_get_type (void)
{
	static gsize gala_app_state_type_id__once = 0;
	if (g_once_init_enter (&gala_app_state_type_id__once)) {
		GType gala_app_state_type_id;
		gala_app_state_type_id = gala_app_state_get_type_once ();
		g_once_init_leave (&gala_app_state_type_id__once, gala_app_state_type_id);
	}
	return gala_app_state_type_id__once;
}

static inline gpointer
gala_app_get_instance_private (GalaApp* self)
{
	return G_STRUCT_MEMBER_P (self, GalaApp_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 68 "../lib/App.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 113 "App.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 68 "../lib/App.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 121 "App.c"
}

GalaApp*
gala_app_new_from_startup_sequence (MetaStartupSequence* sequence)
{
	const gchar* app_id = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* basename = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GalaAppSystem* appsys = NULL;
	GalaAppSystem* _tmp4_;
	GalaAppSystem* _tmp5_;
	const gchar* _tmp6_;
	GalaApp* _tmp7_;
	GalaApp* result;
#line 74 "../lib/App.vala"
	g_return_val_if_fail (sequence != NULL, NULL);
#line 75 "../lib/App.vala"
	_tmp0_ = meta_startup_sequence_get_application_id (sequence);
#line 75 "../lib/App.vala"
	app_id = _tmp0_;
#line 76 "../lib/App.vala"
	_tmp1_ = app_id;
#line 76 "../lib/App.vala"
	if (_tmp1_ == NULL) {
#line 77 "../lib/App.vala"
		result = NULL;
#line 77 "../lib/App.vala"
		return result;
#line 153 "App.c"
	}
#line 80 "../lib/App.vala"
	_tmp2_ = app_id;
#line 80 "../lib/App.vala"
	_tmp3_ = g_path_get_basename (_tmp2_);
#line 80 "../lib/App.vala"
	basename = _tmp3_;
#line 81 "../lib/App.vala"
	_tmp4_ = gala_app_system_get_default ();
#line 81 "../lib/App.vala"
	appsys = _tmp4_;
#line 82 "../lib/App.vala"
	_tmp5_ = appsys;
#line 82 "../lib/App.vala"
	_tmp6_ = basename;
#line 82 "../lib/App.vala"
	_tmp7_ = gala_app_system_lookup_app (_tmp5_, _tmp6_);
#line 82 "../lib/App.vala"
	result = _tmp7_;
#line 82 "../lib/App.vala"
	_g_free0 (basename);
#line 82 "../lib/App.vala"
	return result;
#line 177 "App.c"
}

GalaApp*
gala_app_construct (GType object_type,
                    GDesktopAppInfo* info)
{
	GalaApp * self = NULL;
#line 85 "../lib/App.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 86 "../lib/App.vala"
	self = (GalaApp*) g_object_new (object_type, "app-info", info, NULL);
#line 85 "../lib/App.vala"
	return self;
#line 191 "App.c"
}

GalaApp*
gala_app_new (GDesktopAppInfo* info)
{
#line 85 "../lib/App.vala"
	return gala_app_construct (GALA_TYPE_APP, info);
#line 199 "App.c"
}

GalaApp*
gala_app_construct_for_window (GType object_type,
                               MetaWindow* window)
{
	GalaApp * self = NULL;
	gchar* _tmp0_;
#line 89 "../lib/App.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 89 "../lib/App.vala"
	self = (GalaApp*) g_object_new (object_type, NULL);
#line 90 "../lib/App.vala"
	_tmp0_ = g_strdup_printf ("window:%u", meta_window_get_stable_sequence (window));
#line 90 "../lib/App.vala"
	_g_free0 (self->priv->window_id_string);
#line 90 "../lib/App.vala"
	self->priv->window_id_string = _tmp0_;
#line 91 "../lib/App.vala"
	gala_app_add_window (self, window);
#line 89 "../lib/App.vala"
	return self;
#line 222 "App.c"
}

GalaApp*
gala_app_new_for_window (MetaWindow* window)
{
#line 89 "../lib/App.vala"
	return gala_app_construct_for_window (GALA_TYPE_APP, window);
#line 230 "App.c"
}

GSList*
gala_app_get_windows (GalaApp* self)
{
	GSList* _tmp0_;
	GSList* result;
#line 94 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../lib/App.vala"
	_tmp0_ = self->priv->windows;
#line 95 "../lib/App.vala"
	result = _tmp0_;
#line 95 "../lib/App.vala"
	return result;
#line 246 "App.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 103 "../lib/App.vala"
	return self ? g_object_ref (self) : NULL;
#line 254 "App.c"
}

void
gala_app_add_window (GalaApp* self,
                     MetaWindow* window)
{
	GSList* _tmp0_;
	GSList* _tmp1_;
	MetaWindow* _tmp2_;
#line 98 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/App.vala"
	g_return_if_fail (window != NULL);
#line 99 "../lib/App.vala"
	_tmp0_ = self->priv->windows;
#line 99 "../lib/App.vala"
	_tmp1_ = g_slist_find (_tmp0_, window);
#line 99 "../lib/App.vala"
	if (_tmp1_ != NULL) {
#line 100 "../lib/App.vala"
		return;
#line 276 "App.c"
	}
#line 103 "../lib/App.vala"
	_tmp2_ = _g_object_ref0 (window);
#line 103 "../lib/App.vala"
	self->priv->windows = g_slist_prepend (self->priv->windows, _tmp2_);
#line 104 "../lib/App.vala"
	if (!meta_window_is_skip_taskbar (window)) {
#line 284 "App.c"
		guint _tmp3_;
#line 105 "../lib/App.vala"
		_tmp3_ = self->priv->interesting_windows;
#line 105 "../lib/App.vala"
		self->priv->interesting_windows = _tmp3_ + 1;
#line 290 "App.c"
	}
#line 108 "../lib/App.vala"
	gala_app_sync_running_state (self);
#line 294 "App.c"
}

static GSList*
vala_g_slist_remove_full (GSList* self,
                          gconstpointer data,
                          GFreeFunc func)
{
	GSList* l = NULL;
	GSList* result;
#line 5327 "glib-2.0.vapi"
	l = self;
#line 5328 "glib-2.0.vapi"
	while (TRUE) {
#line 308 "App.c"
		GSList* _tmp0_;
		GSList* _tmp1_;
		gconstpointer _tmp2_;
#line 5328 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5328 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5328 "glib-2.0.vapi"
			break;
#line 318 "App.c"
		}
#line 5329 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5329 "glib-2.0.vapi"
		_tmp2_ = ((GSList*) _tmp1_)->data;
#line 5329 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 326 "App.c"
			GSList* _tmp3_;
			GSList* _tmp4_;
#line 5330 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5330 "glib-2.0.vapi"
			_tmp4_ = ((GSList*) _tmp3_)->next;
#line 5330 "glib-2.0.vapi"
			l = _tmp4_;
#line 335 "App.c"
		} else {
			GSList* _tmp5_;
			gconstpointer _tmp6_;
			GSList* _tmp7_;
#line 5332 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5332 "glib-2.0.vapi"
			_tmp6_ = ((GSList*) _tmp5_)->data;
#line 5332 "glib-2.0.vapi"
			func (_tmp6_);
#line 5333 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5333 "glib-2.0.vapi"
			self = g_slist_delete_link (self, (GSList*) _tmp7_);
#line 5334 "glib-2.0.vapi"
			break;
#line 352 "App.c"
		}
	}
#line 5337 "glib-2.0.vapi"
	result = self;
#line 5337 "glib-2.0.vapi"
	return result;
#line 359 "App.c"
}

void
gala_app_remove_window (GalaApp* self,
                        MetaWindow* window)
{
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 112 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 112 "../lib/App.vala"
	g_return_if_fail (window != NULL);
#line 113 "../lib/App.vala"
	_tmp0_ = self->priv->windows;
#line 113 "../lib/App.vala"
	_tmp1_ = g_slist_find (_tmp0_, window);
#line 113 "../lib/App.vala"
	if (_tmp1_ == NULL) {
#line 114 "../lib/App.vala"
		return;
#line 380 "App.c"
	}
#line 117 "../lib/App.vala"
	if (!meta_window_is_skip_taskbar (window)) {
#line 384 "App.c"
		guint _tmp2_;
#line 118 "../lib/App.vala"
		_tmp2_ = self->priv->interesting_windows;
#line 118 "../lib/App.vala"
		self->priv->interesting_windows = _tmp2_ - 1;
#line 390 "App.c"
	}
#line 121 "../lib/App.vala"
	self->priv->windows = vala_g_slist_remove_full (self->priv->windows, window, _g_object_unref0_);
#line 122 "../lib/App.vala"
	gala_app_sync_running_state (self);
#line 396 "App.c"
}

static void
gala_app_sync_running_state (GalaApp* self)
{
	GalaAppState _tmp0_;
#line 125 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 126 "../lib/App.vala"
	_tmp0_ = self->priv->_state;
#line 126 "../lib/App.vala"
	if (_tmp0_ != GALA_APP_STATE_STARTING) {
#line 409 "App.c"
		GalaAppSystem* app_sys = NULL;
		GalaAppSystem* _tmp1_;
#line 127 "../lib/App.vala"
		_tmp1_ = gala_app_system_get_default ();
#line 127 "../lib/App.vala"
		app_sys = _tmp1_;
#line 128 "../lib/App.vala"
		if (self->priv->interesting_windows == ((guint) 0)) {
#line 418 "App.c"
			GalaAppSystem* _tmp2_;
#line 129 "../lib/App.vala"
			gala_app_set_state (self, GALA_APP_STATE_STOPPED);
#line 130 "../lib/App.vala"
			_tmp2_ = app_sys;
#line 130 "../lib/App.vala"
			gala_app_system_notify_app_state_changed (_tmp2_, self);
#line 426 "App.c"
		} else {
			GalaAppSystem* _tmp3_;
#line 132 "../lib/App.vala"
			gala_app_set_state (self, GALA_APP_STATE_RUNNING);
#line 133 "../lib/App.vala"
			_tmp3_ = app_sys;
#line 133 "../lib/App.vala"
			gala_app_system_notify_app_state_changed (_tmp3_, self);
#line 435 "App.c"
		}
	}
}

void
gala_app_handle_startup_sequence (GalaApp* self,
                                  MetaStartupSequence* sequence)
{
	gboolean starting = FALSE;
	gboolean _tmp0_ = FALSE;
	GalaAppSystem* app_sys = NULL;
	GalaAppSystem* _tmp4_;
#line 138 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 138 "../lib/App.vala"
	g_return_if_fail (sequence != NULL);
#line 139 "../lib/App.vala"
	starting = !meta_startup_sequence_get_completed (sequence);
#line 141 "../lib/App.vala"
	if (starting) {
#line 456 "App.c"
		GalaAppState _tmp1_;
#line 141 "../lib/App.vala"
		_tmp1_ = self->priv->_state;
#line 141 "../lib/App.vala"
		_tmp0_ = _tmp1_ == GALA_APP_STATE_STOPPED;
#line 462 "App.c"
	} else {
#line 141 "../lib/App.vala"
		_tmp0_ = FALSE;
#line 466 "App.c"
	}
#line 141 "../lib/App.vala"
	if (_tmp0_) {
#line 142 "../lib/App.vala"
		gala_app_set_state (self, GALA_APP_STATE_STARTING);
#line 472 "App.c"
	}
#line 145 "../lib/App.vala"
	if (starting) {
#line 476 "App.c"
		gint _tmp2_;
		gint _tmp3_;
#line 146 "../lib/App.vala"
		_tmp2_ = meta_startup_sequence_get_workspace (sequence);
#line 146 "../lib/App.vala"
		_tmp3_ = _tmp2_;
#line 146 "../lib/App.vala"
		self->priv->started_on_workspace = _tmp3_;
#line 485 "App.c"
	} else {
#line 147 "../lib/App.vala"
		if (self->priv->interesting_windows > ((guint) 0)) {
#line 148 "../lib/App.vala"
			gala_app_set_state (self, GALA_APP_STATE_RUNNING);
#line 491 "App.c"
		} else {
#line 150 "../lib/App.vala"
			gala_app_set_state (self, GALA_APP_STATE_STOPPED);
#line 495 "App.c"
		}
	}
#line 153 "../lib/App.vala"
	_tmp4_ = gala_app_system_get_default ();
#line 153 "../lib/App.vala"
	app_sys = _tmp4_;
#line 154 "../lib/App.vala"
	gala_app_system_notify_app_state_changed (app_sys, self);
#line 504 "App.c"
}

static MetaWindow*
gala_app_get_backing_window (GalaApp* self)
{
	GDesktopAppInfo* _tmp0_;
	GSList* _tmp1_;
	gconstpointer _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* result;
#line 157 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 157 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 157 "../lib/App.vala"
	_vala_return_val_if_fail (_tmp0_ == NULL, "app_info == null", NULL);
#line 158 "../lib/App.vala"
	_tmp1_ = self->priv->windows;
#line 158 "../lib/App.vala"
	_tmp2_ = _tmp1_->data;
#line 158 "../lib/App.vala"
	_tmp3_ = _g_object_ref0 ((MetaWindow*) _tmp2_);
#line 158 "../lib/App.vala"
	result = _tmp3_;
#line 158 "../lib/App.vala"
	return result;
#line 531 "App.c"
}

static pid_t*
_pid_t_dup (pid_t* self)
{
	pid_t* dup;
#line 173 "../lib/App.vala"
	dup = g_new0 (pid_t, 1);
#line 173 "../lib/App.vala"
	memcpy (dup, self, sizeof (pid_t));
#line 173 "../lib/App.vala"
	return dup;
#line 544 "App.c"
}

static gpointer
__pid_t_dup0 (gpointer self)
{
#line 173 "../lib/App.vala"
	return self ? _pid_t_dup (self) : NULL;
#line 552 "App.c"
}

GSList*
gala_app_get_pids (GalaApp* self)
{
	GSList* results = NULL;
	GSList* _tmp0_;
	GSList* result;
#line 161 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../lib/App.vala"
	results = NULL;
#line 163 "../lib/App.vala"
	_tmp0_ = self->priv->windows;
#line 567 "App.c"
	{
		GSList* window_collection = NULL;
		GSList* window_it = NULL;
#line 163 "../lib/App.vala"
		window_collection = _tmp0_;
#line 163 "../lib/App.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 575 "App.c"
			MetaWindow* window = NULL;
#line 163 "../lib/App.vala"
			window = (MetaWindow*) window_it->data;
#line 579 "App.c"
			{
				pid_t pid = 0;
				MetaWindow* _tmp1_;
				GSList* _tmp2_;
				GSList* _tmp3_;
#line 164 "../lib/App.vala"
				_tmp1_ = window;
#line 164 "../lib/App.vala"
				pid = meta_window_get_pid (_tmp1_);
#line 165 "../lib/App.vala"
				if (pid < ((pid_t) 1)) {
#line 166 "../lib/App.vala"
					continue;
#line 593 "App.c"
				}
#line 172 "../lib/App.vala"
				_tmp2_ = results;
#line 172 "../lib/App.vala"
				_tmp3_ = g_slist_find (_tmp2_, &pid);
#line 172 "../lib/App.vala"
				if (_tmp3_ == NULL) {
#line 601 "App.c"
					pid_t* _tmp4_;
#line 173 "../lib/App.vala"
					_tmp4_ = __pid_t_dup0 (&pid);
#line 173 "../lib/App.vala"
					results = g_slist_prepend (results, _tmp4_);
#line 607 "App.c"
				}
			}
		}
	}
#line 177 "../lib/App.vala"
	result = results;
#line 177 "../lib/App.vala"
	return result;
#line 616 "App.c"
}

const gchar*
gala_app_get_id (GalaApp* self)
{
	const gchar* result;
	GDesktopAppInfo* _tmp0_;
#line 15 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 16 "../lib/App.vala"
	if (_tmp0_ != NULL) {
#line 630 "App.c"
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
#line 17 "../lib/App.vala"
		_tmp1_ = self->priv->_app_info;
#line 17 "../lib/App.vala"
		_tmp2_ = g_app_info_get_id ((GAppInfo*) _tmp1_);
#line 17 "../lib/App.vala"
		result = _tmp2_;
#line 17 "../lib/App.vala"
		return result;
#line 641 "App.c"
	} else {
		const gchar* _tmp3_;
#line 19 "../lib/App.vala"
		_tmp3_ = self->priv->window_id_string;
#line 19 "../lib/App.vala"
		result = _tmp3_;
#line 19 "../lib/App.vala"
		return result;
#line 650 "App.c"
	}
}

GDesktopAppInfo*
gala_app_get_app_info (GalaApp* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 24 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 24 "../lib/App.vala"
	result = _tmp0_;
#line 24 "../lib/App.vala"
	return result;
#line 667 "App.c"
}

static void
gala_app_set_app_info (GalaApp* self,
                       GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 24 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 24 "../lib/App.vala"
	old_value = gala_app_get_app_info (self);
#line 24 "../lib/App.vala"
	if (old_value != value) {
#line 681 "App.c"
		GDesktopAppInfo* _tmp0_;
#line 24 "../lib/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../lib/App.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 24 "../lib/App.vala"
		self->priv->_app_info = _tmp0_;
#line 24 "../lib/App.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_app_properties[GALA_APP_APP_INFO_PROPERTY]);
#line 691 "App.c"
	}
}

GIcon*
gala_app_get_icon (GalaApp* self)
{
	GIcon* result;
	GDesktopAppInfo* _tmp0_;
	GIcon* _tmp3_;
	GIcon* _tmp5_;
#line 27 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 28 "../lib/App.vala"
	if (_tmp0_ != NULL) {
#line 708 "App.c"
		GDesktopAppInfo* _tmp1_;
		GIcon* _tmp2_;
#line 29 "../lib/App.vala"
		_tmp1_ = self->priv->_app_info;
#line 29 "../lib/App.vala"
		_tmp2_ = g_app_info_get_icon ((GAppInfo*) _tmp1_);
#line 29 "../lib/App.vala"
		result = _tmp2_;
#line 29 "../lib/App.vala"
		return result;
#line 719 "App.c"
	}
#line 32 "../lib/App.vala"
	_tmp3_ = self->priv->fallback_icon;
#line 32 "../lib/App.vala"
	if (_tmp3_ == NULL) {
#line 725 "App.c"
		GThemedIcon* _tmp4_;
#line 33 "../lib/App.vala"
		_tmp4_ = (GThemedIcon*) g_themed_icon_new ("application-x-executable");
#line 33 "../lib/App.vala"
		_g_object_unref0 (self->priv->fallback_icon);
#line 33 "../lib/App.vala"
		self->priv->fallback_icon = (GIcon*) _tmp4_;
#line 733 "App.c"
	}
#line 36 "../lib/App.vala"
	_tmp5_ = self->priv->fallback_icon;
#line 36 "../lib/App.vala"
	result = _tmp5_;
#line 36 "../lib/App.vala"
	return result;
#line 741 "App.c"
}

const gchar*
gala_app_get_name (GalaApp* self)
{
	const gchar* result;
	GDesktopAppInfo* _tmp0_;
#line 41 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 42 "../lib/App.vala"
	if (_tmp0_ != NULL) {
#line 755 "App.c"
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
#line 43 "../lib/App.vala"
		_tmp1_ = self->priv->_app_info;
#line 43 "../lib/App.vala"
		_tmp2_ = g_app_info_get_name ((GAppInfo*) _tmp1_);
#line 43 "../lib/App.vala"
		result = _tmp2_;
#line 43 "../lib/App.vala"
		return result;
#line 766 "App.c"
	} else {
		const gchar* name = NULL;
		MetaWindow* window = NULL;
		MetaWindow* _tmp3_;
		MetaWindow* _tmp4_;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_;
#line 45 "../lib/App.vala"
		name = NULL;
#line 46 "../lib/App.vala"
		_tmp3_ = gala_app_get_backing_window (self);
#line 46 "../lib/App.vala"
		window = _tmp3_;
#line 47 "../lib/App.vala"
		_tmp4_ = window;
#line 47 "../lib/App.vala"
		if (_tmp4_ != NULL) {
#line 784 "App.c"
			MetaWindow* _tmp5_;
			const gchar* _tmp6_;
#line 48 "../lib/App.vala"
			_tmp5_ = window;
#line 48 "../lib/App.vala"
			_tmp6_ = meta_window_get_wm_class (_tmp5_);
#line 48 "../lib/App.vala"
			name = _tmp6_;
#line 793 "App.c"
		}
#line 51 "../lib/App.vala"
		_tmp8_ = name;
#line 51 "../lib/App.vala"
		_tmp7_ = _tmp8_;
#line 51 "../lib/App.vala"
		if (_tmp7_ == NULL) {
#line 51 "../lib/App.vala"
			_tmp7_ = C_ ("program", "Unknown");
#line 803 "App.c"
		}
#line 51 "../lib/App.vala"
		result = _tmp7_;
#line 51 "../lib/App.vala"
		_g_object_unref0 (window);
#line 51 "../lib/App.vala"
		return result;
#line 811 "App.c"
	}
}

const gchar*
gala_app_get_description (GalaApp* self)
{
	const gchar* result;
	GDesktopAppInfo* _tmp0_;
#line 57 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../lib/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 58 "../lib/App.vala"
	if (_tmp0_ != NULL) {
#line 826 "App.c"
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
#line 59 "../lib/App.vala"
		_tmp1_ = self->priv->_app_info;
#line 59 "../lib/App.vala"
		_tmp2_ = g_app_info_get_description ((GAppInfo*) _tmp1_);
#line 59 "../lib/App.vala"
		result = _tmp2_;
#line 59 "../lib/App.vala"
		return result;
#line 837 "App.c"
	}
#line 62 "../lib/App.vala"
	result = NULL;
#line 62 "../lib/App.vala"
	return result;
#line 843 "App.c"
}

GalaAppState
gala_app_get_state (GalaApp* self)
{
	GalaAppState result;
#line 66 "../lib/App.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../lib/App.vala"
	result = self->priv->_state;
#line 66 "../lib/App.vala"
	return result;
#line 856 "App.c"
}

static void
gala_app_set_state (GalaApp* self,
                    GalaAppState value)
{
	GalaAppState old_value;
#line 66 "../lib/App.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/App.vala"
	old_value = gala_app_get_state (self);
#line 66 "../lib/App.vala"
	if (old_value != value) {
#line 66 "../lib/App.vala"
		self->priv->_state = value;
#line 66 "../lib/App.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_app_properties[GALA_APP_STATE_PROPERTY]);
#line 874 "App.c"
	}
}

static void
gala_app_class_init (GalaAppClass * klass,
                     gpointer klass_data)
{
#line 13 "../lib/App.vala"
	gala_app_parent_class = g_type_class_peek_parent (klass);
#line 13 "../lib/App.vala"
	g_type_class_adjust_private_offset (klass, &GalaApp_private_offset);
#line 13 "../lib/App.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_app_get_property;
#line 13 "../lib/App.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_app_set_property;
#line 13 "../lib/App.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_app_finalize;
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_ID_PROPERTY, gala_app_properties[GALA_APP_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_APP_INFO_PROPERTY, gala_app_properties[GALA_APP_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_ICON_PROPERTY, gala_app_properties[GALA_APP_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_NAME_PROPERTY, gala_app_properties[GALA_APP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_DESCRIPTION_PROPERTY, gala_app_properties[GALA_APP_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../lib/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_APP_STATE_PROPERTY, gala_app_properties[GALA_APP_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", GALA_TYPE_APP_STATE, GALA_APP_STATE_STOPPED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 904 "App.c"
}

static void
gala_app_instance_init (GalaApp * self,
                        gpointer klass)
{
#line 13 "../lib/App.vala"
	self->priv = gala_app_get_instance_private (self);
#line 66 "../lib/App.vala"
	self->priv->_state = GALA_APP_STATE_STOPPED;
#line 68 "../lib/App.vala"
	self->priv->windows = NULL;
#line 69 "../lib/App.vala"
	self->priv->interesting_windows = (guint) 0;
#line 70 "../lib/App.vala"
	self->priv->window_id_string = NULL;
#line 71 "../lib/App.vala"
	self->priv->fallback_icon = NULL;
#line 923 "App.c"
}

static void
gala_app_finalize (GObject * obj)
{
	GalaApp * self;
#line 13 "../lib/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_APP, GalaApp);
#line 24 "../lib/App.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 68 "../lib/App.vala"
	(self->priv->windows == NULL) ? NULL : (self->priv->windows = (_g_slist_free__g_object_unref0_ (self->priv->windows), NULL));
#line 70 "../lib/App.vala"
	_g_free0 (self->priv->window_id_string);
#line 71 "../lib/App.vala"
	_g_object_unref0 (self->priv->fallback_icon);
#line 13 "../lib/App.vala"
	G_OBJECT_CLASS (gala_app_parent_class)->finalize (obj);
#line 942 "App.c"
}

 G_GNUC_NO_INLINE static GType
gala_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaApp), 0, (GInstanceInitFunc) gala_app_instance_init, NULL };
	GType gala_app_type_id;
	gala_app_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaApp", &g_define_type_info, 0);
	GalaApp_private_offset = g_type_add_instance_private (gala_app_type_id, sizeof (GalaAppPrivate));
	return gala_app_type_id;
}

GType
gala_app_get_type (void)
{
	static gsize gala_app_type_id__once = 0;
	if (g_once_init_enter (&gala_app_type_id__once)) {
		GType gala_app_type_id;
		gala_app_type_id = gala_app_get_type_once ();
		g_once_init_leave (&gala_app_type_id__once, gala_app_type_id);
	}
	return gala_app_type_id__once;
}

static void
_vala_gala_app_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	GalaApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_APP, GalaApp);
#line 13 "../lib/App.vala"
	switch (property_id) {
#line 13 "../lib/App.vala"
		case GALA_APP_ID_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_string (value, gala_app_get_id (self));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_APP_INFO_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_object (value, gala_app_get_app_info (self));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_ICON_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_object (value, gala_app_get_icon (self));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_NAME_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_string (value, gala_app_get_name (self));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_DESCRIPTION_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_string (value, gala_app_get_description (self));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_STATE_PROPERTY:
#line 13 "../lib/App.vala"
		g_value_set_enum (value, gala_app_get_state (self));
#line 13 "../lib/App.vala"
		break;
#line 1013 "App.c"
		default:
#line 13 "../lib/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../lib/App.vala"
		break;
#line 1019 "App.c"
	}
}

static void
_vala_gala_app_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	GalaApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_APP, GalaApp);
#line 13 "../lib/App.vala"
	switch (property_id) {
#line 13 "../lib/App.vala"
		case GALA_APP_APP_INFO_PROPERTY:
#line 13 "../lib/App.vala"
		gala_app_set_app_info (self, g_value_get_object (value));
#line 13 "../lib/App.vala"
		break;
#line 13 "../lib/App.vala"
		case GALA_APP_STATE_PROPERTY:
#line 13 "../lib/App.vala"
		gala_app_set_state (self, g_value_get_enum (value));
#line 13 "../lib/App.vala"
		break;
#line 1045 "App.c"
		default:
#line 13 "../lib/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../lib/App.vala"
		break;
#line 1051 "App.c"
	}
}

