/* PopupWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PopupWindow.vala, do not modify */

/*
 * Copyright 2017 Adam Bieńkowski
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala-pip.h"
#include <glib.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <clutter/clutter.h>
#include "gala.h"
#include <float.h>
#include <math.h>
#include <meta/window.h>
#include <glib-object.h>
#include <graphene-gobject.h>
#include <meta/common.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <mtk/mtk.h>

#define GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT ((guint) 200)
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE 0.1f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE 1.0f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN 0
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT 0.5f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS 80
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_0_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS
};
static guint gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS] = {0};

struct _GalaPluginsPIPPopupWindowPrivate {
	gint button_size;
	gint container_margin;
	MetaDisplay* _display;
	MetaWindowActor* _window_actor;
	ClutterClone* clone;
	ClutterActor* clone_container;
	ClutterActor* container;
	GalaCloseButton* close_button;
	ClutterActor* resize_button;
	GalaDragDropAction* move_action;
	gfloat begin_resize_width;
	gfloat begin_resize_height;
	gfloat resize_start_x;
	gfloat resize_start_y;
	gboolean resizing;
	gboolean off_screen;
	ClutterGrab* grab;
};

struct _Block4Data {
	int _ref_count_;
	GalaPluginsPIPPopupWindow* self;
	gulong completed_id;
};

static gint GalaPluginsPIPPopupWindow_private_offset;
static gpointer gala_plugins_pip_popup_window_parent_class = NULL;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus = NULL;

static void gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                                    gfloat src_height,
                                                                    gfloat max_width,
                                                                    gfloat max_height,
                                                                    gfloat* width,
                                                                    gfloat* height);
static gboolean gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window);
static void gala_plugins_pip_popup_window_real_show (ClutterActor* base);
static void gala_plugins_pip_popup_window_real_hide (ClutterActor* base);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda4_ (Block4Data* _data4_);
static void ____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                       gpointer self);
static gboolean gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                         ClutterEvent* event);
static void gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self);
static ClutterActor* gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                               ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                                        ClutterEvent* event);
static gboolean _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                             ClutterEvent* event,
                                                                             gpointer self);
static void gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self);
static gboolean __lambda5_ (GalaPluginsPIPPopupWindow* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                           gfloat* width,
                                                           gfloat* height);
static void gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                                  gfloat coord,
                                                                  ClutterOrientation axis);
static void gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self);
static GObject * gala_plugins_pip_popup_window_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static ClutterActor* _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                                             gfloat x,
                                                                                             gfloat y,
                                                                                             gpointer self);
static void _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                     gpointer self);
static void _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                                  guint32 button,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                        guint32 timestamp,
                                                                                        gpointer self);
static gboolean _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                                 ClutterEvent* event,
                                                                                                 gpointer self);
static void _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                         gpointer self);
static void gala_plugins_pip_popup_window_finalize (GObject * obj);
static GType gala_plugins_pip_popup_window_get_type_once (void);
static void _vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
gala_plugins_pip_popup_window_get_instance_private (GalaPluginsPIPPopupWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginsPIPPopupWindow_private_offset);
}

static void
gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                               gfloat src_height,
                                                               gfloat max_width,
                                                               gfloat max_height,
                                                               gfloat* width,
                                                               gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	gfloat ratio = 0.0F;
#line 43 "../plugins/pip/PopupWindow.vala"
	ratio = MIN (max_width / src_width, max_height / src_height);
#line 44 "../plugins/pip/PopupWindow.vala"
	_vala_width = src_width * ratio;
#line 45 "../plugins/pip/PopupWindow.vala"
	_vala_height = src_height * ratio;
#line 41 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 201 "PopupWindow.c"
	}
#line 41 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 207 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window)
{
	MetaWindowType window_type = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 48 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 49 "../plugins/pip/PopupWindow.vala"
	window_type = meta_window_get_window_type (window);
#line 50 "../plugins/pip/PopupWindow.vala"
	if (window_type == META_WINDOW_NORMAL) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = TRUE;
#line 226 "PopupWindow.c"
	} else {
#line 51 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = window_type == META_WINDOW_DIALOG;
#line 230 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	if (_tmp1_) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 236 "PopupWindow.c"
	} else {
#line 52 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = window_type == META_WINDOW_MODAL_DIALOG;
#line 240 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 50 "../plugins/pip/PopupWindow.vala"
	return result;
#line 246 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_construct (GType object_type,
                                         MetaDisplay* display,
                                         MetaWindowActor* window_actor)
{
	GalaPluginsPIPPopupWindow * self = NULL;
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window_actor != NULL, NULL);
#line 56 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) g_object_new (object_type, "display", display, "window-actor", window_actor, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	return self;
#line 263 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_new (MetaDisplay* display,
                                   MetaWindowActor* window_actor)
{
#line 55 "../plugins/pip/PopupWindow.vala"
	return gala_plugins_pip_popup_window_construct (GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, display, window_actor);
#line 272 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_show (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
#line 134 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 135 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 137 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 139 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 140 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, animations_settings_get_animation_duration ((guint) 200));
#line 141 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 142 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 293 "PopupWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 154 "../plugins/pip/PopupWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 154 "../plugins/pip/PopupWindow.vala"
	return _data4_;
#line 303 "PopupWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 154 "../plugins/pip/PopupWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 313 "PopupWindow.c"
		GalaPluginsPIPPopupWindow* self;
#line 154 "../plugins/pip/PopupWindow.vala"
		self = _data4_->self;
#line 154 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self);
#line 154 "../plugins/pip/PopupWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 321 "PopupWindow.c"
	}
}

static void
___lambda4_ (Block4Data* _data4_)
{
	GalaPluginsPIPPopupWindow* self;
#line 158 "../plugins/pip/PopupWindow.vala"
	self = _data4_->self;
#line 159 "../plugins/pip/PopupWindow.vala"
	g_signal_handler_disconnect ((GObject*) self, _data4_->completed_id);
#line 160 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 335 "PopupWindow.c"
}

static void
____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                  gpointer self)
{
#line 158 "../plugins/pip/PopupWindow.vala"
	___lambda4_ (self);
#line 344 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_hide (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
#line 145 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 146 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 148 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 200);
#line 149 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 150 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 151 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 152 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 154 "../plugins/pip/PopupWindow.vala"
	if (duration == ((guint) 0)) {
#line 155 "../plugins/pip/PopupWindow.vala"
		CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 370 "PopupWindow.c"
	} else {
		Block4Data* _data4_;
		gulong _tmp0_;
#line 154 "../plugins/pip/PopupWindow.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 154 "../plugins/pip/PopupWindow.vala"
		_data4_->_ref_count_ = 1;
#line 154 "../plugins/pip/PopupWindow.vala"
		_data4_->self = g_object_ref (self);
#line 157 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = (gulong) 0;
#line 158 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = g_signal_connect_data ((ClutterActor*) self, "transitions-completed", (GCallback) ____lambda4__clutter_actor_transitions_completed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 158 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = _tmp0_;
#line 154 "../plugins/pip/PopupWindow.vala"
		block4_data_unref (_data4_);
#line 154 "../plugins/pip/PopupWindow.vala"
		_data4_ = NULL;
#line 390 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
	GalaCloseButton* _tmp0_;
	GalaCloseButton* _tmp1_;
	GalaCloseButton* _tmp2_;
	GalaCloseButton* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	gboolean result;
#line 166 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 166 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 170 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 172 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->close_button;
#line 172 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp0_);
#line 173 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->close_button;
#line 173 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp1_, duration);
#line 174 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->close_button;
#line 174 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp2_, (guint) 255);
#line 175 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = self->priv->close_button;
#line 175 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp3_);
#line 177 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->resize_button;
#line 177 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp4_);
#line 178 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->resize_button;
#line 178 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp5_, duration);
#line 179 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->resize_button;
#line 179 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp6_, (guint) 255);
#line 180 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 180 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp7_);
#line 182 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 182 "../plugins/pip/PopupWindow.vala"
	return result;
#line 451 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
	GalaCloseButton* _tmp0_;
	GalaCloseButton* _tmp1_;
	GalaCloseButton* _tmp2_;
	GalaCloseButton* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	gboolean result;
#line 186 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 186 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 190 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 192 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->close_button;
#line 192 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp0_);
#line 193 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->close_button;
#line 193 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp1_, duration);
#line 194 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->close_button;
#line 194 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp2_, (guint) 0);
#line 195 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = self->priv->close_button;
#line 195 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp3_);
#line 197 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->resize_button;
#line 197 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp4_);
#line 198 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->resize_button;
#line 198 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp5_, duration);
#line 199 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->resize_button;
#line 199 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp6_, (guint) 0);
#line 200 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 200 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp7_);
#line 202 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 202 "../plugins/pip/PopupWindow.vala"
	return result;
#line 511 "PopupWindow.c"
}

void
gala_plugins_pip_popup_window_set_container_clip (GalaPluginsPIPPopupWindow* self,
                                                  graphene_rect_t* container_clip)
{
	ClutterActor* _tmp0_;
	graphene_rect_t _tmp1_;
#line 205 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 206 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 206 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = *container_clip;
#line 206 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp0_, "clip-rect", &_tmp1_, NULL);
#line 207 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 208 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed (self);
#line 532 "PopupWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 214 "../plugins/pip/PopupWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 540 "PopupWindow.c"
}

static ClutterActor*
gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* result;
#line 211 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 212 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp0_, META_CURSOR_DND_IN_DRAG);
#line 214 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = _g_object_ref0 ((ClutterActor*) self);
#line 214 "../plugins/pip/PopupWindow.vala"
	result = _tmp1_;
#line 214 "../plugins/pip/PopupWindow.vala"
	return result;
#line 561 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* _tmp0_;
#line 217 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 218 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 219 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 220 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 220 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp0_, META_CURSOR_DEFAULT);
#line 578 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                    ClutterEvent* event,
                                                                    gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_event ((GalaPluginsPIPPopupWindow*) self, event);
#line 240 "../plugins/pip/PopupWindow.vala"
	return result;
#line 590 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                      ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	ClutterActor* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterActor* _tmp11_;
	MetaDisplay* _tmp12_;
	gboolean result;
#line 224 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 228 "../plugins/pip/PopupWindow.vala"
	if (self->priv->resizing) {
#line 228 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 619 "PopupWindow.c"
	} else {
#line 228 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = clutter_event_get_button (event) != CLUTTER_BUTTON_PRIMARY;
#line 623 "PopupWindow.c"
	}
#line 228 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_) {
#line 229 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 229 "../plugins/pip/PopupWindow.vala"
		return result;
#line 631 "PopupWindow.c"
	}
#line 232 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = TRUE;
#line 234 "../plugins/pip/PopupWindow.vala"
	clutter_event_get_coords (event, &_tmp1_, &_tmp2_);
#line 234 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = _tmp1_;
#line 234 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = _tmp2_;
#line 236 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = clutter_actor_get_width ((ClutterActor*) self);
#line 236 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = _tmp3_;
#line 236 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = _tmp4_;
#line 237 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_height ((ClutterActor*) self);
#line 237 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 237 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = _tmp6_;
#line 239 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 239 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = clutter_actor_get_stage (_tmp7_);
#line 239 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 239 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = clutter_stage_grab (_tmp8_, _tmp9_);
#line 239 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 239 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = _tmp10_;
#line 240 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 240 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp11_, "event", (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self, 0);
#line 242 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->_display;
#line 242 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp12_, META_CURSOR_SE_RESIZE);
#line 244 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 244 "../plugins/pip/PopupWindow.vala"
	return result;
#line 677 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                               ClutterEvent* event)
{
	gboolean result;
#line 247 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 248 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 249 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 249 "../plugins/pip/PopupWindow.vala"
		return result;
#line 695 "PopupWindow.c"
	}
#line 252 "../plugins/pip/PopupWindow.vala"
	switch (clutter_event_type (event)) {
#line 252 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_MOTION:
#line 701 "PopupWindow.c"
		{
			ClutterModifierType mods = 0U;
			gfloat event_x = 0.0F;
			gfloat event_y = 0.0F;
			gfloat _tmp0_ = 0.0F;
			gfloat _tmp1_ = 0.0F;
			gfloat diff_x = 0.0F;
			gfloat diff_y = 0.0F;
#line 254 "../plugins/pip/PopupWindow.vala"
			mods = clutter_event_get_state (event);
#line 255 "../plugins/pip/PopupWindow.vala"
			if (!((mods & CLUTTER_BUTTON1_MASK) == CLUTTER_BUTTON1_MASK)) {
#line 256 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 257 "../plugins/pip/PopupWindow.vala"
				break;
#line 718 "PopupWindow.c"
			}
#line 261 "../plugins/pip/PopupWindow.vala"
			clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 261 "../plugins/pip/PopupWindow.vala"
			event_x = _tmp0_;
#line 261 "../plugins/pip/PopupWindow.vala"
			event_y = _tmp1_;
#line 262 "../plugins/pip/PopupWindow.vala"
			diff_x = event_x - self->priv->resize_start_x;
#line 263 "../plugins/pip/PopupWindow.vala"
			diff_y = event_y - self->priv->resize_start_y;
#line 265 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_width ((ClutterActor*) self, self->priv->begin_resize_width + diff_x);
#line 266 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_height ((ClutterActor*) self, self->priv->begin_resize_height + diff_y);
#line 268 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 269 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_size (self);
#line 271 "../plugins/pip/PopupWindow.vala"
			break;
#line 740 "PopupWindow.c"
		}
#line 252 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 744 "PopupWindow.c"
		{
#line 273 "../plugins/pip/PopupWindow.vala"
			if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 274 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 750 "PopupWindow.c"
			}
#line 277 "../plugins/pip/PopupWindow.vala"
			break;
#line 754 "PopupWindow.c"
		}
#line 252 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_LEAVE:
#line 252 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_ENTER:
#line 760 "PopupWindow.c"
		{
#line 280 "../plugins/pip/PopupWindow.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 280 "../plugins/pip/PopupWindow.vala"
			return result;
#line 766 "PopupWindow.c"
		}
		default:
		{
#line 282 "../plugins/pip/PopupWindow.vala"
			break;
#line 772 "PopupWindow.c"
		}
	}
#line 285 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_STOP;
#line 285 "../plugins/pip/PopupWindow.vala"
	return result;
#line 779 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self)
{
	ClutterGrab* _tmp0_;
	MetaDisplay* _tmp4_;
#line 288 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 289 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 290 "../plugins/pip/PopupWindow.vala"
		return;
#line 793 "PopupWindow.c"
	}
#line 293 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->grab;
#line 293 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_ != NULL) {
#line 799 "PopupWindow.c"
		ClutterGrab* _tmp1_;
		ClutterActor* _tmp2_;
		guint _tmp3_;
#line 294 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = self->priv->grab;
#line 294 "../plugins/pip/PopupWindow.vala"
		clutter_grab_dismiss (_tmp1_);
#line 295 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = self->priv->resize_button;
#line 295 "../plugins/pip/PopupWindow.vala"
		g_signal_parse_name ("event", clutter_actor_get_type (), &_tmp3_, NULL, FALSE);
#line 295 "../plugins/pip/PopupWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self);
#line 296 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->grab);
#line 296 "../plugins/pip/PopupWindow.vala"
		self->priv->grab = NULL;
#line 817 "PopupWindow.c"
	}
#line 299 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 301 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 303 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_display;
#line 303 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp4_, META_CURSOR_DEFAULT);
#line 827 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self)
{
#line 306 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 307 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 308 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 839 "PopupWindow.c"
}

static gboolean
__lambda5_ (GalaPluginsPIPPopupWindow* self)
{
	gboolean result;
#line 320 "../plugins/pip/PopupWindow.vala"
	g_signal_emit (self, gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL], 0);
#line 321 "../plugins/pip/PopupWindow.vala"
	result = G_SOURCE_REMOVE;
#line 321 "../plugins/pip/PopupWindow.vala"
	return result;
#line 852 "PopupWindow.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((GalaPluginsPIPPopupWindow*) self);
#line 319 "../plugins/pip/PopupWindow.vala"
	return result;
#line 862 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self)
{
	guint duration = 0U;
#line 311 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 312 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration (GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT);
#line 314 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 315 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 316 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 317 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 319 "../plugins/pip/PopupWindow.vala"
	clutter_threads_add_timeout (duration, ___lambda5__gsource_func, self);
#line 883 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self)
{
	MetaWindow* focus_window = NULL;
	MetaDisplay* _tmp0_;
	MetaWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindow* _tmp4_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp10_;
	MetaWorkspaceManager* _tmp11_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp12_;
	MetaWorkspace* _tmp13_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp14_;
	MetaWindow* _tmp15_;
	gboolean _tmp16_ = FALSE;
	MetaWindow* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	MetaWindow* _tmp23_;
#line 325 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 326 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 326 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_display_get_focus_window (_tmp0_);
#line 326 "../plugins/pip/PopupWindow.vala"
	focus_window = _tmp1_;
#line 327 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = focus_window;
#line 327 "../plugins/pip/PopupWindow.vala"
	if (_tmp4_ != NULL) {
#line 921 "PopupWindow.c"
		MetaWindow* _tmp5_;
#line 327 "../plugins/pip/PopupWindow.vala"
		_tmp5_ = focus_window;
#line 327 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp5_);
#line 927 "PopupWindow.c"
	} else {
#line 327 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = FALSE;
#line 931 "PopupWindow.c"
	}
#line 327 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 327 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = TRUE;
#line 937 "PopupWindow.c"
	} else {
		gboolean _tmp6_ = FALSE;
		MetaWindow* _tmp7_;
#line 328 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = gala_plugins_pip_popup_window_previous_focus;
#line 328 "../plugins/pip/PopupWindow.vala"
		if (_tmp7_ != NULL) {
#line 945 "PopupWindow.c"
			MetaWindow* _tmp8_;
#line 328 "../plugins/pip/PopupWindow.vala"
			_tmp8_ = gala_plugins_pip_popup_window_previous_focus;
#line 328 "../plugins/pip/PopupWindow.vala"
			_tmp6_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp8_);
#line 951 "PopupWindow.c"
		} else {
#line 328 "../plugins/pip/PopupWindow.vala"
			_tmp6_ = FALSE;
#line 955 "PopupWindow.c"
		}
#line 328 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _tmp6_;
#line 959 "PopupWindow.c"
	}
#line 327 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 963 "PopupWindow.c"
		MetaWindow* _tmp9_;
#line 329 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = focus_window;
#line 329 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_previous_focus = _tmp9_;
#line 330 "../plugins/pip/PopupWindow.vala"
		return;
#line 971 "PopupWindow.c"
	}
#line 333 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->_display;
#line 333 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = meta_display_get_workspace_manager (_tmp10_);
#line 333 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp11_;
#line 334 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = workspace_manager;
#line 334 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 334 "../plugins/pip/PopupWindow.vala"
	active_workspace = _tmp13_;
#line 335 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->_window_actor;
#line 335 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = meta_window_actor_get_meta_window (_tmp14_);
#line 335 "../plugins/pip/PopupWindow.vala"
	window = _tmp15_;
#line 337 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = window;
#line 337 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp17_, "appears-focused", &_tmp18_, NULL);
#line 337 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = _tmp18_;
#line 337 "../plugins/pip/PopupWindow.vala"
	if (_tmp19_) {
#line 999 "PopupWindow.c"
		MetaWindow* _tmp20_;
		MetaWorkspace* _tmp21_;
#line 337 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = window;
#line 337 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = active_workspace;
#line 337 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = meta_window_located_on_workspace (_tmp20_, _tmp21_);
#line 1008 "PopupWindow.c"
	} else {
#line 337 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = FALSE;
#line 1012 "PopupWindow.c"
	}
#line 337 "../plugins/pip/PopupWindow.vala"
	if (_tmp16_) {
#line 338 "../plugins/pip/PopupWindow.vala"
		clutter_actor_hide ((ClutterActor*) self);
#line 1018 "PopupWindow.c"
	} else {
		MetaWindowActor* _tmp22_;
#line 339 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = self->priv->_window_actor;
#line 339 "../plugins/pip/PopupWindow.vala"
		if (!meta_window_actor_is_destroyed (_tmp22_)) {
#line 340 "../plugins/pip/PopupWindow.vala"
			clutter_actor_show ((ClutterActor*) self);
#line 1027 "PopupWindow.c"
		}
	}
#line 343 "../plugins/pip/PopupWindow.vala"
	_tmp23_ = focus_window;
#line 343 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_previous_focus = _tmp23_;
#line 1034 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self)
{
	gint clone_container_width = 0;
	gint clone_container_height = 0;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClutterActor* _tmp24_;
	ClutterActor* _tmp25_;
#line 346 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 349 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 349 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 349 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 349 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1057 "PopupWindow.c"
		gfloat src_width = 0.0F;
		gfloat src_height = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		ClutterActor* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 350 "../plugins/pip/PopupWindow.vala"
		src_width = 0.0f;
#line 350 "../plugins/pip/PopupWindow.vala"
		src_height = 0.0f;
#line 351 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 351 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 351 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 351 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 352 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 352 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp6_, "scale-x", &_tmp7_, NULL);
#line 352 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 352 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (src_width * _tmp8_);
#line 353 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 353 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp9_, "scale-y", &_tmp10_, NULL);
#line 353 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 353 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (src_height * _tmp11_);
#line 1097 "PopupWindow.c"
	} else {
		ClutterActor* _tmp12_;
		gfloat _tmp13_;
		gfloat _tmp14_;
		ClutterActor* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ClutterActor* _tmp18_;
		gfloat _tmp19_;
		gfloat _tmp20_;
		ClutterActor* _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = self->priv->clone_container;
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = clutter_actor_get_width (_tmp12_);
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = _tmp13_;
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = self->priv->clone_container;
#line 355 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp15_, "scale-x", &_tmp16_, NULL);
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 355 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (_tmp14_ * _tmp17_);
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = self->priv->clone_container;
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp19_ = clutter_actor_get_height (_tmp18_);
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = _tmp19_;
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = self->priv->clone_container;
#line 356 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp21_, "scale-y", &_tmp22_, NULL);
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = _tmp22_;
#line 356 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (_tmp20_ * _tmp23_);
#line 1139 "PopupWindow.c"
	}
#line 359 "../plugins/pip/PopupWindow.vala"
	_tmp24_ = self->priv->container;
#line 359 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width (_tmp24_, (gfloat) clone_container_width);
#line 360 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = self->priv->container;
#line 360 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height (_tmp25_, (gfloat) clone_container_height);
#line 362 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) (clone_container_width + self->priv->button_size));
#line 363 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) (clone_container_height + self->priv->button_size));
#line 1153 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle rect = {0};
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle _tmp2_ = {0};
	gfloat x_offset = 0.0F;
	MtkRectangle _tmp3_;
	MetaWindowActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat y_offset = 0.0F;
	MtkRectangle _tmp7_;
	MetaWindowActor* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	ClutterClone* _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	ClutterClone* _tmp14_;
	ClutterActor* _tmp15_;
	MtkRectangle _tmp16_;
	MtkRectangle _tmp17_;
#line 369 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 370 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 370 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 370 "../plugins/pip/PopupWindow.vala"
	meta_window_get_frame_rect (_tmp1_, &_tmp2_);
#line 370 "../plugins/pip/PopupWindow.vala"
	rect = _tmp2_;
#line 372 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = rect;
#line 372 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 372 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_x ((ClutterActor*) _tmp4_);
#line 372 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 372 "../plugins/pip/PopupWindow.vala"
	x_offset = _tmp3_.x - _tmp6_;
#line 373 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = rect;
#line 373 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->_window_actor;
#line 373 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_y ((ClutterActor*) _tmp8_);
#line 373 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 373 "../plugins/pip/PopupWindow.vala"
	y_offset = _tmp7_.y - _tmp10_;
#line 374 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->clone;
#line 374 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = rect;
#line 374 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = rect;
#line 374 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_clip ((ClutterActor*) _tmp11_, x_offset, y_offset, (gfloat) _tmp12_.width, (gfloat) _tmp13_.height);
#line 375 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->clone;
#line 375 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) _tmp14_, -x_offset, -y_offset);
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->clone_container;
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = rect;
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = rect;
#line 377 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_size (_tmp15_, (gfloat) _tmp16_.width, (gfloat) _tmp17_.height);
#line 1230 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self)
{
	gfloat src_width = 0.0F;
	gfloat src_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gfloat max_width = 0.0F;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat max_height = 0.0F;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat new_width = 0.0F;
	gfloat new_height = 0.0F;
	gfloat _tmp16_ = 0.0F;
	gfloat _tmp17_ = 0.0F;
	gfloat window_width = 0.0F;
	gfloat window_height = 0.0F;
	gfloat _tmp18_ = 0.0F;
	gfloat _tmp19_ = 0.0F;
	gfloat new_scale_x = 0.0F;
	gfloat new_scale_y = 0.0F;
	ClutterActor* _tmp20_;
	ClutterActor* _tmp21_;
#line 380 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 381 "../plugins/pip/PopupWindow.vala"
	src_width = 1.0f;
#line 381 "../plugins/pip/PopupWindow.vala"
	src_height = 1.0f;
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 382 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 382 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1273 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 383 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 383 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 383 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 383 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 1285 "PopupWindow.c"
	} else {
		ClutterActor* _tmp6_;
		gfloat _tmp7_;
		gfloat _tmp8_;
		ClutterActor* _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_;
#line 385 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 385 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 385 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 385 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp8_;
#line 386 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 386 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 386 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 386 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp11_;
#line 1309 "PopupWindow.c"
	}
#line 389 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) self);
#line 389 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = _tmp12_;
#line 389 "../plugins/pip/PopupWindow.vala"
	max_width = _tmp13_ - self->priv->button_size;
#line 390 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = clutter_actor_get_height ((ClutterActor*) self);
#line 390 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = _tmp14_;
#line 390 "../plugins/pip/PopupWindow.vala"
	max_height = _tmp15_ - self->priv->button_size;
#line 393 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (src_width, src_height, max_width, max_height, &_tmp16_, &_tmp17_);
#line 393 "../plugins/pip/PopupWindow.vala"
	new_width = _tmp16_;
#line 393 "../plugins/pip/PopupWindow.vala"
	new_height = _tmp17_;
#line 399 "../plugins/pip/PopupWindow.vala"
	window_width = 1.0f;
#line 399 "../plugins/pip/PopupWindow.vala"
	window_height = 1.0f;
#line 400 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_target_window_size (self, &_tmp18_, &_tmp19_);
#line 400 "../plugins/pip/PopupWindow.vala"
	window_width = _tmp18_;
#line 400 "../plugins/pip/PopupWindow.vala"
	window_height = _tmp19_;
#line 402 "../plugins/pip/PopupWindow.vala"
	new_scale_x = new_width / window_width;
#line 403 "../plugins/pip/PopupWindow.vala"
	new_scale_y = new_height / window_height;
#line 405 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = self->priv->clone_container;
#line 405 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp20_, "scale-x", (gdouble) CLAMP (new_scale_x, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 406 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = self->priv->clone_container;
#line 406 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp21_, "scale-y", (gdouble) CLAMP (new_scale_y, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 408 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_position (self);
#line 1353 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 411 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 412 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 412 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 412 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 412 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1372 "PopupWindow.c"
		gfloat clip_x = 0.0F;
		gfloat clip_y = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		ClutterActor* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 413 "../plugins/pip/PopupWindow.vala"
		clip_x = 0.0f;
#line 413 "../plugins/pip/PopupWindow.vala"
		clip_y = 0.0f;
#line 414 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 414 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, &_tmp4_, &_tmp5_, NULL, NULL);
#line 414 "../plugins/pip/PopupWindow.vala"
		clip_x = _tmp4_;
#line 414 "../plugins/pip/PopupWindow.vala"
		clip_y = _tmp5_;
#line 415 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 415 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = self->priv->clone_container;
#line 415 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp7_, "scale-x", &_tmp8_, NULL);
#line 415 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = _tmp8_;
#line 415 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x (_tmp6_, (gfloat) ((-clip_x) * _tmp9_));
#line 416 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = self->priv->clone_container;
#line 416 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = self->priv->clone_container;
#line 416 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp11_, "scale-y", &_tmp12_, NULL);
#line 416 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = _tmp12_;
#line 416 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y (_tmp10_, (gfloat) ((-clip_y) * _tmp13_));
#line 1418 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self)
{
#line 420 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 421 "../plugins/pip/PopupWindow.vala"
	if (!gala_plugins_pip_popup_window_place_window_off_screen (self)) {
#line 422 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 1431 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle workarea_rect = {0};
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* _tmp2_;
	MtkRectangle _tmp3_ = {0};
	gint screen_limit_start_x = 0;
	MtkRectangle _tmp4_;
	gfloat screen_limit_end_x = 0.0F;
	MtkRectangle _tmp5_;
	MtkRectangle _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gint screen_limit_start_y = 0;
	MtkRectangle _tmp9_;
	gfloat screen_limit_end_y = 0.0F;
	MtkRectangle _tmp10_;
	MtkRectangle _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	guint duration = 0U;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
#line 426 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 427 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 429 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 429 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_display_get_workspace_manager (_tmp0_);
#line 429 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = meta_workspace_manager_get_active_workspace (_tmp1_);
#line 429 "../plugins/pip/PopupWindow.vala"
	meta_workspace_get_work_area_all_monitors (_tmp2_, &_tmp3_);
#line 429 "../plugins/pip/PopupWindow.vala"
	workarea_rect = _tmp3_;
#line 431 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = workarea_rect;
#line 431 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_x = _tmp4_.x + GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN;
#line 432 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = workarea_rect;
#line 432 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = workarea_rect;
#line 432 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_width ((ClutterActor*) self);
#line 432 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 432 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_x = ((_tmp5_.x + _tmp6_.width) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp8_;
#line 433 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = workarea_rect;
#line 433 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_y = _tmp9_.y + GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN;
#line 434 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = workarea_rect;
#line 434 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = workarea_rect;
#line 434 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = clutter_actor_get_height ((ClutterActor*) self);
#line 434 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = _tmp12_;
#line 434 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_y = ((_tmp10_.y + _tmp11_.height) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp13_;
#line 436 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 438 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 439 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 440 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 441 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = clutter_actor_get_x ((ClutterActor*) self);
#line 441 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = _tmp14_;
#line 441 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_x ((ClutterActor*) self, CLAMP (_tmp15_, (gfloat) screen_limit_start_x, screen_limit_end_x));
#line 442 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = clutter_actor_get_y ((ClutterActor*) self);
#line 442 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = _tmp16_;
#line 442 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_y ((ClutterActor*) self, CLAMP (_tmp17_, (gfloat) screen_limit_start_y, screen_limit_end_y));
#line 443 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1526 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self)
{
	guint duration = 0U;
	MtkRectangle monitor_rect = {0};
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
	MtkRectangle _tmp2_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp3_;
	gint monitor_y = 0;
	MtkRectangle _tmp4_;
	gint monitor_width = 0;
	MtkRectangle _tmp5_;
	gint monitor_height = 0;
	MtkRectangle _tmp6_;
	gfloat off_screen_x_threshold = 0.0F;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gboolean off_screen_x = FALSE;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean off_screen_w = FALSE;
	gfloat _tmp16_;
	gfloat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gboolean _tmp20_ = FALSE;
	gfloat off_screen_y_threshold = 0.0F;
	gfloat _tmp25_;
	gfloat _tmp26_;
	gboolean off_screen_y = FALSE;
	gfloat _tmp27_;
	gfloat _tmp28_;
	gboolean _tmp29_ = FALSE;
	gboolean off_screen_h = FALSE;
	gfloat _tmp34_;
	gfloat _tmp35_;
	gfloat _tmp36_;
	gfloat _tmp37_;
	gboolean _tmp38_ = FALSE;
	gboolean result;
#line 446 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 447 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 449 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 451 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 452 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 453 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 455 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 455 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 455 "../plugins/pip/PopupWindow.vala"
	meta_display_get_monitor_geometry (_tmp0_, meta_display_get_current_monitor (_tmp1_), &_tmp2_);
#line 455 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp2_;
#line 457 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = monitor_rect;
#line 457 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp3_.x;
#line 458 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = monitor_rect;
#line 458 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp4_.y;
#line 459 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = monitor_rect;
#line 459 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp5_.width;
#line 460 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = monitor_rect;
#line 460 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp6_.height;
#line 463 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_width ((ClutterActor*) self);
#line 463 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 463 "../plugins/pip/PopupWindow.vala"
	off_screen_x_threshold = _tmp8_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_x ((ClutterActor*) self);
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 465 "../plugins/pip/PopupWindow.vala"
	off_screen_x = (_tmp10_ - monitor_x) < (-off_screen_x_threshold);
#line 466 "../plugins/pip/PopupWindow.vala"
	if (off_screen_x) {
#line 1622 "PopupWindow.c"
		gfloat _tmp12_;
		gfloat _tmp13_;
#line 467 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = clutter_actor_get_x ((ClutterActor*) self);
#line 467 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = _tmp12_;
#line 467 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp13_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1631 "PopupWindow.c"
	} else {
#line 466 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = FALSE;
#line 1635 "PopupWindow.c"
	}
#line 466 "../plugins/pip/PopupWindow.vala"
	if (_tmp11_) {
#line 1639 "PopupWindow.c"
		gfloat _tmp14_;
		gfloat _tmp15_;
#line 468 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 469 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = clutter_actor_get_width ((ClutterActor*) self);
#line 469 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = _tmp14_;
#line 469 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (monitor_x - _tmp15_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1650 "PopupWindow.c"
	}
#line 472 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = clutter_actor_get_x ((ClutterActor*) self);
#line 472 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = _tmp16_;
#line 472 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = clutter_actor_get_width ((ClutterActor*) self);
#line 472 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = _tmp18_;
#line 472 "../plugins/pip/PopupWindow.vala"
	off_screen_w = (_tmp17_ + _tmp19_) > ((monitor_x + monitor_width) + off_screen_x_threshold);
#line 473 "../plugins/pip/PopupWindow.vala"
	if (off_screen_w) {
#line 1664 "PopupWindow.c"
		gfloat _tmp21_;
		gfloat _tmp22_;
		gfloat _tmp23_;
		gfloat _tmp24_;
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = clutter_actor_get_x ((ClutterActor*) self);
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = _tmp21_;
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = clutter_actor_get_width ((ClutterActor*) self);
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = _tmp23_;
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp22_ + _tmp24_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1679 "PopupWindow.c"
	} else {
#line 473 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = FALSE;
#line 1683 "PopupWindow.c"
	}
#line 473 "../plugins/pip/PopupWindow.vala"
	if (_tmp20_) {
#line 475 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 476 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (gfloat) ((monitor_x + monitor_width) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1691 "PopupWindow.c"
	}
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = clutter_actor_get_height ((ClutterActor*) self);
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp26_ = _tmp25_;
#line 480 "../plugins/pip/PopupWindow.vala"
	off_screen_y_threshold = _tmp26_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 482 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = clutter_actor_get_y ((ClutterActor*) self);
#line 482 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = _tmp27_;
#line 482 "../plugins/pip/PopupWindow.vala"
	off_screen_y = (_tmp28_ - monitor_y) < (-off_screen_y_threshold);
#line 483 "../plugins/pip/PopupWindow.vala"
	if (off_screen_y) {
#line 1707 "PopupWindow.c"
		gfloat _tmp30_;
		gfloat _tmp31_;
#line 484 "../plugins/pip/PopupWindow.vala"
		_tmp30_ = clutter_actor_get_y ((ClutterActor*) self);
#line 484 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = _tmp30_;
#line 484 "../plugins/pip/PopupWindow.vala"
		_tmp29_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp31_, CLUTTER_ORIENTATION_VERTICAL);
#line 1716 "PopupWindow.c"
	} else {
#line 483 "../plugins/pip/PopupWindow.vala"
		_tmp29_ = FALSE;
#line 1720 "PopupWindow.c"
	}
#line 483 "../plugins/pip/PopupWindow.vala"
	if (_tmp29_) {
#line 1724 "PopupWindow.c"
		gfloat _tmp32_;
		gfloat _tmp33_;
#line 485 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 486 "../plugins/pip/PopupWindow.vala"
		_tmp32_ = clutter_actor_get_height ((ClutterActor*) self);
#line 486 "../plugins/pip/PopupWindow.vala"
		_tmp33_ = _tmp32_;
#line 486 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (monitor_y - _tmp33_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1735 "PopupWindow.c"
	}
#line 489 "../plugins/pip/PopupWindow.vala"
	_tmp34_ = clutter_actor_get_y ((ClutterActor*) self);
#line 489 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = _tmp34_;
#line 489 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = clutter_actor_get_height ((ClutterActor*) self);
#line 489 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = _tmp36_;
#line 489 "../plugins/pip/PopupWindow.vala"
	off_screen_h = (_tmp35_ + _tmp37_) > ((monitor_y + monitor_height) + off_screen_y_threshold);
#line 490 "../plugins/pip/PopupWindow.vala"
	if (off_screen_h) {
#line 1749 "PopupWindow.c"
		gfloat _tmp39_;
		gfloat _tmp40_;
		gfloat _tmp41_;
		gfloat _tmp42_;
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp39_ = clutter_actor_get_y ((ClutterActor*) self);
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = _tmp39_;
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp41_ = clutter_actor_get_height ((ClutterActor*) self);
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp42_ = _tmp41_;
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp38_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp40_ + _tmp42_, CLUTTER_ORIENTATION_VERTICAL);
#line 1764 "PopupWindow.c"
	} else {
#line 490 "../plugins/pip/PopupWindow.vala"
		_tmp38_ = FALSE;
#line 1768 "PopupWindow.c"
	}
#line 490 "../plugins/pip/PopupWindow.vala"
	if (_tmp38_) {
#line 492 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 493 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (gfloat) ((monitor_y + monitor_height) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1776 "PopupWindow.c"
	}
#line 496 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 498 "../plugins/pip/PopupWindow.vala"
	result = self->priv->off_screen;
#line 498 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1784 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                         gfloat coord,
                                                         ClutterOrientation axis)
{
	gint n_monitors = 0;
	MetaDisplay* _tmp0_;
	gint current = 0;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 501 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 502 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 502 "../plugins/pip/PopupWindow.vala"
	n_monitors = meta_display_get_n_monitors (_tmp0_);
#line 504 "../plugins/pip/PopupWindow.vala"
	if (n_monitors == 1) {
#line 505 "../plugins/pip/PopupWindow.vala"
		result = FALSE;
#line 505 "../plugins/pip/PopupWindow.vala"
		return result;
#line 1809 "PopupWindow.c"
	}
#line 508 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 508 "../plugins/pip/PopupWindow.vala"
	current = meta_display_get_current_monitor (_tmp1_);
#line 1815 "PopupWindow.c"
	{
		gint i = 0;
#line 509 "../plugins/pip/PopupWindow.vala"
		i = 0;
#line 1820 "PopupWindow.c"
		{
			gboolean _tmp2_ = FALSE;
#line 509 "../plugins/pip/PopupWindow.vala"
			_tmp2_ = TRUE;
#line 509 "../plugins/pip/PopupWindow.vala"
			while (TRUE) {
#line 509 "../plugins/pip/PopupWindow.vala"
				if (!_tmp2_) {
#line 1829 "PopupWindow.c"
					gint _tmp3_;
#line 509 "../plugins/pip/PopupWindow.vala"
					_tmp3_ = i;
#line 509 "../plugins/pip/PopupWindow.vala"
					i = _tmp3_ + 1;
#line 1835 "PopupWindow.c"
				}
#line 509 "../plugins/pip/PopupWindow.vala"
				_tmp2_ = FALSE;
#line 509 "../plugins/pip/PopupWindow.vala"
				if (!(i < n_monitors)) {
#line 509 "../plugins/pip/PopupWindow.vala"
					break;
#line 1843 "PopupWindow.c"
				}
#line 510 "../plugins/pip/PopupWindow.vala"
				if (i != current) {
#line 1847 "PopupWindow.c"
					MtkRectangle monitor_rect = {0};
					MetaDisplay* _tmp4_;
					MtkRectangle _tmp5_ = {0};
					gboolean in_monitor = FALSE;
#line 511 "../plugins/pip/PopupWindow.vala"
					_tmp4_ = self->priv->_display;
#line 511 "../plugins/pip/PopupWindow.vala"
					meta_display_get_monitor_geometry (_tmp4_, i, &_tmp5_);
#line 511 "../plugins/pip/PopupWindow.vala"
					monitor_rect = _tmp5_;
#line 512 "../plugins/pip/PopupWindow.vala"
					in_monitor = FALSE;
#line 514 "../plugins/pip/PopupWindow.vala"
					if (axis == CLUTTER_ORIENTATION_HORIZONTAL) {
#line 1862 "PopupWindow.c"
						gboolean _tmp6_ = FALSE;
						MtkRectangle _tmp7_;
#line 515 "../plugins/pip/PopupWindow.vala"
						_tmp7_ = monitor_rect;
#line 515 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp7_.x)) {
#line 1869 "PopupWindow.c"
							MtkRectangle _tmp8_;
							MtkRectangle _tmp9_;
#line 515 "../plugins/pip/PopupWindow.vala"
							_tmp8_ = monitor_rect;
#line 515 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = monitor_rect;
#line 515 "../plugins/pip/PopupWindow.vala"
							_tmp6_ = coord <= ((gfloat) (_tmp8_.x + _tmp9_.width));
#line 1878 "PopupWindow.c"
						} else {
#line 515 "../plugins/pip/PopupWindow.vala"
							_tmp6_ = FALSE;
#line 1882 "PopupWindow.c"
						}
#line 515 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp6_;
#line 1886 "PopupWindow.c"
					} else {
						gboolean _tmp10_ = FALSE;
						MtkRectangle _tmp11_;
#line 517 "../plugins/pip/PopupWindow.vala"
						_tmp11_ = monitor_rect;
#line 517 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp11_.y)) {
#line 1894 "PopupWindow.c"
							MtkRectangle _tmp12_;
							MtkRectangle _tmp13_;
#line 517 "../plugins/pip/PopupWindow.vala"
							_tmp12_ = monitor_rect;
#line 517 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = monitor_rect;
#line 517 "../plugins/pip/PopupWindow.vala"
							_tmp10_ = coord <= ((gfloat) (_tmp12_.y + _tmp13_.height));
#line 1903 "PopupWindow.c"
						} else {
#line 517 "../plugins/pip/PopupWindow.vala"
							_tmp10_ = FALSE;
#line 1907 "PopupWindow.c"
						}
#line 517 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp10_;
#line 1911 "PopupWindow.c"
					}
#line 520 "../plugins/pip/PopupWindow.vala"
					if (in_monitor) {
#line 521 "../plugins/pip/PopupWindow.vala"
						result = TRUE;
#line 521 "../plugins/pip/PopupWindow.vala"
						return result;
#line 1919 "PopupWindow.c"
					}
				}
			}
		}
	}
#line 526 "../plugins/pip/PopupWindow.vala"
	result = FALSE;
#line 526 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1929 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                      gfloat* width,
                                                      gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 529 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 530 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 530 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 530 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 530 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1952 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 531 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 531 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 531 "../plugins/pip/PopupWindow.vala"
		_vala_width = _tmp4_;
#line 531 "../plugins/pip/PopupWindow.vala"
		_vala_height = _tmp5_;
#line 1964 "PopupWindow.c"
	} else {
		ClutterClone* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 532 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone;
#line 532 "../plugins/pip/PopupWindow.vala"
		g_object_get ((ClutterActor*) _tmp6_, "has-clip", &_tmp7_, NULL);
#line 532 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 532 "../plugins/pip/PopupWindow.vala"
		if (_tmp8_) {
#line 1977 "PopupWindow.c"
			ClutterClone* _tmp9_;
			gfloat _tmp10_ = 0.0F;
			gfloat _tmp11_ = 0.0F;
#line 533 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = self->priv->clone;
#line 533 "../plugins/pip/PopupWindow.vala"
			clutter_actor_get_clip ((ClutterActor*) _tmp9_, NULL, NULL, &_tmp10_, &_tmp11_);
#line 533 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp10_;
#line 533 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp11_;
#line 1989 "PopupWindow.c"
		} else {
			ClutterClone* _tmp12_;
			gfloat _tmp13_;
			gfloat _tmp14_;
			ClutterClone* _tmp15_;
			gfloat _tmp16_;
			gfloat _tmp17_;
#line 535 "../plugins/pip/PopupWindow.vala"
			_tmp12_ = self->priv->clone;
#line 535 "../plugins/pip/PopupWindow.vala"
			_tmp13_ = clutter_actor_get_width ((ClutterActor*) _tmp12_);
#line 535 "../plugins/pip/PopupWindow.vala"
			_tmp14_ = _tmp13_;
#line 535 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp14_;
#line 536 "../plugins/pip/PopupWindow.vala"
			_tmp15_ = self->priv->clone;
#line 536 "../plugins/pip/PopupWindow.vala"
			_tmp16_ = clutter_actor_get_height ((ClutterActor*) _tmp15_);
#line 536 "../plugins/pip/PopupWindow.vala"
			_tmp17_ = _tmp16_;
#line 536 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp17_;
#line 2013 "PopupWindow.c"
		}
	}
#line 529 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 529 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 2020 "PopupWindow.c"
	}
#line 529 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 529 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 2026 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self)
{
#line 540 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 541 "../plugins/pip/PopupWindow.vala"
	if (self->priv->off_screen) {
#line 542 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 2039 "PopupWindow.c"
	} else {
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp0_;
		MetaWindow* _tmp1_;
		MetaWindow* _tmp2_;
		MetaWindow* _tmp3_;
#line 544 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->_window_actor;
#line 544 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 544 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 544 "../plugins/pip/PopupWindow.vala"
		window = _tmp2_;
#line 545 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = window;
#line 545 "../plugins/pip/PopupWindow.vala"
		meta_window_activate (_tmp3_, clutter_get_current_event_time ());
#line 541 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (window);
#line 2060 "PopupWindow.c"
	}
}

MetaDisplay*
gala_plugins_pip_popup_window_get_display (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 19 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2077 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_display (GalaPluginsPIPPopupWindow* self,
                                           MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_display (self);
#line 19 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2091 "PopupWindow.c"
		MetaDisplay* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_display);
#line 19 "../plugins/pip/PopupWindow.vala"
		self->priv->_display = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY]);
#line 2101 "PopupWindow.c"
	}
}

MetaWindowActor*
gala_plugins_pip_popup_window_get_window_actor (GalaPluginsPIPPopupWindow* self)
{
	MetaWindowActor* result;
	MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 20 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2118 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_window_actor (GalaPluginsPIPPopupWindow* self,
                                                MetaWindowActor* value)
{
	MetaWindowActor* old_value;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_window_actor (self);
#line 20 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2132 "PopupWindow.c"
		MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_window_actor);
#line 20 "../plugins/pip/PopupWindow.vala"
		self->priv->_window_actor = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY]);
#line 2142 "PopupWindow.c"
	}
}

static ClutterActor*
_gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                               gfloat x,
                                                                               gfloat y,
                                                                               gpointer self)
{
	ClutterActor* result;
	result = gala_plugins_pip_popup_window_on_move_begin ((GalaPluginsPIPPopupWindow*) self);
#line 84 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2156 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                gpointer self)
{
#line 85 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_move_end ((GalaPluginsPIPPopupWindow*) self);
#line 2165 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                             guint32 button,
                                                                             gpointer self)
{
#line 86 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_activate ((GalaPluginsPIPPopupWindow*) self);
#line 2175 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                   guint32 timestamp,
                                                                                   gpointer self)
{
#line 109 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2185 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                        ClutterEvent* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_button_press ((GalaPluginsPIPPopupWindow*) self, event);
#line 116 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2197 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self)
{
#line 122 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed ((GalaPluginsPIPPopupWindow*) self);
#line 2207 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                             gpointer self)
{
#line 127 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2216 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 128 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2226 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                    gpointer self)
{
#line 131 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2235 "PopupWindow.c"
}

static GObject *
gala_plugins_pip_popup_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPluginsPIPPopupWindow * self;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindowActor* _tmp2_;
	ClutterClone* _tmp3_;
	ClutterActor* _tmp4_ = NULL;
	ClutterActor* _tmp5_;
	ClutterClone* _tmp6_;
	ClutterActor* _tmp7_ = NULL;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	GalaShadowEffect* _tmp11_;
	GalaShadowEffect* _tmp12_;
	GalaDragDropAction* _tmp13_;
	GalaDragDropAction* _tmp14_;
	GalaDragDropAction* _tmp15_;
	GalaDragDropAction* _tmp16_;
	GalaDragDropAction* _tmp17_;
	MtkRectangle workarea_rect = {0};
	MetaDisplay* _tmp18_;
	MetaWorkspaceManager* _tmp19_;
	MetaWorkspace* _tmp20_;
	MtkRectangle _tmp21_ = {0};
	gfloat x_position = 0.0F;
	gfloat y_position = 0.0F;
	MtkRectangle _tmp27_;
	MtkRectangle _tmp28_;
	gfloat _tmp29_;
	gfloat _tmp30_;
	GalaCloseButton* _tmp31_ = NULL;
	GalaCloseButton* _tmp32_;
	ClutterAlignConstraint* _tmp33_;
	ClutterAlignConstraint* _tmp34_;
	GalaCloseButton* _tmp35_;
	ClutterAlignConstraint* _tmp36_;
	ClutterAlignConstraint* _tmp37_;
	GalaCloseButton* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterActor* _tmp41_;
	ClutterActor* _tmp42_;
	ClutterAlignConstraint* _tmp43_;
	ClutterAlignConstraint* _tmp44_;
	ClutterActor* _tmp45_;
	ClutterAlignConstraint* _tmp46_;
	ClutterAlignConstraint* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterActor* _tmp49_;
	GalaCloseButton* _tmp50_;
	ClutterActor* _tmp51_;
	MetaWindowActor* _tmp52_;
	ClutterActor* _tmp53_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp54_;
	MetaWindow* _tmp55_;
	MetaWindow* _tmp56_;
	MetaWindow* _tmp57_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp58_;
	MetaWorkspaceManager* _tmp59_;
	MetaWorkspaceManager* _tmp60_;
#line 59 "../plugins/pip/PopupWindow.vala"
	parent_class = G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class);
#line 59 "../plugins/pip/PopupWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 60 "../plugins/pip/PopupWindow.vala"
	scale = meta_display_get_monitor_scale (_tmp0_, meta_display_get_current_monitor (_tmp1_));
#line 62 "../plugins/pip/PopupWindow.vala"
	self->priv->button_size = gala_utils_scale_to_int (36, scale);
#line 63 "../plugins/pip/PopupWindow.vala"
	self->priv->container_margin = self->priv->button_size / 2;
#line 65 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 66 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) self, 0.5f, 0.5f);
#line 67 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_IN_QUAD);
#line 69 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->_window_actor;
#line 69 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp2_);
#line 69 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 69 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 69 "../plugins/pip/PopupWindow.vala"
	self->priv->clone = _tmp3_;
#line 71 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = clutter_actor_new ();
#line 71 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp4_, "scale-x", (gdouble) 0.35f, NULL);
#line 71 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp4_, "scale-y", (gdouble) 0.35f, NULL);
#line 71 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 71 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 71 "../plugins/pip/PopupWindow.vala"
	self->priv->clone_container = _tmp4_;
#line 75 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->clone_container;
#line 75 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->clone;
#line 75 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp5_, (ClutterActor*) _tmp6_);
#line 77 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_new ();
#line 77 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp7_, TRUE);
#line 77 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 77 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 77 "../plugins/pip/PopupWindow.vala"
	self->priv->container = _tmp7_;
#line 80 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->container;
#line 80 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->clone_container;
#line 80 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp8_, _tmp9_);
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->container;
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = gala_shadow_effect_new ("window");
#line 81 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 81 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_effect (_tmp10_, (ClutterEffect*) _tmp12_);
#line 81 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp12_);
#line 83 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = gala_drag_drop_action_new (GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "pip");
#line 83 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 83 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 83 "../plugins/pip/PopupWindow.vala"
	self->priv->move_action = _tmp13_;
#line 84 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->move_action;
#line 84 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp14_, "drag-begin", (GCallback) _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin, self, 0);
#line 85 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->move_action;
#line 85 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp15_, "drag-canceled", (GCallback) _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled, self, 0);
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = self->priv->move_action;
#line 86 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp16_, "actor-clicked", (GCallback) _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked, self, 0);
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = self->priv->move_action;
#line 87 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_action ((ClutterActor*) self, (ClutterAction*) _tmp17_);
#line 89 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 91 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = self->priv->_display;
#line 91 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = meta_display_get_workspace_manager (_tmp18_);
#line 91 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = meta_workspace_manager_get_active_workspace (_tmp19_);
#line 91 "../plugins/pip/PopupWindow.vala"
	meta_workspace_get_work_area_all_monitors (_tmp20_, &_tmp21_);
#line 91 "../plugins/pip/PopupWindow.vala"
	workarea_rect = _tmp21_;
#line 94 "../plugins/pip/PopupWindow.vala"
	if (clutter_get_default_text_direction () == CLUTTER_TEXT_DIRECTION_RTL) {
#line 2424 "PopupWindow.c"
		MtkRectangle _tmp22_;
#line 95 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = workarea_rect;
#line 95 "../plugins/pip/PopupWindow.vala"
		x_position = (gfloat) (GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + _tmp22_.x);
#line 2430 "PopupWindow.c"
	} else {
		MtkRectangle _tmp23_;
		MtkRectangle _tmp24_;
		gfloat _tmp25_;
		gfloat _tmp26_;
#line 97 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = workarea_rect;
#line 97 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = workarea_rect;
#line 97 "../plugins/pip/PopupWindow.vala"
		_tmp25_ = clutter_actor_get_width ((ClutterActor*) self);
#line 97 "../plugins/pip/PopupWindow.vala"
		_tmp26_ = _tmp25_;
#line 97 "../plugins/pip/PopupWindow.vala"
		x_position = ((_tmp23_.x + _tmp24_.width) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp26_;
#line 2446 "PopupWindow.c"
	}
#line 99 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = workarea_rect;
#line 99 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = workarea_rect;
#line 99 "../plugins/pip/PopupWindow.vala"
	_tmp29_ = clutter_actor_get_height ((ClutterActor*) self);
#line 99 "../plugins/pip/PopupWindow.vala"
	_tmp30_ = _tmp29_;
#line 99 "../plugins/pip/PopupWindow.vala"
	y_position = ((_tmp27_.y + _tmp28_.height) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp30_;
#line 101 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) self, x_position, y_position);
#line 103 "../plugins/pip/PopupWindow.vala"
	_tmp31_ = gala_close_button_new (scale);
#line 103 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp31_, (guint) 0);
#line 103 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp31_);
#line 103 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 103 "../plugins/pip/PopupWindow.vala"
	self->priv->close_button = _tmp31_;
#line 107 "../plugins/pip/PopupWindow.vala"
	_tmp32_ = self->priv->close_button;
#line 107 "../plugins/pip/PopupWindow.vala"
	_tmp33_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 0.0f);
#line 107 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp33_);
#line 107 "../plugins/pip/PopupWindow.vala"
	_tmp34_ = _tmp33_;
#line 107 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp32_, (ClutterConstraint*) _tmp34_);
#line 107 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp34_);
#line 108 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = self->priv->close_button;
#line 108 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 0.0f);
#line 108 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 108 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = _tmp36_;
#line 108 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp35_, (ClutterConstraint*) _tmp37_);
#line 108 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp37_);
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = self->priv->close_button;
#line 109 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp38_, "triggered", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered, self, 0);
#line 111 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = gala_utils_create_resize_button (scale);
#line 111 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 111 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_button = _tmp39_;
#line 112 "../plugins/pip/PopupWindow.vala"
	_tmp40_ = self->priv->resize_button;
#line 112 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp40_, (guint) 0);
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp41_ = self->priv->resize_button;
#line 113 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp41_, TRUE);
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp42_ = self->priv->resize_button;
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp43_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 1.0f);
#line 114 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp43_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp44_ = _tmp43_;
#line 114 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp42_, (ClutterConstraint*) _tmp44_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp44_);
#line 115 "../plugins/pip/PopupWindow.vala"
	_tmp45_ = self->priv->resize_button;
#line 115 "../plugins/pip/PopupWindow.vala"
	_tmp46_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 1.0f);
#line 115 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp46_);
#line 115 "../plugins/pip/PopupWindow.vala"
	_tmp47_ = _tmp46_;
#line 115 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp45_, (ClutterConstraint*) _tmp47_);
#line 115 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp47_);
#line 116 "../plugins/pip/PopupWindow.vala"
	_tmp48_ = self->priv->resize_button;
#line 116 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp48_, "button-press-event", (GCallback) _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event, self, 0);
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp49_ = self->priv->container;
#line 118 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp49_);
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp50_ = self->priv->close_button;
#line 119 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp50_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp51_ = self->priv->resize_button;
#line 120 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp51_);
#line 122 "../plugins/pip/PopupWindow.vala"
	_tmp52_ = self->priv->_window_actor;
#line 122 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp52_, "notify::allocation", (GCallback) _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify, self, 0);
#line 123 "../plugins/pip/PopupWindow.vala"
	_tmp53_ = self->priv->container;
#line 123 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position (_tmp53_, (gfloat) self->priv->container_margin, (gfloat) self->priv->container_margin);
#line 124 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 126 "../plugins/pip/PopupWindow.vala"
	_tmp54_ = self->priv->_window_actor;
#line 126 "../plugins/pip/PopupWindow.vala"
	_tmp55_ = meta_window_actor_get_meta_window (_tmp54_);
#line 126 "../plugins/pip/PopupWindow.vala"
	window = _tmp55_;
#line 127 "../plugins/pip/PopupWindow.vala"
	_tmp56_ = window;
#line 127 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp56_, "unmanaged", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged, self, 0);
#line 128 "../plugins/pip/PopupWindow.vala"
	_tmp57_ = window;
#line 128 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp57_, "notify::appears-focused", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_g_object_notify, self, 0);
#line 130 "../plugins/pip/PopupWindow.vala"
	_tmp58_ = self->priv->_display;
#line 130 "../plugins/pip/PopupWindow.vala"
	_tmp59_ = meta_display_get_workspace_manager (_tmp58_);
#line 130 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp59_;
#line 131 "../plugins/pip/PopupWindow.vala"
	_tmp60_ = workspace_manager;
#line 131 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp60_, "active-workspace-changed", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed, self, 0);
#line 59 "../plugins/pip/PopupWindow.vala"
	return obj;
#line 2588 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_class_init (GalaPluginsPIPPopupWindowClass * klass,
                                          gpointer klass_data)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_parent_class = g_type_class_peek_parent (klass);
#line 7 "../plugins/pip/PopupWindow.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginsPIPPopupWindow_private_offset);
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->show = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_show;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->hide = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_hide;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->enter_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_enter_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->leave_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_leave_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugins_pip_popup_window_get_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugins_pip_popup_window_set_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_plugins_pip_popup_window_constructor;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugins_pip_popup_window_finalize;
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY] = g_param_spec_object ("window-actor", "window-actor", "window-actor", meta_window_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2621 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_instance_init (GalaPluginsPIPPopupWindow * self,
                                             gpointer klass)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	self->priv = gala_plugins_pip_popup_window_get_instance_private (self);
#line 29 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = 0.0f;
#line 30 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = 0.0f;
#line 31 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = 0.0f;
#line 32 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = 0.0f;
#line 34 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 35 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 36 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = NULL;
#line 2644 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_finalize (GObject * obj)
{
	GalaPluginsPIPPopupWindow * self;
#line 7 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 19 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_display);
#line 20 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_window_actor);
#line 22 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 23 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 24 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 25 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 26 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 27 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 36 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class)->finalize (obj);
#line 2673 "PopupWindow.c"
}

 G_GNUC_NO_INLINE static GType
gala_plugins_pip_popup_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginsPIPPopupWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugins_pip_popup_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginsPIPPopupWindow), 0, (GInstanceInitFunc) gala_plugins_pip_popup_window_instance_init, NULL };
	GType gala_plugins_pip_popup_window_type_id;
	gala_plugins_pip_popup_window_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPluginsPIPPopupWindow", &g_define_type_info, 0);
	GalaPluginsPIPPopupWindow_private_offset = g_type_add_instance_private (gala_plugins_pip_popup_window_type_id, sizeof (GalaPluginsPIPPopupWindowPrivate));
	return gala_plugins_pip_popup_window_type_id;
}

GType
gala_plugins_pip_popup_window_get_type (void)
{
	static gsize gala_plugins_pip_popup_window_type_id__once = 0;
	if (g_once_init_enter (&gala_plugins_pip_popup_window_type_id__once)) {
		GType gala_plugins_pip_popup_window_type_id;
		gala_plugins_pip_popup_window_type_id = gala_plugins_pip_popup_window_get_type_once ();
		g_once_init_leave (&gala_plugins_pip_popup_window_type_id__once, gala_plugins_pip_popup_window_type_id);
	}
	return gala_plugins_pip_popup_window_type_id__once;
}

static void
_vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_display (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_window_actor (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2720 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2726 "PopupWindow.c"
	}
}

static void
_vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_display (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_window_actor (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2752 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2758 "PopupWindow.c"
	}
}

