/* Animation.c generated by valac 0.56.17, the Vala compiler
 * generated from Animation.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 *                         2014 Tom Beckmann
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <libgnome-desktop/gnome-bg-slide-show.h>
#include <gio/gio.h>
#include <mtk/mtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_ANIMATION (gala_animation_get_type ())
#define GALA_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ANIMATION, GalaAnimation))
#define GALA_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ANIMATION, GalaAnimationClass))
#define GALA_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ANIMATION))
#define GALA_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ANIMATION))
#define GALA_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ANIMATION, GalaAnimationClass))

typedef struct _GalaAnimation GalaAnimation;
typedef struct _GalaAnimationClass GalaAnimationClass;
typedef struct _GalaAnimationPrivate GalaAnimationPrivate;
enum  {
	GALA_ANIMATION_0_PROPERTY,
	GALA_ANIMATION_FILENAME_PROPERTY,
	GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY,
	GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY,
	GALA_ANIMATION_TRANSITION_DURATION_PROPERTY,
	GALA_ANIMATION_LOADED_PROPERTY,
	GALA_ANIMATION_NUM_PROPERTIES
};
static GParamSpec* gala_animation_properties[GALA_ANIMATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block42Data Block42Data;
typedef struct _GalaAnimationLoadData GalaAnimationLoadData;

struct _GalaAnimation {
	GObject parent_instance;
	GalaAnimationPrivate * priv;
};

struct _GalaAnimationClass {
	GObjectClass parent_class;
};

struct _GalaAnimationPrivate {
	gchar* _filename;
	gchar** _key_frame_files;
	gint _key_frame_files_length1;
	gint __key_frame_files_size_;
	gdouble _transition_progress;
	gdouble _transition_duration;
	gboolean _loaded;
	GnomeBGSlideShow* show;
};

struct _Block42Data {
	int _ref_count_;
	GalaAnimation* self;
	gpointer _async_data_;
};

struct _GalaAnimationLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GalaAnimation* self;
	Block42Data* _data42_;
	const gchar* _tmp0_;
	GnomeBGSlideShow* _tmp1_;
	GnomeBGSlideShow* _tmp2_;
};

static gint GalaAnimation_private_offset;
static gpointer gala_animation_parent_class = NULL;

VALA_EXTERN GType gala_animation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaAnimation, g_object_unref)
VALA_EXTERN GalaAnimation* gala_animation_new (const gchar* filename);
VALA_EXTERN GalaAnimation* gala_animation_construct (GType object_type,
                                         const gchar* filename);
static void gala_animation_load_data_free (gpointer _data);
VALA_EXTERN void gala_animation_load (GalaAnimation* self,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
VALA_EXTERN void gala_animation_load_finish (GalaAnimation* self,
                                 GAsyncResult* _res_);
static gboolean gala_animation_load_co (GalaAnimationLoadData* _data_);
static Block42Data* block42_data_ref (Block42Data* _data42_);
static void block42_data_unref (void * _userdata_);
VALA_EXTERN const gchar* gala_animation_get_filename (GalaAnimation* self);
static void __lambda24_ (Block42Data* _data42_,
                  GObject* obj,
                  GAsyncResult* res);
static void gala_animation_set_loaded (GalaAnimation* self,
                                gboolean value);
static void ___lambda24__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void gala_animation_update (GalaAnimation* self,
                            MtkRectangle* monitor);
static void gala_animation_set_transition_duration (GalaAnimation* self,
                                             gdouble value);
static void gala_animation_set_transition_progress (GalaAnimation* self,
                                             gdouble value);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void gala_animation_set_key_frame_files (GalaAnimation* self,
                                         gchar** value,
                                         gint value_length1);
static void gala_animation_set_filename (GalaAnimation* self,
                                  const gchar* value);
VALA_EXTERN gchar** gala_animation_get_key_frame_files (GalaAnimation* self,
                                            gint* result_length1);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
VALA_EXTERN gdouble gala_animation_get_transition_progress (GalaAnimation* self);
VALA_EXTERN gdouble gala_animation_get_transition_duration (GalaAnimation* self);
VALA_EXTERN gboolean gala_animation_get_loaded (GalaAnimation* self);
static void gala_animation_finalize (GObject * obj);
static GType gala_animation_get_type_once (void);
static void _vala_gala_animation_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_gala_animation_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gala_animation_get_instance_private (GalaAnimation* self)
{
	return G_STRUCT_MEMBER_P (self, GalaAnimation_private_offset);
}

GalaAnimation*
gala_animation_construct (GType object_type,
                          const gchar* filename)
{
	GalaAnimation * self = NULL;
#line 16 "../src/Background/Animation.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 17 "../src/Background/Animation.vala"
	self = (GalaAnimation*) g_object_new (object_type, "filename", filename, NULL);
#line 16 "../src/Background/Animation.vala"
	return self;
#line 188 "Animation.c"
}

GalaAnimation*
gala_animation_new (const gchar* filename)
{
#line 16 "../src/Background/Animation.vala"
	return gala_animation_construct (GALA_TYPE_ANIMATION, filename);
#line 196 "Animation.c"
}

static void
gala_animation_load_data_free (gpointer _data)
{
	GalaAnimationLoadData* _data_;
	_data_ = _data;
#line 7 "../src/Background/Animation.vala"
	_g_object_unref0 (_data_->self);
#line 7 "../src/Background/Animation.vala"
	g_slice_free (GalaAnimationLoadData, _data_);
#line 208 "Animation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 7 "../src/Background/Animation.vala"
	return self ? g_object_ref (self) : NULL;
#line 216 "Animation.c"
}

void
gala_animation_load (GalaAnimation* self,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
	GalaAnimationLoadData* _data_;
	GalaAnimation* _tmp0_;
#line 7 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/Background/Animation.vala"
	_data_ = g_slice_new0 (GalaAnimationLoadData);
#line 7 "../src/Background/Animation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 7 "../src/Background/Animation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gala_animation_load_data_free);
#line 7 "../src/Background/Animation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 7 "../src/Background/Animation.vala"
	_data_->self = _tmp0_;
#line 7 "../src/Background/Animation.vala"
	gala_animation_load_co (_data_);
#line 240 "Animation.c"
}

void
gala_animation_load_finish (GalaAnimation* self,
                            GAsyncResult* _res_)
{
	GalaAnimationLoadData* _data_;
#line 7 "../src/Background/Animation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 250 "Animation.c"
}

static Block42Data*
block42_data_ref (Block42Data* _data42_)
{
#line 20 "../src/Background/Animation.vala"
	g_atomic_int_inc (&_data42_->_ref_count_);
#line 20 "../src/Background/Animation.vala"
	return _data42_;
#line 260 "Animation.c"
}

static void
block42_data_unref (void * _userdata_)
{
	Block42Data* _data42_;
	_data42_ = (Block42Data*) _userdata_;
#line 20 "../src/Background/Animation.vala"
	if (g_atomic_int_dec_and_test (&_data42_->_ref_count_)) {
#line 270 "Animation.c"
		GalaAnimation* self;
#line 20 "../src/Background/Animation.vala"
		self = _data42_->self;
#line 20 "../src/Background/Animation.vala"
		_g_object_unref0 (self);
#line 20 "../src/Background/Animation.vala"
		g_slice_free (Block42Data, _data42_);
#line 278 "Animation.c"
	}
}

static void
__lambda24_ (Block42Data* _data42_,
             GObject* obj,
             GAsyncResult* res)
{
	GalaAnimation* self;
#line 23 "../src/Background/Animation.vala"
	self = _data42_->self;
#line 23 "../src/Background/Animation.vala"
	g_return_if_fail (res != NULL);
#line 24 "../src/Background/Animation.vala"
	gala_animation_set_loaded (self, TRUE);
#line 26 "../src/Background/Animation.vala"
	gala_animation_load_co (_data42_->_async_data_);
#line 296 "Animation.c"
}

static void
___lambda24__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 23 "../src/Background/Animation.vala"
	__lambda24_ (self, source_object, res);
#line 306 "Animation.c"
}

static gboolean
gala_animation_load_co (GalaAnimationLoadData* _data_)
{
#line 20 "../src/Background/Animation.vala"
	switch (_data_->_state_) {
#line 20 "../src/Background/Animation.vala"
		case 0:
#line 316 "Animation.c"
		goto _state_0;
#line 20 "../src/Background/Animation.vala"
		case 1:
#line 320 "Animation.c"
		goto _state_1;
		default:
#line 20 "../src/Background/Animation.vala"
		g_assert_not_reached ();
#line 325 "Animation.c"
	}
	_state_0:
#line 20 "../src/Background/Animation.vala"
	_data_->_data42_ = g_slice_new0 (Block42Data);
#line 20 "../src/Background/Animation.vala"
	_data_->_data42_->_ref_count_ = 1;
#line 20 "../src/Background/Animation.vala"
	_data_->_data42_->self = g_object_ref (_data_->self);
#line 20 "../src/Background/Animation.vala"
	_data_->_data42_->_async_data_ = _data_;
#line 21 "../src/Background/Animation.vala"
	_data_->_tmp0_ = _data_->self->priv->_filename;
#line 21 "../src/Background/Animation.vala"
	_data_->_tmp1_ = gnome_bg_slide_show_new (_data_->_tmp0_);
#line 21 "../src/Background/Animation.vala"
	_g_object_unref0 (_data_->self->priv->show);
#line 21 "../src/Background/Animation.vala"
	_data_->self->priv->show = _data_->_tmp1_;
#line 23 "../src/Background/Animation.vala"
	_data_->_tmp2_ = _data_->self->priv->show;
#line 23 "../src/Background/Animation.vala"
	gnome_bg_slide_show_load_async (_data_->_tmp2_, NULL, ___lambda24__gasync_ready_callback, _data_->_data42_);
#line 29 "../src/Background/Animation.vala"
	_data_->_state_ = 1;
#line 29 "../src/Background/Animation.vala"
	return FALSE;
#line 352 "Animation.c"
	_state_1:
	;
#line 20 "../src/Background/Animation.vala"
	block42_data_unref (_data_->_data42_);
#line 20 "../src/Background/Animation.vala"
	_data_->_data42_ = NULL;
#line 20 "../src/Background/Animation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 20 "../src/Background/Animation.vala"
	if (_data_->_state_ != 0) {
#line 20 "../src/Background/Animation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 20 "../src/Background/Animation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 367 "Animation.c"
		}
	}
#line 20 "../src/Background/Animation.vala"
	g_object_unref (_data_->_async_result);
#line 20 "../src/Background/Animation.vala"
	return FALSE;
#line 374 "Animation.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 56 "../src/Background/Animation.vala"
	if ((*length) == (*size)) {
#line 56 "../src/Background/Animation.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 56 "../src/Background/Animation.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 389 "Animation.c"
	}
#line 56 "../src/Background/Animation.vala"
	(*array)[(*length)++] = value;
#line 56 "../src/Background/Animation.vala"
	(*array)[*length] = NULL;
#line 395 "Animation.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 60 "../src/Background/Animation.vala"
	if ((*length) == (*size)) {
#line 60 "../src/Background/Animation.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 60 "../src/Background/Animation.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 410 "Animation.c"
	}
#line 60 "../src/Background/Animation.vala"
	(*array)[(*length)++] = value;
#line 60 "../src/Background/Animation.vala"
	(*array)[*length] = NULL;
#line 416 "Animation.c"
}

void
gala_animation_update (GalaAnimation* self,
                       MtkRectangle* monitor)
{
	gchar** key_frame_files = NULL;
	gchar** _tmp0_;
	gint key_frame_files_length1;
	gint _key_frame_files_size_;
	GnomeBGSlideShow* _tmp1_;
	GnomeBGSlideShow* _tmp2_;
	gdouble progress = 0.0;
	gdouble duration = 0.0;
	gboolean is_fixed = FALSE;
	gchar* file1 = NULL;
	gchar* file2 = NULL;
	GnomeBGSlideShow* _tmp3_;
	MtkRectangle _tmp4_;
	MtkRectangle _tmp5_;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp16_;
	gchar** _tmp19_;
	gint _tmp19__length1;
#line 33 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Background/Animation.vala"
	g_return_if_fail (monitor != NULL);
#line 37 "../src/Background/Animation.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 37 "../src/Background/Animation.vala"
	key_frame_files = _tmp0_;
#line 37 "../src/Background/Animation.vala"
	key_frame_files_length1 = 0;
#line 37 "../src/Background/Animation.vala"
	_key_frame_files_size_ = key_frame_files_length1;
#line 39 "../src/Background/Animation.vala"
	_tmp1_ = self->priv->show;
#line 39 "../src/Background/Animation.vala"
	if (_tmp1_ == NULL) {
#line 40 "../src/Background/Animation.vala"
		key_frame_files = (_vala_array_free (key_frame_files, key_frame_files_length1, (GDestroyNotify) g_free), NULL);
#line 40 "../src/Background/Animation.vala"
		return;
#line 468 "Animation.c"
	}
#line 43 "../src/Background/Animation.vala"
	_tmp2_ = self->priv->show;
#line 43 "../src/Background/Animation.vala"
	if (gnome_bg_slide_show_get_num_slides (_tmp2_) < 1) {
#line 44 "../src/Background/Animation.vala"
		key_frame_files = (_vala_array_free (key_frame_files, key_frame_files_length1, (GDestroyNotify) g_free), NULL);
#line 44 "../src/Background/Animation.vala"
		return;
#line 478 "Animation.c"
	}
#line 50 "../src/Background/Animation.vala"
	_tmp3_ = self->priv->show;
#line 50 "../src/Background/Animation.vala"
	_tmp4_ = *monitor;
#line 50 "../src/Background/Animation.vala"
	_tmp5_ = *monitor;
#line 50 "../src/Background/Animation.vala"
	gnome_bg_slide_show_get_current_slide (_tmp3_, _tmp4_.width, _tmp5_.height, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 50 "../src/Background/Animation.vala"
	progress = _tmp6_;
#line 50 "../src/Background/Animation.vala"
	duration = _tmp7_;
#line 50 "../src/Background/Animation.vala"
	is_fixed = _tmp8_;
#line 50 "../src/Background/Animation.vala"
	_g_free0 (file1);
#line 50 "../src/Background/Animation.vala"
	_tmp11_ = g_strdup (_tmp9_);
#line 50 "../src/Background/Animation.vala"
	file1 = _tmp11_;
#line 50 "../src/Background/Animation.vala"
	_g_free0 (file2);
#line 50 "../src/Background/Animation.vala"
	_tmp12_ = g_strdup (_tmp10_);
#line 50 "../src/Background/Animation.vala"
	file2 = _tmp12_;
#line 52 "../src/Background/Animation.vala"
	gala_animation_set_transition_duration (self, duration);
#line 53 "../src/Background/Animation.vala"
	gala_animation_set_transition_progress (self, progress);
#line 55 "../src/Background/Animation.vala"
	_tmp13_ = file1;
#line 55 "../src/Background/Animation.vala"
	if (_tmp13_ != NULL) {
#line 514 "Animation.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 56 "../src/Background/Animation.vala"
		_tmp14_ = file1;
#line 56 "../src/Background/Animation.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 56 "../src/Background/Animation.vala"
		_vala_array_add10 (&key_frame_files, &key_frame_files_length1, &_key_frame_files_size_, _tmp15_);
#line 523 "Animation.c"
	}
#line 59 "../src/Background/Animation.vala"
	_tmp16_ = file2;
#line 59 "../src/Background/Animation.vala"
	if (_tmp16_ != NULL) {
#line 529 "Animation.c"
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 60 "../src/Background/Animation.vala"
		_tmp17_ = file2;
#line 60 "../src/Background/Animation.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 60 "../src/Background/Animation.vala"
		_vala_array_add11 (&key_frame_files, &key_frame_files_length1, &_key_frame_files_size_, _tmp18_);
#line 538 "Animation.c"
	}
#line 63 "../src/Background/Animation.vala"
	_tmp19_ = key_frame_files;
#line 63 "../src/Background/Animation.vala"
	_tmp19__length1 = key_frame_files_length1;
#line 63 "../src/Background/Animation.vala"
	gala_animation_set_key_frame_files (self, _tmp19_, _tmp19__length1);
#line 33 "../src/Background/Animation.vala"
	_g_free0 (file2);
#line 33 "../src/Background/Animation.vala"
	_g_free0 (file1);
#line 33 "../src/Background/Animation.vala"
	key_frame_files = (_vala_array_free (key_frame_files, key_frame_files_length1, (GDestroyNotify) g_free), NULL);
#line 552 "Animation.c"
}

const gchar*
gala_animation_get_filename (GalaAnimation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 8 "../src/Background/Animation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/Background/Animation.vala"
	_tmp0_ = self->priv->_filename;
#line 8 "../src/Background/Animation.vala"
	result = _tmp0_;
#line 8 "../src/Background/Animation.vala"
	return result;
#line 568 "Animation.c"
}

static void
gala_animation_set_filename (GalaAnimation* self,
                             const gchar* value)
{
	gchar* old_value;
#line 8 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/Background/Animation.vala"
	old_value = gala_animation_get_filename (self);
#line 8 "../src/Background/Animation.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 582 "Animation.c"
		gchar* _tmp0_;
#line 8 "../src/Background/Animation.vala"
		_tmp0_ = g_strdup (value);
#line 8 "../src/Background/Animation.vala"
		_g_free0 (self->priv->_filename);
#line 8 "../src/Background/Animation.vala"
		self->priv->_filename = _tmp0_;
#line 8 "../src/Background/Animation.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_animation_properties[GALA_ANIMATION_FILENAME_PROPERTY]);
#line 592 "Animation.c"
	}
}

gchar**
gala_animation_get_key_frame_files (GalaAnimation* self,
                                    gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 9 "../src/Background/Animation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/Background/Animation.vala"
	_tmp0_ = self->priv->_key_frame_files;
#line 9 "../src/Background/Animation.vala"
	_tmp0__length1 = self->priv->_key_frame_files_length1;
#line 9 "../src/Background/Animation.vala"
	_tmp1_ = _tmp0_;
#line 9 "../src/Background/Animation.vala"
	_tmp1__length1 = _tmp0__length1;
#line 9 "../src/Background/Animation.vala"
	if (result_length1) {
#line 9 "../src/Background/Animation.vala"
		*result_length1 = _tmp1__length1;
#line 619 "Animation.c"
	}
#line 9 "../src/Background/Animation.vala"
	result = _tmp1_;
#line 9 "../src/Background/Animation.vala"
	return result;
#line 625 "Animation.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 9 "../src/Background/Animation.vala"
	if (length >= 0) {
#line 634 "Animation.c"
		gchar** result;
		gssize i;
#line 9 "../src/Background/Animation.vala"
		result = g_new0 (gchar*, length + 1);
#line 9 "../src/Background/Animation.vala"
		for (i = 0; i < length; i++) {
#line 641 "Animation.c"
			gchar* _tmp0_;
#line 9 "../src/Background/Animation.vala"
			_tmp0_ = g_strdup (self[i]);
#line 9 "../src/Background/Animation.vala"
			result[i] = _tmp0_;
#line 647 "Animation.c"
		}
#line 9 "../src/Background/Animation.vala"
		return result;
#line 651 "Animation.c"
	}
#line 9 "../src/Background/Animation.vala"
	return NULL;
#line 655 "Animation.c"
}

static void
gala_animation_set_key_frame_files (GalaAnimation* self,
                                    gchar** value,
                                    gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 9 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/Background/Animation.vala"
	old_value = gala_animation_get_key_frame_files (self, &old_value_length);
#line 9 "../src/Background/Animation.vala"
	if (old_value != value) {
#line 671 "Animation.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 9 "../src/Background/Animation.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup3 (value, value_length1) : value;
#line 9 "../src/Background/Animation.vala"
		_tmp0__length1 = value_length1;
#line 9 "../src/Background/Animation.vala"
		self->priv->_key_frame_files = (_vala_array_free (self->priv->_key_frame_files, self->priv->_key_frame_files_length1, (GDestroyNotify) g_free), NULL);
#line 9 "../src/Background/Animation.vala"
		self->priv->_key_frame_files = _tmp0_;
#line 9 "../src/Background/Animation.vala"
		self->priv->_key_frame_files_length1 = _tmp0__length1;
#line 9 "../src/Background/Animation.vala"
		self->priv->__key_frame_files_size_ = self->priv->_key_frame_files_length1;
#line 9 "../src/Background/Animation.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_animation_properties[GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY]);
#line 688 "Animation.c"
	}
}

gdouble
gala_animation_get_transition_progress (GalaAnimation* self)
{
	gdouble result;
#line 10 "../src/Background/Animation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 10 "../src/Background/Animation.vala"
	result = self->priv->_transition_progress;
#line 10 "../src/Background/Animation.vala"
	return result;
#line 702 "Animation.c"
}

static void
gala_animation_set_transition_progress (GalaAnimation* self,
                                        gdouble value)
{
	gdouble old_value;
#line 10 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/Background/Animation.vala"
	old_value = gala_animation_get_transition_progress (self);
#line 10 "../src/Background/Animation.vala"
	if (old_value != value) {
#line 10 "../src/Background/Animation.vala"
		self->priv->_transition_progress = value;
#line 10 "../src/Background/Animation.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_animation_properties[GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY]);
#line 720 "Animation.c"
	}
}

gdouble
gala_animation_get_transition_duration (GalaAnimation* self)
{
	gdouble result;
#line 11 "../src/Background/Animation.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 11 "../src/Background/Animation.vala"
	result = self->priv->_transition_duration;
#line 11 "../src/Background/Animation.vala"
	return result;
#line 734 "Animation.c"
}

static void
gala_animation_set_transition_duration (GalaAnimation* self,
                                        gdouble value)
{
	gdouble old_value;
#line 11 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/Background/Animation.vala"
	old_value = gala_animation_get_transition_duration (self);
#line 11 "../src/Background/Animation.vala"
	if (old_value != value) {
#line 11 "../src/Background/Animation.vala"
		self->priv->_transition_duration = value;
#line 11 "../src/Background/Animation.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_animation_properties[GALA_ANIMATION_TRANSITION_DURATION_PROPERTY]);
#line 752 "Animation.c"
	}
}

gboolean
gala_animation_get_loaded (GalaAnimation* self)
{
	gboolean result;
#line 12 "../src/Background/Animation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../src/Background/Animation.vala"
	result = self->priv->_loaded;
#line 12 "../src/Background/Animation.vala"
	return result;
#line 766 "Animation.c"
}

static void
gala_animation_set_loaded (GalaAnimation* self,
                           gboolean value)
{
	gboolean old_value;
#line 12 "../src/Background/Animation.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/Background/Animation.vala"
	old_value = gala_animation_get_loaded (self);
#line 12 "../src/Background/Animation.vala"
	if (old_value != value) {
#line 12 "../src/Background/Animation.vala"
		self->priv->_loaded = value;
#line 12 "../src/Background/Animation.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_animation_properties[GALA_ANIMATION_LOADED_PROPERTY]);
#line 784 "Animation.c"
	}
}

static void
gala_animation_class_init (GalaAnimationClass * klass,
                           gpointer klass_data)
{
#line 7 "../src/Background/Animation.vala"
	gala_animation_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Background/Animation.vala"
	g_type_class_adjust_private_offset (klass, &GalaAnimation_private_offset);
#line 7 "../src/Background/Animation.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_animation_get_property;
#line 7 "../src/Background/Animation.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_animation_set_property;
#line 7 "../src/Background/Animation.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_animation_finalize;
#line 7 "../src/Background/Animation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_ANIMATION_FILENAME_PROPERTY, gala_animation_properties[GALA_ANIMATION_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../src/Background/Animation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY, gala_animation_properties[GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY] = g_param_spec_boxed ("key-frame-files", "key-frame-files", "key-frame-files", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/Background/Animation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY, gala_animation_properties[GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY] = g_param_spec_double ("transition-progress", "transition-progress", "transition-progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/Background/Animation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_ANIMATION_TRANSITION_DURATION_PROPERTY, gala_animation_properties[GALA_ANIMATION_TRANSITION_DURATION_PROPERTY] = g_param_spec_double ("transition-duration", "transition-duration", "transition-duration", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/Background/Animation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_ANIMATION_LOADED_PROPERTY, gala_animation_properties[GALA_ANIMATION_LOADED_PROPERTY] = g_param_spec_boolean ("loaded", "loaded", "loaded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 812 "Animation.c"
}

static void
gala_animation_instance_init (GalaAnimation * self,
                              gpointer klass)
{
	gchar** _tmp0_;
#line 7 "../src/Background/Animation.vala"
	self->priv = gala_animation_get_instance_private (self);
#line 9 "../src/Background/Animation.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 9 "../src/Background/Animation.vala"
	self->priv->_key_frame_files = _tmp0_;
#line 9 "../src/Background/Animation.vala"
	self->priv->_key_frame_files_length1 = 0;
#line 9 "../src/Background/Animation.vala"
	self->priv->__key_frame_files_size_ = self->priv->_key_frame_files_length1;
#line 10 "../src/Background/Animation.vala"
	self->priv->_transition_progress = 0.0;
#line 11 "../src/Background/Animation.vala"
	self->priv->_transition_duration = 0.0;
#line 12 "../src/Background/Animation.vala"
	self->priv->_loaded = FALSE;
#line 14 "../src/Background/Animation.vala"
	self->priv->show = NULL;
#line 838 "Animation.c"
}

static void
gala_animation_finalize (GObject * obj)
{
	GalaAnimation * self;
#line 7 "../src/Background/Animation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_ANIMATION, GalaAnimation);
#line 8 "../src/Background/Animation.vala"
	_g_free0 (self->priv->_filename);
#line 9 "../src/Background/Animation.vala"
	self->priv->_key_frame_files = (_vala_array_free (self->priv->_key_frame_files, self->priv->_key_frame_files_length1, (GDestroyNotify) g_free), NULL);
#line 14 "../src/Background/Animation.vala"
	_g_object_unref0 (self->priv->show);
#line 7 "../src/Background/Animation.vala"
	G_OBJECT_CLASS (gala_animation_parent_class)->finalize (obj);
#line 855 "Animation.c"
}

 G_GNUC_NO_INLINE static GType
gala_animation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaAnimation), 0, (GInstanceInitFunc) gala_animation_instance_init, NULL };
	GType gala_animation_type_id;
	gala_animation_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaAnimation", &g_define_type_info, 0);
	GalaAnimation_private_offset = g_type_add_instance_private (gala_animation_type_id, sizeof (GalaAnimationPrivate));
	return gala_animation_type_id;
}

GType
gala_animation_get_type (void)
{
	static gsize gala_animation_type_id__once = 0;
	if (g_once_init_enter (&gala_animation_type_id__once)) {
		GType gala_animation_type_id;
		gala_animation_type_id = gala_animation_get_type_once ();
		g_once_init_leave (&gala_animation_type_id__once, gala_animation_type_id);
	}
	return gala_animation_type_id__once;
}

static void
_vala_gala_animation_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	GalaAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_ANIMATION, GalaAnimation);
#line 7 "../src/Background/Animation.vala"
	switch (property_id) {
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_FILENAME_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		g_value_set_string (value, gala_animation_get_filename (self));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY:
#line 898 "Animation.c"
		{
			int length;
#line 7 "../src/Background/Animation.vala"
			g_value_set_boxed (value, gala_animation_get_key_frame_files (self, &length));
#line 903 "Animation.c"
		}
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		g_value_set_double (value, gala_animation_get_transition_progress (self));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_TRANSITION_DURATION_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		g_value_set_double (value, gala_animation_get_transition_duration (self));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_LOADED_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		g_value_set_boolean (value, gala_animation_get_loaded (self));
#line 7 "../src/Background/Animation.vala"
		break;
#line 925 "Animation.c"
		default:
#line 7 "../src/Background/Animation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Background/Animation.vala"
		break;
#line 931 "Animation.c"
	}
}

static void
_vala_gala_animation_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	GalaAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_ANIMATION, GalaAnimation);
#line 7 "../src/Background/Animation.vala"
	switch (property_id) {
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_FILENAME_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		gala_animation_set_filename (self, g_value_get_string (value));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_KEY_FRAME_FILES_PROPERTY:
#line 953 "Animation.c"
		{
			gpointer boxed;
#line 7 "../src/Background/Animation.vala"
			boxed = g_value_get_boxed (value);
#line 7 "../src/Background/Animation.vala"
			gala_animation_set_key_frame_files (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 960 "Animation.c"
		}
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_TRANSITION_PROGRESS_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		gala_animation_set_transition_progress (self, g_value_get_double (value));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_TRANSITION_DURATION_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		gala_animation_set_transition_duration (self, g_value_get_double (value));
#line 7 "../src/Background/Animation.vala"
		break;
#line 7 "../src/Background/Animation.vala"
		case GALA_ANIMATION_LOADED_PROPERTY:
#line 7 "../src/Background/Animation.vala"
		gala_animation_set_loaded (self, g_value_get_boolean (value));
#line 7 "../src/Background/Animation.vala"
		break;
#line 982 "Animation.c"
		default:
#line 7 "../src/Background/Animation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Background/Animation.vala"
		break;
#line 988 "Animation.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 21 "../src/PluginManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 999 "Animation.c"
		gssize i;
#line 21 "../src/PluginManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 21 "../src/PluginManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 21 "../src/PluginManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1007 "Animation.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 21 "../src/PluginManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 21 "../src/PluginManager.vala"
	g_free (array);
#line 1022 "Animation.c"
}

