/* GestureSettings.c generated by valac 0.56.17, the Vala compiler
 * generated from GestureSettings.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc (https://elementary.io)
 *           2021 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <clutter/clutter.h>
#include <glib.h>
#include <meta/common.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_SETTINGS (gala_gesture_settings_get_type ())
#define GALA_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettings))
#define GALA_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))
#define GALA_IS_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_IS_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_GESTURE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))

typedef struct _GalaGestureSettings GalaGestureSettings;
typedef struct _GalaGestureSettingsClass GalaGestureSettingsClass;
typedef struct _GalaGestureSettingsPrivate GalaGestureSettingsPrivate;
enum  {
	GALA_GESTURE_SETTINGS_0_PROPERTY,
	GALA_GESTURE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* gala_gesture_settings_properties[GALA_GESTURE_SETTINGS_NUM_PROPERTIES];
typedef enum  {
	GALA_GESTURE_SETTINGS_GESTURE_ACTION_NONE,
	GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WORKSPACE,
	GALA_GESTURE_SETTINGS_GESTURE_ACTION_MOVE_TO_WORKSPACE,
	GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WINDOWS,
	GALA_GESTURE_SETTINGS_GESTURE_ACTION_MULTITASKING_VIEW
} GalaGestureSettingsGestureAction;

#define GALA_GESTURE_SETTINGS_TYPE_GESTURE_ACTION (gala_gesture_settings_gesture_action_get_type ())

#define GALA_TYPE_GESTURE (gala_gesture_get_type ())
#define GALA_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE, GalaGesture))
#define GALA_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE, GalaGestureClass))
#define GALA_IS_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE))
#define GALA_IS_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE))
#define GALA_GESTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE, GalaGestureClass))

typedef struct _GalaGesture GalaGesture;
typedef struct _GalaGestureClass GalaGestureClass;
typedef struct _GalaGesturePrivate GalaGesturePrivate;
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GalaGestureSettings {
	GObject parent_instance;
	GalaGestureSettingsPrivate * priv;
};

struct _GalaGestureSettingsClass {
	GObjectClass parent_class;
};

struct _GalaGesture {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaGesturePrivate * priv;
	ClutterEventType type;
	GalaGestureDirection direction;
	gint fingers;
	ClutterInputDeviceType performed_on_device_type;
	gfloat origin_x;
	gfloat origin_y;
};

struct _GalaGestureClass {
	GTypeClass parent_class;
	void (*finalize) (GalaGesture *self);
};

static gpointer gala_gesture_settings_parent_class = NULL;
static GSettings* gala_gesture_settings_gala_settings;
static GSettings* gala_gesture_settings_gala_settings = NULL;
static GSettings* gala_gesture_settings_touchpad_settings;
static GSettings* gala_gesture_settings_touchpad_settings = NULL;

VALA_EXTERN GType gala_gesture_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureSettings, g_object_unref)
VALA_EXTERN GType gala_gesture_settings_gesture_action_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean gala_gesture_settings_is_natural_scroll_enabled (GalaGestureSettings* self,
                                                          ClutterInputDeviceType device_type);
VALA_EXTERN gpointer gala_gesture_ref (gpointer instance);
VALA_EXTERN void gala_gesture_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_gesture (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void gala_value_set_gesture (GValue* value,
                             gpointer v_object);
VALA_EXTERN void gala_value_take_gesture (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer gala_value_get_gesture (const GValue* value);
VALA_EXTERN GType gala_gesture_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGesture, gala_gesture_unref)
VALA_EXTERN MetaMotionDirection* gala_gesture_settings_get_direction (GalaGestureSettings* self,
                                                          GalaGesture* gesture);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
static MetaMotionDirection* _meta_motion_direction_dup (MetaMotionDirection* self);
VALA_EXTERN MetaMotionDirection* gala_gesture_settings_get_natural_scroll_direction (GalaGestureSettings* self,
                                                                         GalaGesture* gesture);
VALA_EXTERN gchar* gala_gesture_settings_get_string (const gchar* setting_id);
VALA_EXTERN GalaGestureSettingsGestureAction gala_gesture_settings_get_action (GalaGesture* gesture);
VALA_EXTERN GalaGestureSettings* gala_gesture_settings_new (void);
VALA_EXTERN GalaGestureSettings* gala_gesture_settings_construct (GType object_type);
static void gala_gesture_settings_finalize (GObject * obj);
static GType gala_gesture_settings_get_type_once (void);

 G_GNUC_NO_INLINE static GType
gala_gesture_settings_gesture_action_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_GESTURE_SETTINGS_GESTURE_ACTION_NONE, "GALA_GESTURE_SETTINGS_GESTURE_ACTION_NONE", "none"}, {GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WORKSPACE, "GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WORKSPACE", "switch-workspace"}, {GALA_GESTURE_SETTINGS_GESTURE_ACTION_MOVE_TO_WORKSPACE, "GALA_GESTURE_SETTINGS_GESTURE_ACTION_MOVE_TO_WORKSPACE", "move-to-workspace"}, {GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WINDOWS, "GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WINDOWS", "switch-windows"}, {GALA_GESTURE_SETTINGS_GESTURE_ACTION_MULTITASKING_VIEW, "GALA_GESTURE_SETTINGS_GESTURE_ACTION_MULTITASKING_VIEW", "multitasking-view"}, {0, NULL, NULL}};
	GType gala_gesture_settings_gesture_action_type_id;
	gala_gesture_settings_gesture_action_type_id = g_enum_register_static ("GalaGestureSettingsGestureAction", values);
	return gala_gesture_settings_gesture_action_type_id;
}

GType
gala_gesture_settings_gesture_action_get_type (void)
{
	static gsize gala_gesture_settings_gesture_action_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_settings_gesture_action_type_id__once)) {
		GType gala_gesture_settings_gesture_action_type_id;
		gala_gesture_settings_gesture_action_type_id = gala_gesture_settings_gesture_action_get_type_once ();
		g_once_init_leave (&gala_gesture_settings_gesture_action_type_id__once, gala_gesture_settings_gesture_action_type_id);
	}
	return gala_gesture_settings_gesture_action_type_id__once;
}

gboolean
gala_gesture_settings_is_natural_scroll_enabled (GalaGestureSettings* self,
                                                 ClutterInputDeviceType device_type)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 39 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Gestures/GestureSettings.vala"
	if (device_type == CLUTTER_TOUCHSCREEN_DEVICE) {
#line 41 "../src/Gestures/GestureSettings.vala"
		_tmp0_ = TRUE;
#line 197 "GestureSettings.c"
	} else {
		GSettings* _tmp1_;
#line 42 "../src/Gestures/GestureSettings.vala"
		_tmp1_ = gala_gesture_settings_touchpad_settings;
#line 42 "../src/Gestures/GestureSettings.vala"
		_tmp0_ = g_settings_get_boolean (_tmp1_, "natural-scroll");
#line 204 "GestureSettings.c"
	}
#line 40 "../src/Gestures/GestureSettings.vala"
	result = _tmp0_;
#line 40 "../src/Gestures/GestureSettings.vala"
	return result;
#line 210 "GestureSettings.c"
}

static MetaMotionDirection*
_meta_motion_direction_dup (MetaMotionDirection* self)
{
	MetaMotionDirection* dup;
#line 48 "../src/Gestures/GestureSettings.vala"
	dup = g_new0 (MetaMotionDirection, 1);
#line 48 "../src/Gestures/GestureSettings.vala"
	memcpy (dup, self, sizeof (MetaMotionDirection));
#line 48 "../src/Gestures/GestureSettings.vala"
	return dup;
#line 223 "GestureSettings.c"
}

static gpointer
__meta_motion_direction_dup0 (gpointer self)
{
#line 48 "../src/Gestures/GestureSettings.vala"
	return self ? _meta_motion_direction_dup (self) : NULL;
#line 231 "GestureSettings.c"
}

MetaMotionDirection*
gala_gesture_settings_get_direction (GalaGestureSettings* self,
                                     GalaGesture* gesture)
{
	MetaMotionDirection* result;
#line 45 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (gesture != NULL, NULL);
#line 46 "../src/Gestures/GestureSettings.vala"
	switch (gesture->direction) {
#line 46 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_UP:
#line 247 "GestureSettings.c"
		{
			MetaMotionDirection _tmp0_;
			MetaMotionDirection* _tmp1_;
#line 48 "../src/Gestures/GestureSettings.vala"
			_tmp0_ = META_MOTION_UP;
#line 48 "../src/Gestures/GestureSettings.vala"
			_tmp1_ = __meta_motion_direction_dup0 (&_tmp0_);
#line 48 "../src/Gestures/GestureSettings.vala"
			result = _tmp1_;
#line 48 "../src/Gestures/GestureSettings.vala"
			return result;
#line 259 "GestureSettings.c"
		}
#line 46 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_DOWN:
#line 263 "GestureSettings.c"
		{
			MetaMotionDirection _tmp2_;
			MetaMotionDirection* _tmp3_;
#line 50 "../src/Gestures/GestureSettings.vala"
			_tmp2_ = META_MOTION_DOWN;
#line 50 "../src/Gestures/GestureSettings.vala"
			_tmp3_ = __meta_motion_direction_dup0 (&_tmp2_);
#line 50 "../src/Gestures/GestureSettings.vala"
			result = _tmp3_;
#line 50 "../src/Gestures/GestureSettings.vala"
			return result;
#line 275 "GestureSettings.c"
		}
#line 46 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_LEFT:
#line 279 "GestureSettings.c"
		{
			MetaMotionDirection _tmp4_;
			MetaMotionDirection* _tmp5_;
#line 52 "../src/Gestures/GestureSettings.vala"
			_tmp4_ = META_MOTION_LEFT;
#line 52 "../src/Gestures/GestureSettings.vala"
			_tmp5_ = __meta_motion_direction_dup0 (&_tmp4_);
#line 52 "../src/Gestures/GestureSettings.vala"
			result = _tmp5_;
#line 52 "../src/Gestures/GestureSettings.vala"
			return result;
#line 291 "GestureSettings.c"
		}
#line 46 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_RIGHT:
#line 295 "GestureSettings.c"
		{
			MetaMotionDirection _tmp6_;
			MetaMotionDirection* _tmp7_;
#line 54 "../src/Gestures/GestureSettings.vala"
			_tmp6_ = META_MOTION_RIGHT;
#line 54 "../src/Gestures/GestureSettings.vala"
			_tmp7_ = __meta_motion_direction_dup0 (&_tmp6_);
#line 54 "../src/Gestures/GestureSettings.vala"
			result = _tmp7_;
#line 54 "../src/Gestures/GestureSettings.vala"
			return result;
#line 307 "GestureSettings.c"
		}
		default:
		{
#line 56 "../src/Gestures/GestureSettings.vala"
			result = NULL;
#line 56 "../src/Gestures/GestureSettings.vala"
			return result;
#line 315 "GestureSettings.c"
		}
	}
}

MetaMotionDirection*
gala_gesture_settings_get_natural_scroll_direction (GalaGestureSettings* self,
                                                    GalaGesture* gesture)
{
	gboolean natural_scroll = FALSE;
	MetaMotionDirection* result;
#line 60 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (gesture != NULL, NULL);
#line 61 "../src/Gestures/GestureSettings.vala"
	natural_scroll = gala_gesture_settings_is_natural_scroll_enabled (self, gesture->performed_on_device_type);
#line 63 "../src/Gestures/GestureSettings.vala"
	switch (gesture->direction) {
#line 63 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_UP:
#line 336 "GestureSettings.c"
		{
			MetaMotionDirection _tmp0_ = 0;
			MetaMotionDirection* _tmp1_;
#line 65 "../src/Gestures/GestureSettings.vala"
			if (natural_scroll) {
#line 65 "../src/Gestures/GestureSettings.vala"
				_tmp0_ = META_MOTION_DOWN;
#line 344 "GestureSettings.c"
			} else {
#line 65 "../src/Gestures/GestureSettings.vala"
				_tmp0_ = META_MOTION_UP;
#line 348 "GestureSettings.c"
			}
#line 65 "../src/Gestures/GestureSettings.vala"
			_tmp1_ = __meta_motion_direction_dup0 (&_tmp0_);
#line 65 "../src/Gestures/GestureSettings.vala"
			result = _tmp1_;
#line 65 "../src/Gestures/GestureSettings.vala"
			return result;
#line 356 "GestureSettings.c"
		}
#line 63 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_DOWN:
#line 360 "GestureSettings.c"
		{
			MetaMotionDirection _tmp2_ = 0;
			MetaMotionDirection* _tmp3_;
#line 67 "../src/Gestures/GestureSettings.vala"
			if (natural_scroll) {
#line 67 "../src/Gestures/GestureSettings.vala"
				_tmp2_ = META_MOTION_UP;
#line 368 "GestureSettings.c"
			} else {
#line 67 "../src/Gestures/GestureSettings.vala"
				_tmp2_ = META_MOTION_DOWN;
#line 372 "GestureSettings.c"
			}
#line 67 "../src/Gestures/GestureSettings.vala"
			_tmp3_ = __meta_motion_direction_dup0 (&_tmp2_);
#line 67 "../src/Gestures/GestureSettings.vala"
			result = _tmp3_;
#line 67 "../src/Gestures/GestureSettings.vala"
			return result;
#line 380 "GestureSettings.c"
		}
#line 63 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_LEFT:
#line 384 "GestureSettings.c"
		{
			MetaMotionDirection _tmp4_ = 0;
			MetaMotionDirection* _tmp5_;
#line 69 "../src/Gestures/GestureSettings.vala"
			if (natural_scroll) {
#line 69 "../src/Gestures/GestureSettings.vala"
				_tmp4_ = META_MOTION_RIGHT;
#line 392 "GestureSettings.c"
			} else {
#line 69 "../src/Gestures/GestureSettings.vala"
				_tmp4_ = META_MOTION_LEFT;
#line 396 "GestureSettings.c"
			}
#line 69 "../src/Gestures/GestureSettings.vala"
			_tmp5_ = __meta_motion_direction_dup0 (&_tmp4_);
#line 69 "../src/Gestures/GestureSettings.vala"
			result = _tmp5_;
#line 69 "../src/Gestures/GestureSettings.vala"
			return result;
#line 404 "GestureSettings.c"
		}
#line 63 "../src/Gestures/GestureSettings.vala"
		case GALA_GESTURE_DIRECTION_RIGHT:
#line 408 "GestureSettings.c"
		{
			MetaMotionDirection _tmp6_ = 0;
			MetaMotionDirection* _tmp7_;
#line 71 "../src/Gestures/GestureSettings.vala"
			if (natural_scroll) {
#line 71 "../src/Gestures/GestureSettings.vala"
				_tmp6_ = META_MOTION_LEFT;
#line 416 "GestureSettings.c"
			} else {
#line 71 "../src/Gestures/GestureSettings.vala"
				_tmp6_ = META_MOTION_RIGHT;
#line 420 "GestureSettings.c"
			}
#line 71 "../src/Gestures/GestureSettings.vala"
			_tmp7_ = __meta_motion_direction_dup0 (&_tmp6_);
#line 71 "../src/Gestures/GestureSettings.vala"
			result = _tmp7_;
#line 71 "../src/Gestures/GestureSettings.vala"
			return result;
#line 428 "GestureSettings.c"
		}
		default:
		{
#line 73 "../src/Gestures/GestureSettings.vala"
			result = NULL;
#line 73 "../src/Gestures/GestureSettings.vala"
			return result;
#line 436 "GestureSettings.c"
		}
	}
}

gchar*
gala_gesture_settings_get_string (const gchar* setting_id)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 77 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (setting_id != NULL, NULL);
#line 78 "../src/Gestures/GestureSettings.vala"
	_tmp0_ = gala_gesture_settings_gala_settings;
#line 78 "../src/Gestures/GestureSettings.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, setting_id);
#line 78 "../src/Gestures/GestureSettings.vala"
	result = _tmp1_;
#line 78 "../src/Gestures/GestureSettings.vala"
	return result;
#line 457 "GestureSettings.c"
}

GalaGestureSettingsGestureAction
gala_gesture_settings_get_action (GalaGesture* gesture)
{
	GalaGestureSettingsGestureAction result;
#line 81 "../src/Gestures/GestureSettings.vala"
	g_return_val_if_fail (gesture != NULL, 0);
#line 82 "../src/Gestures/GestureSettings.vala"
	if (gesture->type == CLUTTER_TOUCHPAD_SWIPE) {
#line 468 "GestureSettings.c"
		gint fingers = 0;
		gboolean _tmp0_ = FALSE;
#line 83 "../src/Gestures/GestureSettings.vala"
		fingers = gesture->fingers;
#line 85 "../src/Gestures/GestureSettings.vala"
		if (gesture->direction == GALA_GESTURE_DIRECTION_LEFT) {
#line 85 "../src/Gestures/GestureSettings.vala"
			_tmp0_ = TRUE;
#line 477 "GestureSettings.c"
		} else {
#line 85 "../src/Gestures/GestureSettings.vala"
			_tmp0_ = gesture->direction == GALA_GESTURE_DIRECTION_RIGHT;
#line 481 "GestureSettings.c"
		}
#line 85 "../src/Gestures/GestureSettings.vala"
		if (_tmp0_) {
#line 485 "GestureSettings.c"
			gchar* three_finger_swipe_horizontal = NULL;
			gchar* _tmp1_;
			gchar* four_finger_swipe_horizontal = NULL;
			gchar* _tmp2_;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
#line 86 "../src/Gestures/GestureSettings.vala"
			_tmp1_ = gala_gesture_settings_get_string ("three-finger-swipe-horizontal");
#line 86 "../src/Gestures/GestureSettings.vala"
			three_finger_swipe_horizontal = _tmp1_;
#line 87 "../src/Gestures/GestureSettings.vala"
			_tmp2_ = gala_gesture_settings_get_string ("four-finger-swipe-horizontal");
#line 87 "../src/Gestures/GestureSettings.vala"
			four_finger_swipe_horizontal = _tmp2_;
#line 89 "../src/Gestures/GestureSettings.vala"
			if (fingers == 3) {
#line 506 "GestureSettings.c"
				const gchar* _tmp5_;
#line 89 "../src/Gestures/GestureSettings.vala"
				_tmp5_ = three_finger_swipe_horizontal;
#line 89 "../src/Gestures/GestureSettings.vala"
				_tmp4_ = g_strcmp0 (_tmp5_, "switch-to-workspace") == 0;
#line 512 "GestureSettings.c"
			} else {
#line 89 "../src/Gestures/GestureSettings.vala"
				_tmp4_ = FALSE;
#line 516 "GestureSettings.c"
			}
#line 89 "../src/Gestures/GestureSettings.vala"
			if (_tmp4_) {
#line 89 "../src/Gestures/GestureSettings.vala"
				_tmp3_ = TRUE;
#line 522 "GestureSettings.c"
			} else {
				gboolean _tmp6_ = FALSE;
#line 90 "../src/Gestures/GestureSettings.vala"
				if (fingers == 4) {
#line 527 "GestureSettings.c"
					const gchar* _tmp7_;
#line 90 "../src/Gestures/GestureSettings.vala"
					_tmp7_ = four_finger_swipe_horizontal;
#line 90 "../src/Gestures/GestureSettings.vala"
					_tmp6_ = g_strcmp0 (_tmp7_, "switch-to-workspace") == 0;
#line 533 "GestureSettings.c"
				} else {
#line 90 "../src/Gestures/GestureSettings.vala"
					_tmp6_ = FALSE;
#line 537 "GestureSettings.c"
				}
#line 90 "../src/Gestures/GestureSettings.vala"
				_tmp3_ = _tmp6_;
#line 541 "GestureSettings.c"
			}
#line 89 "../src/Gestures/GestureSettings.vala"
			if (_tmp3_) {
#line 91 "../src/Gestures/GestureSettings.vala"
				result = GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WORKSPACE;
#line 91 "../src/Gestures/GestureSettings.vala"
				_g_free0 (four_finger_swipe_horizontal);
#line 91 "../src/Gestures/GestureSettings.vala"
				_g_free0 (three_finger_swipe_horizontal);
#line 91 "../src/Gestures/GestureSettings.vala"
				return result;
#line 553 "GestureSettings.c"
			}
#line 94 "../src/Gestures/GestureSettings.vala"
			if (fingers == 3) {
#line 557 "GestureSettings.c"
				const gchar* _tmp10_;
#line 94 "../src/Gestures/GestureSettings.vala"
				_tmp10_ = three_finger_swipe_horizontal;
#line 94 "../src/Gestures/GestureSettings.vala"
				_tmp9_ = g_strcmp0 (_tmp10_, "move-to-workspace") == 0;
#line 563 "GestureSettings.c"
			} else {
#line 94 "../src/Gestures/GestureSettings.vala"
				_tmp9_ = FALSE;
#line 567 "GestureSettings.c"
			}
#line 94 "../src/Gestures/GestureSettings.vala"
			if (_tmp9_) {
#line 94 "../src/Gestures/GestureSettings.vala"
				_tmp8_ = TRUE;
#line 573 "GestureSettings.c"
			} else {
				gboolean _tmp11_ = FALSE;
#line 95 "../src/Gestures/GestureSettings.vala"
				if (fingers == 4) {
#line 578 "GestureSettings.c"
					const gchar* _tmp12_;
#line 95 "../src/Gestures/GestureSettings.vala"
					_tmp12_ = four_finger_swipe_horizontal;
#line 95 "../src/Gestures/GestureSettings.vala"
					_tmp11_ = g_strcmp0 (_tmp12_, "move-to-workspace") == 0;
#line 584 "GestureSettings.c"
				} else {
#line 95 "../src/Gestures/GestureSettings.vala"
					_tmp11_ = FALSE;
#line 588 "GestureSettings.c"
				}
#line 95 "../src/Gestures/GestureSettings.vala"
				_tmp8_ = _tmp11_;
#line 592 "GestureSettings.c"
			}
#line 94 "../src/Gestures/GestureSettings.vala"
			if (_tmp8_) {
#line 96 "../src/Gestures/GestureSettings.vala"
				result = GALA_GESTURE_SETTINGS_GESTURE_ACTION_MOVE_TO_WORKSPACE;
#line 96 "../src/Gestures/GestureSettings.vala"
				_g_free0 (four_finger_swipe_horizontal);
#line 96 "../src/Gestures/GestureSettings.vala"
				_g_free0 (three_finger_swipe_horizontal);
#line 96 "../src/Gestures/GestureSettings.vala"
				return result;
#line 604 "GestureSettings.c"
			}
#line 100 "../src/Gestures/GestureSettings.vala"
			if (fingers == 3) {
#line 608 "GestureSettings.c"
				const gchar* _tmp15_;
#line 100 "../src/Gestures/GestureSettings.vala"
				_tmp15_ = three_finger_swipe_horizontal;
#line 100 "../src/Gestures/GestureSettings.vala"
				_tmp14_ = g_strcmp0 (_tmp15_, "switch-windows") == 0;
#line 614 "GestureSettings.c"
			} else {
#line 100 "../src/Gestures/GestureSettings.vala"
				_tmp14_ = FALSE;
#line 618 "GestureSettings.c"
			}
#line 100 "../src/Gestures/GestureSettings.vala"
			if (_tmp14_) {
#line 100 "../src/Gestures/GestureSettings.vala"
				_tmp13_ = TRUE;
#line 624 "GestureSettings.c"
			} else {
				gboolean _tmp16_ = FALSE;
#line 101 "../src/Gestures/GestureSettings.vala"
				if (fingers == 4) {
#line 629 "GestureSettings.c"
					const gchar* _tmp17_;
#line 101 "../src/Gestures/GestureSettings.vala"
					_tmp17_ = four_finger_swipe_horizontal;
#line 101 "../src/Gestures/GestureSettings.vala"
					_tmp16_ = g_strcmp0 (_tmp17_, "switch-windows") == 0;
#line 635 "GestureSettings.c"
				} else {
#line 101 "../src/Gestures/GestureSettings.vala"
					_tmp16_ = FALSE;
#line 639 "GestureSettings.c"
				}
#line 101 "../src/Gestures/GestureSettings.vala"
				_tmp13_ = _tmp16_;
#line 643 "GestureSettings.c"
			}
#line 100 "../src/Gestures/GestureSettings.vala"
			if (_tmp13_) {
#line 102 "../src/Gestures/GestureSettings.vala"
				result = GALA_GESTURE_SETTINGS_GESTURE_ACTION_SWITCH_WINDOWS;
#line 102 "../src/Gestures/GestureSettings.vala"
				_g_free0 (four_finger_swipe_horizontal);
#line 102 "../src/Gestures/GestureSettings.vala"
				_g_free0 (three_finger_swipe_horizontal);
#line 102 "../src/Gestures/GestureSettings.vala"
				return result;
#line 655 "GestureSettings.c"
			}
#line 85 "../src/Gestures/GestureSettings.vala"
			_g_free0 (four_finger_swipe_horizontal);
#line 85 "../src/Gestures/GestureSettings.vala"
			_g_free0 (three_finger_swipe_horizontal);
#line 661 "GestureSettings.c"
		} else {
			gboolean _tmp18_ = FALSE;
#line 104 "../src/Gestures/GestureSettings.vala"
			if (gesture->direction == GALA_GESTURE_DIRECTION_UP) {
#line 104 "../src/Gestures/GestureSettings.vala"
				_tmp18_ = TRUE;
#line 668 "GestureSettings.c"
			} else {
#line 104 "../src/Gestures/GestureSettings.vala"
				_tmp18_ = gesture->direction == GALA_GESTURE_DIRECTION_DOWN;
#line 672 "GestureSettings.c"
			}
#line 104 "../src/Gestures/GestureSettings.vala"
			if (_tmp18_) {
#line 676 "GestureSettings.c"
				gchar* three_finger_swipe_up = NULL;
				gchar* _tmp19_;
				gchar* four_finger_swipe_up = NULL;
				gchar* _tmp20_;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
#line 105 "../src/Gestures/GestureSettings.vala"
				_tmp19_ = gala_gesture_settings_get_string ("three-finger-swipe-up");
#line 105 "../src/Gestures/GestureSettings.vala"
				three_finger_swipe_up = _tmp19_;
#line 106 "../src/Gestures/GestureSettings.vala"
				_tmp20_ = gala_gesture_settings_get_string ("four-finger-swipe-up");
#line 106 "../src/Gestures/GestureSettings.vala"
				four_finger_swipe_up = _tmp20_;
#line 108 "../src/Gestures/GestureSettings.vala"
				if (fingers == 3) {
#line 693 "GestureSettings.c"
					const gchar* _tmp23_;
#line 108 "../src/Gestures/GestureSettings.vala"
					_tmp23_ = three_finger_swipe_up;
#line 108 "../src/Gestures/GestureSettings.vala"
					_tmp22_ = g_strcmp0 (_tmp23_, "multitasking-view") == 0;
#line 699 "GestureSettings.c"
				} else {
#line 108 "../src/Gestures/GestureSettings.vala"
					_tmp22_ = FALSE;
#line 703 "GestureSettings.c"
				}
#line 108 "../src/Gestures/GestureSettings.vala"
				if (_tmp22_) {
#line 108 "../src/Gestures/GestureSettings.vala"
					_tmp21_ = TRUE;
#line 709 "GestureSettings.c"
				} else {
					gboolean _tmp24_ = FALSE;
#line 109 "../src/Gestures/GestureSettings.vala"
					if (fingers == 4) {
#line 714 "GestureSettings.c"
						const gchar* _tmp25_;
#line 109 "../src/Gestures/GestureSettings.vala"
						_tmp25_ = four_finger_swipe_up;
#line 109 "../src/Gestures/GestureSettings.vala"
						_tmp24_ = g_strcmp0 (_tmp25_, "multitasking-view") == 0;
#line 720 "GestureSettings.c"
					} else {
#line 109 "../src/Gestures/GestureSettings.vala"
						_tmp24_ = FALSE;
#line 724 "GestureSettings.c"
					}
#line 109 "../src/Gestures/GestureSettings.vala"
					_tmp21_ = _tmp24_;
#line 728 "GestureSettings.c"
				}
#line 108 "../src/Gestures/GestureSettings.vala"
				if (_tmp21_) {
#line 110 "../src/Gestures/GestureSettings.vala"
					result = GALA_GESTURE_SETTINGS_GESTURE_ACTION_MULTITASKING_VIEW;
#line 110 "../src/Gestures/GestureSettings.vala"
					_g_free0 (four_finger_swipe_up);
#line 110 "../src/Gestures/GestureSettings.vala"
					_g_free0 (three_finger_swipe_up);
#line 110 "../src/Gestures/GestureSettings.vala"
					return result;
#line 740 "GestureSettings.c"
				}
#line 104 "../src/Gestures/GestureSettings.vala"
				_g_free0 (four_finger_swipe_up);
#line 104 "../src/Gestures/GestureSettings.vala"
				_g_free0 (three_finger_swipe_up);
#line 746 "GestureSettings.c"
			}
		}
	}
#line 115 "../src/Gestures/GestureSettings.vala"
	result = GALA_GESTURE_SETTINGS_GESTURE_ACTION_NONE;
#line 115 "../src/Gestures/GestureSettings.vala"
	return result;
#line 754 "GestureSettings.c"
}

GalaGestureSettings*
gala_gesture_settings_construct (GType object_type)
{
	GalaGestureSettings * self = NULL;
#line 22 "../src/Gestures/GestureSettings.vala"
	self = (GalaGestureSettings*) g_object_new (object_type, NULL);
#line 22 "../src/Gestures/GestureSettings.vala"
	return self;
#line 765 "GestureSettings.c"
}

GalaGestureSettings*
gala_gesture_settings_new (void)
{
#line 22 "../src/Gestures/GestureSettings.vala"
	return gala_gesture_settings_construct (GALA_TYPE_GESTURE_SETTINGS);
#line 773 "GestureSettings.c"
}

static void
gala_gesture_settings_class_init (GalaGestureSettingsClass * klass,
                                  gpointer klass_data)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 22 "../src/Gestures/GestureSettings.vala"
	gala_gesture_settings_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Gestures/GestureSettings.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_gesture_settings_finalize;
#line 35 "../src/Gestures/GestureSettings.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wm.gestures");
#line 35 "../src/Gestures/GestureSettings.vala"
	_g_object_unref0 (gala_gesture_settings_gala_settings);
#line 35 "../src/Gestures/GestureSettings.vala"
	gala_gesture_settings_gala_settings = _tmp0_;
#line 36 "../src/Gestures/GestureSettings.vala"
	_tmp1_ = g_settings_new ("org.gnome.desktop.peripherals.touchpad");
#line 36 "../src/Gestures/GestureSettings.vala"
	_g_object_unref0 (gala_gesture_settings_touchpad_settings);
#line 36 "../src/Gestures/GestureSettings.vala"
	gala_gesture_settings_touchpad_settings = _tmp1_;
#line 798 "GestureSettings.c"
}

static void
gala_gesture_settings_instance_init (GalaGestureSettings * self,
                                     gpointer klass)
{
}

static void
gala_gesture_settings_finalize (GObject * obj)
{
	GalaGestureSettings * self;
#line 22 "../src/Gestures/GestureSettings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettings);
#line 22 "../src/Gestures/GestureSettings.vala"
	G_OBJECT_CLASS (gala_gesture_settings_parent_class)->finalize (obj);
#line 815 "GestureSettings.c"
}

/**
 * Utility class to access the gesture settings. Easily accessible through GestureTracker.settings.
 */
 G_GNUC_NO_INLINE static GType
gala_gesture_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaGestureSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_gesture_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaGestureSettings), 0, (GInstanceInitFunc) gala_gesture_settings_instance_init, NULL };
	GType gala_gesture_settings_type_id;
	gala_gesture_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaGestureSettings", &g_define_type_info, 0);
	return gala_gesture_settings_type_id;
}

GType
gala_gesture_settings_get_type (void)
{
	static gsize gala_gesture_settings_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_settings_type_id__once)) {
		GType gala_gesture_settings_type_id;
		gala_gesture_settings_type_id = gala_gesture_settings_get_type_once ();
		g_once_init_leave (&gala_gesture_settings_type_id__once, gala_gesture_settings_type_id);
	}
	return gala_gesture_settings_type_id__once;
}

