/* ToucheggBackend.c generated by valac 0.56.17, the Vala compiler
 * generated from ToucheggBackend.vala, do not modify */

/*
 * Copyright 2020 - 2021 elementary, Inc (https://elementary.io)
 *           2020 - 2021 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <meta/common.h>
#include <clutter/clutter.h>

#define GALA_TOUCHEGG_BACKEND_DBUS_ADDRESS "unix:abstract=touchegg"
#define GALA_TOUCHEGG_BACKEND_DBUS_INTERFACE_NAME "io.github.joseexposito.Touchegg"
#define GALA_TOUCHEGG_BACKEND_DBUS_OBJECT_PATH "/io/github/joseexposito/Touchegg"
#define GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_BEGIN "OnGestureBegin"
#define GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_UPDATE "OnGestureUpdate"
#define GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_END "OnGestureEnd"
#define GALA_TOUCHEGG_BACKEND_MAX_RECONNECTION_ATTEMPTS 10
#define GALA_TOUCHEGG_BACKEND_RECONNECTION_USLEEP_TIME 5000000
#define GALA_TOUCHEGG_BACKEND_DELTA_MULTIPLIER 0.01
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_BACKEND (gala_gesture_backend_get_type ())
#define GALA_GESTURE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_BACKEND, GalaGestureBackend))
#define GALA_IS_GESTURE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_BACKEND))
#define GALA_GESTURE_BACKEND_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_BACKEND, GalaGestureBackendIface))

typedef struct _GalaGestureBackend GalaGestureBackend;
typedef struct _GalaGestureBackendIface GalaGestureBackendIface;

#define GALA_TYPE_TOUCHEGG_BACKEND (gala_touchegg_backend_get_type ())
#define GALA_TOUCHEGG_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackend))
#define GALA_TOUCHEGG_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackendClass))
#define GALA_IS_TOUCHEGG_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_TOUCHEGG_BACKEND))
#define GALA_IS_TOUCHEGG_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_TOUCHEGG_BACKEND))
#define GALA_TOUCHEGG_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackendClass))

typedef struct _GalaToucheggBackend GalaToucheggBackend;
typedef struct _GalaToucheggBackendClass GalaToucheggBackendClass;
typedef struct _GalaToucheggBackendPrivate GalaToucheggBackendPrivate;
enum  {
	GALA_TOUCHEGG_BACKEND_0_PROPERTY,
	GALA_TOUCHEGG_BACKEND_NUM_PROPERTIES
};
static GParamSpec* gala_touchegg_backend_properties[GALA_TOUCHEGG_BACKEND_NUM_PROPERTIES];
typedef enum  {
	GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_NOT_SUPPORTED = 0,
	GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_SWIPE = 1,
	GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_PINCH = 2
} GalaToucheggBackendGestureType;

#define GALA_TOUCHEGG_BACKEND_TYPE_GESTURE_TYPE (gala_touchegg_backend_gesture_type_get_type ())
typedef enum  {
	GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_UNKNOWN = 0,
	GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHPAD = 1,
	GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHSCREEN = 2
} GalaToucheggBackendDeviceType;

#define GALA_TOUCHEGG_BACKEND_TYPE_DEVICE_TYPE (gala_touchegg_backend_device_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())
typedef struct _Block62Data Block62Data;

#define GALA_TYPE_GESTURE (gala_gesture_get_type ())
#define GALA_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE, GalaGesture))
#define GALA_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE, GalaGestureClass))
#define GALA_IS_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE))
#define GALA_IS_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE))
#define GALA_GESTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE, GalaGestureClass))

typedef struct _GalaGesture GalaGesture;
typedef struct _GalaGestureClass GalaGestureClass;
#define _gala_gesture_unref0(var) ((var == NULL) ? NULL : (var = (gala_gesture_unref (var), NULL)))
typedef struct _GalaGesturePrivate GalaGesturePrivate;

struct _GalaGestureBackendIface {
	GTypeInterface parent_iface;
	void (*prepare_gesture_handling) (GalaGestureBackend* self);
};

struct _GalaToucheggBackend {
	GObject parent_instance;
	GalaToucheggBackendPrivate * priv;
};

struct _GalaToucheggBackendClass {
	GObjectClass parent_class;
};

struct _GalaToucheggBackendPrivate {
	GDBusConnection* connection;
	gint reconnection_attempts;
	gchar* last_signal_received;
	GVariant* last_params_received;
};

struct _Block62Data {
	int _ref_count_;
	GalaToucheggBackend* self;
	GalaToucheggBackendGestureType type;
	GalaGestureDirection direction;
	gint fingers;
	GalaToucheggBackendDeviceType performed_on_device_type;
	guint64 elapsed_time;
	gdouble delta;
};

struct _GalaGesture {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaGesturePrivate * priv;
	ClutterEventType type;
	GalaGestureDirection direction;
	gint fingers;
	ClutterInputDeviceType performed_on_device_type;
	gfloat origin_x;
	gfloat origin_y;
};

struct _GalaGestureClass {
	GTypeClass parent_class;
	void (*finalize) (GalaGesture *self);
};

static gint GalaToucheggBackend_private_offset;
static gpointer gala_touchegg_backend_parent_class = NULL;
static GalaToucheggBackend* gala_touchegg_backend_instance;
static GalaToucheggBackend* gala_touchegg_backend_instance = NULL;
static GalaGestureBackendIface * gala_touchegg_backend_gala_gesture_backend_parent_iface = NULL;

VALA_EXTERN GType gala_gesture_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureBackend, g_object_unref)
VALA_EXTERN GType gala_touchegg_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaToucheggBackend, g_object_unref)
static GType gala_touchegg_backend_gesture_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType gala_touchegg_backend_device_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GalaToucheggBackend* gala_touchegg_backend_get_default (void);
VALA_EXTERN GalaToucheggBackend* gala_touchegg_backend_new (void);
VALA_EXTERN GalaToucheggBackend* gala_touchegg_backend_construct (GType object_type);
static void gala_touchegg_backend_stablish_connection (GalaToucheggBackend* self);
static void __lambda6_ (GalaToucheggBackend* self);
static void gala_touchegg_backend_on_new_message (GDBusConnection* connection,
                                           const gchar* sender_name,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* signal_name,
                                           GVariant* parameters,
                                           GalaToucheggBackend* self);
static void gala_touchegg_backend_on_disconnected (GalaToucheggBackend* self,
                                            gboolean remote_peer_vanished,
                                            GError* _error_);
static void _gala_touchegg_backend_on_disconnected_g_dbus_connection_closed (GDBusConnection* _sender,
                                                                      gboolean remote_peer_vanished,
                                                                      GError* _error_,
                                                                      gpointer self);
static gpointer ___lambda6__gthread_func (gpointer self);
VALA_EXTERN void gala_touchegg_backend_stop (GalaToucheggBackend* self);
static void gala_touchegg_backend_emit_event (GalaToucheggBackend* self,
                                       const gchar* signal_name,
                                       GVariant* signal_params);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static gboolean ___lambda7_ (Block62Data* _data62_);
VALA_EXTERN gpointer gala_gesture_ref (gpointer instance);
VALA_EXTERN void gala_gesture_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_gesture (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void gala_value_set_gesture (GValue* value,
                             gpointer v_object);
VALA_EXTERN void gala_value_take_gesture (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer gala_value_get_gesture (const GValue* value);
VALA_EXTERN GType gala_gesture_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGesture, gala_gesture_unref)
static GalaGesture* gala_touchegg_backend_make_gesture (GalaToucheggBackendGestureType type,
                                                 GalaGestureDirection direction,
                                                 gint fingers,
                                                 GalaToucheggBackendDeviceType performed_on_device_type);
static gboolean ____lambda7__gsource_func (gpointer self);
static gboolean ___lambda8_ (Block62Data* _data62_);
static gboolean ____lambda8__gsource_func (gpointer self);
static gboolean ___lambda9_ (Block62Data* _data62_);
static gboolean ____lambda9__gsource_func (gpointer self);
VALA_EXTERN GalaGesture* gala_gesture_new (void);
VALA_EXTERN GalaGesture* gala_gesture_construct (GType object_type);
static void gala_touchegg_backend_finalize (GObject * obj);
static GType gala_touchegg_backend_get_type_once (void);

static inline gpointer
gala_touchegg_backend_get_instance_private (GalaToucheggBackend* self)
{
	return G_STRUCT_MEMBER_P (self, GalaToucheggBackend_private_offset);
}

/**
     * Gesture type as returned by the daemon.
     */
 G_GNUC_NO_INLINE static GType
gala_touchegg_backend_gesture_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_NOT_SUPPORTED, "GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_NOT_SUPPORTED", "not-supported"}, {GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_SWIPE, "GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_SWIPE", "swipe"}, {GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_PINCH, "GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_PINCH", "pinch"}, {0, NULL, NULL}};
	GType gala_touchegg_backend_gesture_type_type_id;
	gala_touchegg_backend_gesture_type_type_id = g_enum_register_static ("GalaToucheggBackendGestureType", values);
	return gala_touchegg_backend_gesture_type_type_id;
}

static GType
gala_touchegg_backend_gesture_type_get_type (void)
{
	static gsize gala_touchegg_backend_gesture_type_type_id__once = 0;
	if (g_once_init_enter (&gala_touchegg_backend_gesture_type_type_id__once)) {
		GType gala_touchegg_backend_gesture_type_type_id;
		gala_touchegg_backend_gesture_type_type_id = gala_touchegg_backend_gesture_type_get_type_once ();
		g_once_init_leave (&gala_touchegg_backend_gesture_type_type_id__once, gala_touchegg_backend_gesture_type_type_id);
	}
	return gala_touchegg_backend_gesture_type_type_id__once;
}

/**
     * Device type as returned by the daemon.
     */
 G_GNUC_NO_INLINE static GType
gala_touchegg_backend_device_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_UNKNOWN, "GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_UNKNOWN", "unknown"}, {GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHPAD, "GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHPAD", "touchpad"}, {GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHSCREEN, "GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHSCREEN", "touchscreen"}, {0, NULL, NULL}};
	GType gala_touchegg_backend_device_type_type_id;
	gala_touchegg_backend_device_type_type_id = g_enum_register_static ("GalaToucheggBackendDeviceType", values);
	return gala_touchegg_backend_device_type_type_id;
}

static GType
gala_touchegg_backend_device_type_get_type (void)
{
	static gsize gala_touchegg_backend_device_type_type_id__once = 0;
	if (g_once_init_enter (&gala_touchegg_backend_device_type_type_id__once)) {
		GType gala_touchegg_backend_device_type_type_id;
		gala_touchegg_backend_device_type_type_id = gala_touchegg_backend_device_type_get_type_once ();
		g_once_init_leave (&gala_touchegg_backend_device_type_type_id__once, gala_touchegg_backend_device_type_type_id);
	}
	return gala_touchegg_backend_device_type_type_id__once;
}

/**
     * @return Single instance of the class.
     */
GalaToucheggBackend*
gala_touchegg_backend_get_default (void)
{
	GalaToucheggBackend* _tmp0_;
	GalaToucheggBackend* _tmp3_;
	GalaToucheggBackend* result;
#line 105 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = gala_touchegg_backend_instance;
#line 105 "../src/Gestures/ToucheggBackend.vala"
	if (_tmp0_ == NULL) {
#line 311 "ToucheggBackend.c"
		GalaToucheggBackend* _tmp1_;
		GalaToucheggBackend* _tmp2_;
#line 106 "../src/Gestures/ToucheggBackend.vala"
		_tmp1_ = gala_touchegg_backend_new ();
#line 106 "../src/Gestures/ToucheggBackend.vala"
		_g_object_unref0 (gala_touchegg_backend_instance);
#line 106 "../src/Gestures/ToucheggBackend.vala"
		gala_touchegg_backend_instance = _tmp1_;
#line 107 "../src/Gestures/ToucheggBackend.vala"
		_tmp2_ = gala_touchegg_backend_instance;
#line 107 "../src/Gestures/ToucheggBackend.vala"
		gala_touchegg_backend_stablish_connection (_tmp2_);
#line 324 "ToucheggBackend.c"
	}
#line 110 "../src/Gestures/ToucheggBackend.vala"
	_tmp3_ = gala_touchegg_backend_instance;
#line 110 "../src/Gestures/ToucheggBackend.vala"
	result = _tmp3_;
#line 110 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 332 "ToucheggBackend.c"
}

/**
     * Stablish a connection with the daemon server.
     */
static void
_gala_touchegg_backend_on_disconnected_g_dbus_connection_closed (GDBusConnection* _sender,
                                                                 gboolean remote_peer_vanished,
                                                                 GError* _error_,
                                                                 gpointer self)
{
#line 134 "../src/Gestures/ToucheggBackend.vala"
	gala_touchegg_backend_on_disconnected ((GalaToucheggBackend*) self, remote_peer_vanished, _error_);
#line 346 "ToucheggBackend.c"
}

static void
__lambda6_ (GalaToucheggBackend* self)
{
	gboolean connected = FALSE;
	GError* _inner_error0_ = NULL;
#line 118 "../src/Gestures/ToucheggBackend.vala"
	connected = FALSE;
#line 120 "../src/Gestures/ToucheggBackend.vala"
	while (TRUE) {
#line 358 "ToucheggBackend.c"
		gboolean _tmp0_ = FALSE;
#line 120 "../src/Gestures/ToucheggBackend.vala"
		if (!connected) {
#line 120 "../src/Gestures/ToucheggBackend.vala"
			_tmp0_ = self->priv->reconnection_attempts < GALA_TOUCHEGG_BACKEND_MAX_RECONNECTION_ATTEMPTS;
#line 364 "ToucheggBackend.c"
		} else {
#line 120 "../src/Gestures/ToucheggBackend.vala"
			_tmp0_ = FALSE;
#line 368 "ToucheggBackend.c"
		}
#line 120 "../src/Gestures/ToucheggBackend.vala"
		if (!_tmp0_) {
#line 120 "../src/Gestures/ToucheggBackend.vala"
			break;
#line 374 "ToucheggBackend.c"
		}
		{
			GDBusConnection* _tmp1_ = NULL;
			GDBusConnection* _tmp2_;
			GDBusConnection* _tmp3_;
			GDBusConnection* _tmp4_;
			GDBusConnection* _tmp5_;
#line 122 "../src/Gestures/ToucheggBackend.vala"
			g_debug ("ToucheggBackend.vala:122: Connecting to Touchégg daemon");
#line 123 "../src/Gestures/ToucheggBackend.vala"
			_tmp2_ = g_dbus_connection_new_for_address_sync (GALA_TOUCHEGG_BACKEND_DBUS_ADDRESS, G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_CLIENT, NULL, NULL, &_inner_error0_);
#line 123 "../src/Gestures/ToucheggBackend.vala"
			_tmp1_ = _tmp2_;
#line 123 "../src/Gestures/ToucheggBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "ToucheggBackend.c"
				goto __catch0_g_error;
			}
#line 123 "../src/Gestures/ToucheggBackend.vala"
			_tmp3_ = _tmp1_;
#line 123 "../src/Gestures/ToucheggBackend.vala"
			_tmp1_ = NULL;
#line 123 "../src/Gestures/ToucheggBackend.vala"
			_g_object_unref0 (self->priv->connection);
#line 123 "../src/Gestures/ToucheggBackend.vala"
			self->priv->connection = _tmp3_;
#line 128 "../src/Gestures/ToucheggBackend.vala"
			g_debug ("ToucheggBackend.vala:128: Connection with Touchégg established");
#line 129 "../src/Gestures/ToucheggBackend.vala"
			connected = TRUE;
#line 130 "../src/Gestures/ToucheggBackend.vala"
			self->priv->reconnection_attempts = 0;
#line 132 "../src/Gestures/ToucheggBackend.vala"
			_tmp4_ = self->priv->connection;
#line 132 "../src/Gestures/ToucheggBackend.vala"
			g_dbus_connection_signal_subscribe (_tmp4_, NULL, GALA_TOUCHEGG_BACKEND_DBUS_INTERFACE_NAME, NULL, GALA_TOUCHEGG_BACKEND_DBUS_OBJECT_PATH, NULL, G_DBUS_SIGNAL_FLAGS_NONE, (GDBusSignalCallback) gala_touchegg_backend_on_new_message, g_object_ref (self), g_object_unref);
#line 134 "../src/Gestures/ToucheggBackend.vala"
			_tmp5_ = self->priv->connection;
#line 134 "../src/Gestures/ToucheggBackend.vala"
			g_signal_connect_object (_tmp5_, "closed", (GCallback) _gala_touchegg_backend_on_disconnected_g_dbus_connection_closed, self, 0);
#line 121 "../src/Gestures/ToucheggBackend.vala"
			_g_object_unref0 (_tmp1_);
#line 417 "ToucheggBackend.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
#line 121 "../src/Gestures/ToucheggBackend.vala"
			e = _inner_error0_;
#line 121 "../src/Gestures/ToucheggBackend.vala"
			_inner_error0_ = NULL;
#line 136 "../src/Gestures/ToucheggBackend.vala"
			_tmp6_ = e;
#line 136 "../src/Gestures/ToucheggBackend.vala"
			_tmp7_ = _tmp6_->message;
#line 136 "../src/Gestures/ToucheggBackend.vala"
			g_warning ("ToucheggBackend.vala:136: Error connecting to Touchégg daemon: %s", _tmp7_);
#line 137 "../src/Gestures/ToucheggBackend.vala"
			connected = FALSE;
#line 138 "../src/Gestures/ToucheggBackend.vala"
			_tmp8_ = self->priv->reconnection_attempts;
#line 138 "../src/Gestures/ToucheggBackend.vala"
			self->priv->reconnection_attempts = _tmp8_ + 1;
#line 140 "../src/Gestures/ToucheggBackend.vala"
			if (self->priv->reconnection_attempts < GALA_TOUCHEGG_BACKEND_MAX_RECONNECTION_ATTEMPTS) {
#line 141 "../src/Gestures/ToucheggBackend.vala"
				g_debug ("ToucheggBackend.vala:141: Reconnecting to Touchégg daemon in 5 seconds");
#line 142 "../src/Gestures/ToucheggBackend.vala"
				g_usleep ((gulong) GALA_TOUCHEGG_BACKEND_RECONNECTION_USLEEP_TIME);
#line 448 "ToucheggBackend.c"
			} else {
#line 144 "../src/Gestures/ToucheggBackend.vala"
				g_warning ("ToucheggBackend.vala:144: Maximum number of reconnections reached, abo" \
"rting");
#line 452 "ToucheggBackend.c"
			}
#line 121 "../src/Gestures/ToucheggBackend.vala"
			_g_error_free0 (e);
#line 456 "ToucheggBackend.c"
		}
		__finally0:
#line 121 "../src/Gestures/ToucheggBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/Gestures/ToucheggBackend.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/Gestures/ToucheggBackend.vala"
			g_clear_error (&_inner_error0_);
#line 121 "../src/Gestures/ToucheggBackend.vala"
			return;
#line 467 "ToucheggBackend.c"
		}
	}
}

static gpointer
___lambda6__gthread_func (gpointer self)
{
	gpointer result;
#line 117 "../src/Gestures/ToucheggBackend.vala"
	__lambda6_ ((GalaToucheggBackend*) self);
#line 478 "ToucheggBackend.c"
	result = NULL;
#line 117 "../src/Gestures/ToucheggBackend.vala"
	g_object_unref (self);
#line 117 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 484 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_stablish_connection (GalaToucheggBackend* self)
{
	GThreadFunc run = NULL;
	gpointer run_target;
	GThreadFunc _tmp0_;
	gpointer _tmp0__target;
	GThread* _tmp1_;
	GThread* _tmp2_;
#line 116 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/Gestures/ToucheggBackend.vala"
	run = ___lambda6__gthread_func;
#line 117 "../src/Gestures/ToucheggBackend.vala"
	run_target = g_object_ref (self);
#line 150 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = run;
#line 150 "../src/Gestures/ToucheggBackend.vala"
	_tmp0__target = run_target;
#line 150 "../src/Gestures/ToucheggBackend.vala"
	run = NULL;
#line 150 "../src/Gestures/ToucheggBackend.vala"
	run_target = NULL;
#line 150 "../src/Gestures/ToucheggBackend.vala"
	_tmp1_ = g_thread_new (NULL, _tmp0_, _tmp0__target);
#line 150 "../src/Gestures/ToucheggBackend.vala"
	_tmp2_ = _tmp1_;
#line 150 "../src/Gestures/ToucheggBackend.vala"
	_g_thread_unref0 (_tmp2_);
#line 516 "ToucheggBackend.c"
}

void
gala_touchegg_backend_stop (GalaToucheggBackend* self)
{
	GError* _inner_error0_ = NULL;
#line 153 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (self != NULL);
#line 525 "ToucheggBackend.c"
	{
		GDBusConnection* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 155 "../src/Gestures/ToucheggBackend.vala"
		self->priv->reconnection_attempts = GALA_TOUCHEGG_BACKEND_MAX_RECONNECTION_ATTEMPTS;
#line 157 "../src/Gestures/ToucheggBackend.vala"
		_tmp0_ = self->priv->connection;
#line 157 "../src/Gestures/ToucheggBackend.vala"
		g_object_get (_tmp0_, "closed", &_tmp1_, NULL);
#line 157 "../src/Gestures/ToucheggBackend.vala"
		_tmp2_ = _tmp1_;
#line 157 "../src/Gestures/ToucheggBackend.vala"
		if (!_tmp2_) {
#line 540 "ToucheggBackend.c"
			GDBusConnection* _tmp3_;
#line 158 "../src/Gestures/ToucheggBackend.vala"
			_tmp3_ = self->priv->connection;
#line 158 "../src/Gestures/ToucheggBackend.vala"
			g_dbus_connection_close_sync (_tmp3_, NULL, &_inner_error0_);
#line 158 "../src/Gestures/ToucheggBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 548 "ToucheggBackend.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 154 "../src/Gestures/ToucheggBackend.vala"
		g_clear_error (&_inner_error0_);
#line 558 "ToucheggBackend.c"
	}
	__finally0:
#line 154 "../src/Gestures/ToucheggBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/Gestures/ToucheggBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/Gestures/ToucheggBackend.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/Gestures/ToucheggBackend.vala"
		return;
#line 569 "ToucheggBackend.c"
	}
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 169 "../src/Gestures/ToucheggBackend.vala"
	return self ? g_variant_ref (self) : NULL;
#line 578 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_on_new_message (GDBusConnection* connection,
                                      const gchar* sender_name,
                                      const gchar* object_path,
                                      const gchar* interface_name,
                                      const gchar* signal_name,
                                      GVariant* parameters,
                                      GalaToucheggBackend* self)
{
	gchar* _tmp0_;
	GVariant* _tmp1_;
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (connection != NULL);
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (object_path != NULL);
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (interface_name != NULL);
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (signal_name != NULL);
#line 166 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (parameters != NULL);
#line 168 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = g_strdup (signal_name);
#line 168 "../src/Gestures/ToucheggBackend.vala"
	_g_free0 (self->priv->last_signal_received);
#line 168 "../src/Gestures/ToucheggBackend.vala"
	self->priv->last_signal_received = _tmp0_;
#line 169 "../src/Gestures/ToucheggBackend.vala"
	_tmp1_ = _g_variant_ref0 (parameters);
#line 169 "../src/Gestures/ToucheggBackend.vala"
	_g_variant_unref0 (self->priv->last_params_received);
#line 169 "../src/Gestures/ToucheggBackend.vala"
	self->priv->last_params_received = _tmp1_;
#line 170 "../src/Gestures/ToucheggBackend.vala"
	gala_touchegg_backend_emit_event (self, signal_name, parameters);
#line 618 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_on_disconnected (GalaToucheggBackend* self,
                                       gboolean remote_peer_vanished,
                                       GError* _error_)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 173 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = _error_->message;
#line 174 "../src/Gestures/ToucheggBackend.vala"
	g_debug ("ToucheggBackend.vala:174: Connection with Touchégg daemon lost %s", _tmp0_);
#line 176 "../src/Gestures/ToucheggBackend.vala"
	_tmp2_ = self->priv->last_signal_received;
#line 176 "../src/Gestures/ToucheggBackend.vala"
	if (g_strcmp0 (_tmp2_, GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_BEGIN) == 0) {
#line 176 "../src/Gestures/ToucheggBackend.vala"
		_tmp1_ = TRUE;
#line 641 "ToucheggBackend.c"
	} else {
		const gchar* _tmp3_;
#line 176 "../src/Gestures/ToucheggBackend.vala"
		_tmp3_ = self->priv->last_signal_received;
#line 176 "../src/Gestures/ToucheggBackend.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_UPDATE) == 0;
#line 648 "ToucheggBackend.c"
	}
#line 176 "../src/Gestures/ToucheggBackend.vala"
	if (_tmp1_) {
#line 652 "ToucheggBackend.c"
		GVariant* _tmp4_;
#line 177 "../src/Gestures/ToucheggBackend.vala"
		g_debug ("ToucheggBackend.vala:177: Connection lost in the middle of a gesture, " \
"ending it");
#line 178 "../src/Gestures/ToucheggBackend.vala"
		_tmp4_ = self->priv->last_params_received;
#line 178 "../src/Gestures/ToucheggBackend.vala"
		gala_touchegg_backend_emit_event (self, GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_END, _tmp4_);
#line 660 "ToucheggBackend.c"
	}
#line 181 "../src/Gestures/ToucheggBackend.vala"
	gala_touchegg_backend_stablish_connection (self);
#line 664 "ToucheggBackend.c"
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
#line 184 "../src/Gestures/ToucheggBackend.vala"
	g_atomic_int_inc (&_data62_->_ref_count_);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	return _data62_;
#line 674 "ToucheggBackend.c"
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
#line 184 "../src/Gestures/ToucheggBackend.vala"
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
#line 684 "ToucheggBackend.c"
		GalaToucheggBackend* self;
#line 184 "../src/Gestures/ToucheggBackend.vala"
		self = _data62_->self;
#line 184 "../src/Gestures/ToucheggBackend.vala"
		_g_object_unref0 (self);
#line 184 "../src/Gestures/ToucheggBackend.vala"
		g_slice_free (Block62Data, _data62_);
#line 692 "ToucheggBackend.c"
	}
}

static gboolean
___lambda7_ (Block62Data* _data62_)
{
	GalaToucheggBackend* self;
	GalaGesture* _tmp0_;
	GalaGesture* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 199 "../src/Gestures/ToucheggBackend.vala"
	self = _data62_->self;
#line 200 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = gala_touchegg_backend_make_gesture (_data62_->type, _data62_->direction, _data62_->fingers, _data62_->performed_on_device_type);
#line 200 "../src/Gestures/ToucheggBackend.vala"
	_tmp1_ = _tmp0_;
#line 200 "../src/Gestures/ToucheggBackend.vala"
	g_signal_emit_by_name ((GalaGestureBackend*) self, "on-gesture-detected", _tmp1_, (guint32) META_CURRENT_TIME, &_tmp2_);
#line 200 "../src/Gestures/ToucheggBackend.vala"
	_gala_gesture_unref0 (_tmp1_);
#line 201 "../src/Gestures/ToucheggBackend.vala"
	g_signal_emit_by_name ((GalaGestureBackend*) self, "on-begin", _data62_->delta, _data62_->elapsed_time);
#line 202 "../src/Gestures/ToucheggBackend.vala"
	result = FALSE;
#line 202 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 720 "ToucheggBackend.c"
}

static gboolean
____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda7_ (self);
#line 199 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 730 "ToucheggBackend.c"
}

static gboolean
___lambda8_ (Block62Data* _data62_)
{
	GalaToucheggBackend* self;
	gboolean result;
#line 206 "../src/Gestures/ToucheggBackend.vala"
	self = _data62_->self;
#line 207 "../src/Gestures/ToucheggBackend.vala"
	g_signal_emit_by_name ((GalaGestureBackend*) self, "on-update", _data62_->delta, _data62_->elapsed_time);
#line 208 "../src/Gestures/ToucheggBackend.vala"
	result = FALSE;
#line 208 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 746 "ToucheggBackend.c"
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ (self);
#line 206 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 756 "ToucheggBackend.c"
}

static gboolean
___lambda9_ (Block62Data* _data62_)
{
	GalaToucheggBackend* self;
	gboolean result;
#line 212 "../src/Gestures/ToucheggBackend.vala"
	self = _data62_->self;
#line 213 "../src/Gestures/ToucheggBackend.vala"
	g_signal_emit_by_name ((GalaGestureBackend*) self, "on-end", _data62_->delta, _data62_->elapsed_time);
#line 214 "../src/Gestures/ToucheggBackend.vala"
	result = FALSE;
#line 214 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 772 "ToucheggBackend.c"
}

static gboolean
____lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda9_ (self);
#line 212 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 782 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_emit_event (GalaToucheggBackend* self,
                                  const gchar* signal_name,
                                  GVariant* signal_params)
{
	Block62Data* _data62_;
	gdouble percentage = 0.0;
	GalaToucheggBackendGestureType _tmp0_ = 0;
	GalaGestureDirection _tmp1_ = 0;
	gdouble _tmp2_ = 0.0;
	gint _tmp3_ = 0;
	GalaToucheggBackendDeviceType _tmp4_ = 0;
	guint64 _tmp5_ = 0ULL;
	const gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 197 "../src/Gestures/ToucheggBackend.vala"
	static GQuark _tmp7_label0 = 0;
#line 197 "../src/Gestures/ToucheggBackend.vala"
	static GQuark _tmp7_label1 = 0;
#line 197 "../src/Gestures/ToucheggBackend.vala"
	static GQuark _tmp7_label2 = 0;
#line 184 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (signal_name != NULL);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	g_return_if_fail (signal_params != NULL);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	_data62_ = g_slice_new0 (Block62Data);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	_data62_->_ref_count_ = 1;
#line 184 "../src/Gestures/ToucheggBackend.vala"
	_data62_->self = g_object_ref (self);
#line 192 "../src/Gestures/ToucheggBackend.vala"
	g_variant_get (signal_params, "(uudiut)", &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, NULL);
#line 192 "../src/Gestures/ToucheggBackend.vala"
	_data62_->type = _tmp0_;
#line 192 "../src/Gestures/ToucheggBackend.vala"
	_data62_->direction = _tmp1_;
#line 192 "../src/Gestures/ToucheggBackend.vala"
	percentage = _tmp2_;
#line 192 "../src/Gestures/ToucheggBackend.vala"
	_data62_->fingers = _tmp3_;
#line 192 "../src/Gestures/ToucheggBackend.vala"
	_data62_->performed_on_device_type = _tmp4_;
#line 192 "../src/Gestures/ToucheggBackend.vala"
	_data62_->elapsed_time = _tmp5_;
#line 195 "../src/Gestures/ToucheggBackend.vala"
	_data62_->delta = percentage * GALA_TOUCHEGG_BACKEND_DELTA_MULTIPLIER;
#line 197 "../src/Gestures/ToucheggBackend.vala"
	_tmp6_ = signal_name;
#line 197 "../src/Gestures/ToucheggBackend.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 197 "../src/Gestures/ToucheggBackend.vala"
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string (GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_BEGIN)))) {
#line 197 "../src/Gestures/ToucheggBackend.vala"
		switch (0) {
#line 842 "ToucheggBackend.c"
			default:
			{
#line 199 "../src/Gestures/ToucheggBackend.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda7__gsource_func, block62_data_ref (_data62_), block62_data_unref);
#line 204 "../src/Gestures/ToucheggBackend.vala"
				break;
#line 849 "ToucheggBackend.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string (GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_UPDATE)))) {
#line 197 "../src/Gestures/ToucheggBackend.vala"
		switch (0) {
#line 855 "ToucheggBackend.c"
			default:
			{
#line 206 "../src/Gestures/ToucheggBackend.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda8__gsource_func, block62_data_ref (_data62_), block62_data_unref);
#line 210 "../src/Gestures/ToucheggBackend.vala"
				break;
#line 862 "ToucheggBackend.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string (GALA_TOUCHEGG_BACKEND_DBUS_ON_GESTURE_END)))) {
#line 197 "../src/Gestures/ToucheggBackend.vala"
		switch (0) {
#line 868 "ToucheggBackend.c"
			default:
			{
#line 212 "../src/Gestures/ToucheggBackend.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda9__gsource_func, block62_data_ref (_data62_), block62_data_unref);
#line 216 "../src/Gestures/ToucheggBackend.vala"
				break;
#line 875 "ToucheggBackend.c"
			}
		}
	} else {
#line 197 "../src/Gestures/ToucheggBackend.vala"
		switch (0) {
#line 881 "ToucheggBackend.c"
			default:
			{
#line 218 "../src/Gestures/ToucheggBackend.vala"
				break;
#line 886 "ToucheggBackend.c"
			}
		}
	}
#line 184 "../src/Gestures/ToucheggBackend.vala"
	block62_data_unref (_data62_);
#line 184 "../src/Gestures/ToucheggBackend.vala"
	_data62_ = NULL;
#line 894 "ToucheggBackend.c"
}

static GalaGesture*
gala_touchegg_backend_make_gesture (GalaToucheggBackendGestureType type,
                                    GalaGestureDirection direction,
                                    gint fingers,
                                    GalaToucheggBackendDeviceType performed_on_device_type)
{
	ClutterEventType event_type = 0;
	ClutterInputDeviceType input_source = 0;
	GalaGesture* _tmp0_ = NULL;
	GalaGesture* result;
#line 224 "../src/Gestures/ToucheggBackend.vala"
	switch (type) {
#line 224 "../src/Gestures/ToucheggBackend.vala"
		case GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_SWIPE:
#line 911 "ToucheggBackend.c"
		{
#line 226 "../src/Gestures/ToucheggBackend.vala"
			event_type = CLUTTER_TOUCHPAD_SWIPE;
#line 227 "../src/Gestures/ToucheggBackend.vala"
			break;
#line 917 "ToucheggBackend.c"
		}
#line 224 "../src/Gestures/ToucheggBackend.vala"
		case GALA_TOUCHEGG_BACKEND_GESTURE_TYPE_PINCH:
#line 921 "ToucheggBackend.c"
		{
#line 229 "../src/Gestures/ToucheggBackend.vala"
			event_type = CLUTTER_TOUCHPAD_PINCH;
#line 230 "../src/Gestures/ToucheggBackend.vala"
			break;
#line 927 "ToucheggBackend.c"
		}
		default:
		{
#line 232 "../src/Gestures/ToucheggBackend.vala"
			result = NULL;
#line 232 "../src/Gestures/ToucheggBackend.vala"
			return result;
#line 935 "ToucheggBackend.c"
		}
	}
#line 236 "../src/Gestures/ToucheggBackend.vala"
	switch (performed_on_device_type) {
#line 236 "../src/Gestures/ToucheggBackend.vala"
		case GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHPAD:
#line 942 "ToucheggBackend.c"
		{
#line 238 "../src/Gestures/ToucheggBackend.vala"
			input_source = CLUTTER_TOUCHPAD_DEVICE;
#line 239 "../src/Gestures/ToucheggBackend.vala"
			break;
#line 948 "ToucheggBackend.c"
		}
#line 236 "../src/Gestures/ToucheggBackend.vala"
		case GALA_TOUCHEGG_BACKEND_DEVICE_TYPE_TOUCHSCREEN:
#line 952 "ToucheggBackend.c"
		{
#line 241 "../src/Gestures/ToucheggBackend.vala"
			input_source = CLUTTER_TOUCHSCREEN_DEVICE;
#line 242 "../src/Gestures/ToucheggBackend.vala"
			break;
#line 958 "ToucheggBackend.c"
		}
		default:
		{
#line 244 "../src/Gestures/ToucheggBackend.vala"
			result = NULL;
#line 244 "../src/Gestures/ToucheggBackend.vala"
			return result;
#line 966 "ToucheggBackend.c"
		}
	}
#line 247 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_ = gala_gesture_new ();
#line 247 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_->type = event_type;
#line 247 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_->direction = direction;
#line 247 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_->fingers = fingers;
#line 247 "../src/Gestures/ToucheggBackend.vala"
	_tmp0_->performed_on_device_type = input_source;
#line 247 "../src/Gestures/ToucheggBackend.vala"
	result = _tmp0_;
#line 247 "../src/Gestures/ToucheggBackend.vala"
	return result;
#line 983 "ToucheggBackend.c"
}

GalaToucheggBackend*
gala_touchegg_backend_construct (GType object_type)
{
	GalaToucheggBackend * self = NULL;
#line 23 "../src/Gestures/ToucheggBackend.vala"
	self = (GalaToucheggBackend*) g_object_new (object_type, NULL);
#line 23 "../src/Gestures/ToucheggBackend.vala"
	return self;
#line 994 "ToucheggBackend.c"
}

GalaToucheggBackend*
gala_touchegg_backend_new (void)
{
#line 23 "../src/Gestures/ToucheggBackend.vala"
	return gala_touchegg_backend_construct (GALA_TYPE_TOUCHEGG_BACKEND);
#line 1002 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_class_init (GalaToucheggBackendClass * klass,
                                  gpointer klass_data)
{
#line 23 "../src/Gestures/ToucheggBackend.vala"
	gala_touchegg_backend_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Gestures/ToucheggBackend.vala"
	g_type_class_adjust_private_offset (klass, &GalaToucheggBackend_private_offset);
#line 23 "../src/Gestures/ToucheggBackend.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_touchegg_backend_finalize;
#line 1015 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_gala_gesture_backend_interface_init (GalaGestureBackendIface * iface,
                                                           gpointer iface_data)
{
#line 23 "../src/Gestures/ToucheggBackend.vala"
	gala_touchegg_backend_gala_gesture_backend_parent_iface = g_type_interface_peek_parent (iface);
#line 1024 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_instance_init (GalaToucheggBackend * self,
                                     gpointer klass)
{
#line 23 "../src/Gestures/ToucheggBackend.vala"
	self->priv = gala_touchegg_backend_get_instance_private (self);
#line 87 "../src/Gestures/ToucheggBackend.vala"
	self->priv->connection = NULL;
#line 92 "../src/Gestures/ToucheggBackend.vala"
	self->priv->reconnection_attempts = 0;
#line 98 "../src/Gestures/ToucheggBackend.vala"
	self->priv->last_signal_received = NULL;
#line 99 "../src/Gestures/ToucheggBackend.vala"
	self->priv->last_params_received = NULL;
#line 1041 "ToucheggBackend.c"
}

static void
gala_touchegg_backend_finalize (GObject * obj)
{
	GalaToucheggBackend * self;
#line 23 "../src/Gestures/ToucheggBackend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackend);
#line 87 "../src/Gestures/ToucheggBackend.vala"
	_g_object_unref0 (self->priv->connection);
#line 98 "../src/Gestures/ToucheggBackend.vala"
	_g_free0 (self->priv->last_signal_received);
#line 99 "../src/Gestures/ToucheggBackend.vala"
	_g_variant_unref0 (self->priv->last_params_received);
#line 23 "../src/Gestures/ToucheggBackend.vala"
	G_OBJECT_CLASS (gala_touchegg_backend_parent_class)->finalize (obj);
#line 1058 "ToucheggBackend.c"
}

/**
 * Singleton class to manage the connection with Touchégg daemon and receive touch events.
 * See: [[https://github.com/JoseExposito/touchegg]]
 */
 G_GNUC_NO_INLINE static GType
gala_touchegg_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaToucheggBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_touchegg_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaToucheggBackend), 0, (GInstanceInitFunc) gala_touchegg_backend_instance_init, NULL };
	static const GInterfaceInfo gala_gesture_backend_info = { (GInterfaceInitFunc) gala_touchegg_backend_gala_gesture_backend_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_touchegg_backend_type_id;
	gala_touchegg_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaToucheggBackend", &g_define_type_info, 0);
	g_type_add_interface_static (gala_touchegg_backend_type_id, GALA_TYPE_GESTURE_BACKEND, &gala_gesture_backend_info);
	GalaToucheggBackend_private_offset = g_type_add_instance_private (gala_touchegg_backend_type_id, sizeof (GalaToucheggBackendPrivate));
	return gala_touchegg_backend_type_id;
}

GType
gala_touchegg_backend_get_type (void)
{
	static gsize gala_touchegg_backend_type_id__once = 0;
	if (g_once_init_enter (&gala_touchegg_backend_type_id__once)) {
		GType gala_touchegg_backend_type_id;
		gala_touchegg_backend_type_id = gala_touchegg_backend_get_type_once ();
		g_once_init_leave (&gala_touchegg_backend_type_id__once, gala_touchegg_backend_type_id);
	}
	return gala_touchegg_backend_type_id__once;
}

