/* WindowTracker.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowTracker.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. <https://elementary.io>
 * Copyright 2021 Corentin Noël <tintou@noel.tf>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <glib.h>
#include <meta/window.h>
#include "gala.h"
#include <meta/display.h>
#include <meta/meta-startup-notification.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <meta/meta-x11-types.h>
#include <meta/meta-x11-group.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;
typedef struct _GalaWindowTrackerPrivate GalaWindowTrackerPrivate;
enum  {
	GALA_WINDOW_TRACKER_0_PROPERTY,
	GALA_WINDOW_TRACKER_NUM_PROPERTIES
};
static GParamSpec* gala_window_tracker_properties[GALA_WINDOW_TRACKER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_WINDOW_TRACKER_WINDOWS_CHANGED_SIGNAL,
	GALA_WINDOW_TRACKER_NUM_SIGNALS
};
static guint gala_window_tracker_signals[GALA_WINDOW_TRACKER_NUM_SIGNALS] = {0};

struct _GalaWindowTracker {
	GObject parent_instance;
	GalaWindowTrackerPrivate * priv;
};

struct _GalaWindowTrackerClass {
	GObjectClass parent_class;
};

struct _GalaWindowTrackerPrivate {
	GHashTable* window_to_app;
};

static gint GalaWindowTracker_private_offset;
static gpointer gala_window_tracker_parent_class = NULL;

VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN void gala_window_tracker_init (GalaWindowTracker* self,
                               MetaDisplay* display);
static void gala_window_tracker_on_startup_sequence_changed (GalaWindowTracker* self,
                                                      MetaStartupSequence* sequence);
static void _gala_window_tracker_on_startup_sequence_changed_meta_startup_notification_changed (MetaStartupNotification* _sender,
                                                                                         MetaStartupSequence* object,
                                                                                         gpointer self);
static void gala_window_tracker_load_initial_windows (GalaWindowTracker* self,
                                               MetaDisplay* display);
static void gala_window_tracker_init_window_tracking (GalaWindowTracker* self,
                                               MetaDisplay* display);
static void gala_window_tracker_track_window (GalaWindowTracker* self,
                                       MetaWindow* window);
static void _gala_window_tracker_track_window_meta_display_window_created (MetaDisplay* _sender,
                                                                    MetaWindow* object,
                                                                    gpointer self);
static GalaApp* gala_window_tracker_get_app_from_id (const gchar* id);
static GalaApp* gala_window_tracker_get_app_from_gapplication_id (MetaWindow* window);
static GalaApp* gala_window_tracker_get_app_from_pid (pid_t pid);
static pid_t* _pid_t_dup (pid_t* self);
static gboolean _pid_t_equal (const pid_t * s1,
                       const pid_t * s2);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static GalaApp* gala_window_tracker_get_app_from_window_pid (GalaWindowTracker* self,
                                                      MetaWindow* window);
static gboolean gala_window_tracker_check_app_id_prefix (GalaApp* app,
                                                  const gchar* prefix);
static GalaApp* gala_window_tracker_get_app_from_window_wmclass (GalaWindowTracker* self,
                                                          MetaWindow* window);
static GalaApp* gala_window_tracker_get_app_from_sandboxed_app_id (GalaWindowTracker* self,
                                                            MetaWindow* window);
static GalaApp* gala_window_tracker_get_app_from_window_group (GalaWindowTracker* self,
                                                        MetaWindow* window);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
static void gala_window_tracker_tracked_window_changed (GalaWindowTracker* self,
                                                 MetaWindow* window);
static void gala_window_tracker_disassociate_window (GalaWindowTracker* self,
                                              MetaWindow* window);
static void gala_window_tracker_tracked_window_notified (GalaWindowTracker* self,
                                                  GObject* object,
                                                  GParamSpec* pspec);
static void _gala_window_tracker_tracked_window_notified_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _gala_window_tracker_disassociate_window_meta_window_unmanaged (MetaWindow* _sender,
                                                                     gpointer self);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_new (void);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_construct (GType object_type);
static GObject * gala_window_tracker_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void gala_window_tracker_finalize (GObject * obj);
static GType gala_window_tracker_get_type_once (void);

static inline gpointer
gala_window_tracker_get_instance_private (GalaWindowTracker* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowTracker_private_offset);
}

static void
_gala_window_tracker_on_startup_sequence_changed_meta_startup_notification_changed (MetaStartupNotification* _sender,
                                                                                    MetaStartupSequence* object,
                                                                                    gpointer self)
{
#line 18 "../src/WindowTracker.vala"
	gala_window_tracker_on_startup_sequence_changed ((GalaWindowTracker*) self, object);
#line 153 "WindowTracker.c"
}

void
gala_window_tracker_init (GalaWindowTracker* self,
                          MetaDisplay* display)
{
	MetaStartupNotification* sn = NULL;
	MetaStartupNotification* _tmp0_;
#line 16 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/WindowTracker.vala"
	g_return_if_fail (display != NULL);
#line 17 "../src/WindowTracker.vala"
	_tmp0_ = meta_display_get_startup_notification (display);
#line 17 "../src/WindowTracker.vala"
	sn = _tmp0_;
#line 18 "../src/WindowTracker.vala"
	g_signal_connect_object (sn, "changed", (GCallback) _gala_window_tracker_on_startup_sequence_changed_meta_startup_notification_changed, self, 0);
#line 19 "../src/WindowTracker.vala"
	gala_window_tracker_load_initial_windows (self, display);
#line 20 "../src/WindowTracker.vala"
	gala_window_tracker_init_window_tracking (self, display);
#line 176 "WindowTracker.c"
}

static void
gala_window_tracker_load_initial_windows (GalaWindowTracker* self,
                                          MetaDisplay* display)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 23 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/WindowTracker.vala"
	g_return_if_fail (display != NULL);
#line 24 "../src/WindowTracker.vala"
	_tmp0_ = meta_display_list_all_windows (display);
#line 24 "../src/WindowTracker.vala"
	windows = _tmp0_;
#line 25 "../src/WindowTracker.vala"
	_tmp1_ = windows;
#line 196 "WindowTracker.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 25 "../src/WindowTracker.vala"
		window_collection = _tmp1_;
#line 25 "../src/WindowTracker.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 204 "WindowTracker.c"
			MetaWindow* window = NULL;
#line 25 "../src/WindowTracker.vala"
			window = (MetaWindow*) window_it->data;
#line 208 "WindowTracker.c"
			{
				MetaWindow* _tmp2_;
#line 26 "../src/WindowTracker.vala"
				_tmp2_ = window;
#line 26 "../src/WindowTracker.vala"
				gala_window_tracker_track_window (self, _tmp2_);
#line 215 "WindowTracker.c"
			}
		}
	}
#line 23 "../src/WindowTracker.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 221 "WindowTracker.c"
}

static void
_gala_window_tracker_track_window_meta_display_window_created (MetaDisplay* _sender,
                                                               MetaWindow* object,
                                                               gpointer self)
{
#line 31 "../src/WindowTracker.vala"
	gala_window_tracker_track_window ((GalaWindowTracker*) self, object);
#line 231 "WindowTracker.c"
}

static void
gala_window_tracker_init_window_tracking (GalaWindowTracker* self,
                                          MetaDisplay* display)
{
#line 30 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/WindowTracker.vala"
	g_return_if_fail (display != NULL);
#line 31 "../src/WindowTracker.vala"
	g_signal_connect_object (display, "window-created", (GCallback) _gala_window_tracker_track_window_meta_display_window_created, self, 0);
#line 244 "WindowTracker.c"
}

static void
gala_window_tracker_on_startup_sequence_changed (GalaWindowTracker* self,
                                                 MetaStartupSequence* sequence)
{
	GalaApp* app = NULL;
	GalaApp* _tmp0_;
	GalaApp* _tmp1_;
#line 34 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/WindowTracker.vala"
	g_return_if_fail (sequence != NULL);
#line 35 "../src/WindowTracker.vala"
	_tmp0_ = gala_app_new_from_startup_sequence (sequence);
#line 35 "../src/WindowTracker.vala"
	app = _tmp0_;
#line 36 "../src/WindowTracker.vala"
	_tmp1_ = app;
#line 36 "../src/WindowTracker.vala"
	if (_tmp1_ != NULL) {
#line 266 "WindowTracker.c"
		GalaApp* _tmp2_;
#line 37 "../src/WindowTracker.vala"
		_tmp2_ = app;
#line 37 "../src/WindowTracker.vala"
		gala_app_handle_startup_sequence (_tmp2_, sequence);
#line 272 "WindowTracker.c"
	}
}

static GalaApp*
gala_window_tracker_get_app_from_id (const gchar* id)
{
	gchar* desktop_file = NULL;
	gchar* _tmp0_;
	GalaAppSystem* _tmp1_;
	GalaApp* _tmp2_;
	GalaApp* result;
#line 41 "../src/WindowTracker.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 42 "../src/WindowTracker.vala"
	_tmp0_ = g_strconcat (id, ".desktop", NULL);
#line 42 "../src/WindowTracker.vala"
	desktop_file = _tmp0_;
#line 43 "../src/WindowTracker.vala"
	_tmp1_ = gala_app_system_get_default ();
#line 43 "../src/WindowTracker.vala"
	_tmp2_ = gala_app_system_lookup_app (_tmp1_, desktop_file);
#line 43 "../src/WindowTracker.vala"
	result = _tmp2_;
#line 43 "../src/WindowTracker.vala"
	_g_free0 (desktop_file);
#line 43 "../src/WindowTracker.vala"
	return result;
#line 300 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_gapplication_id (MetaWindow* window)
{
	const gchar* id = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GalaApp* _tmp3_;
	GalaApp* result;
#line 46 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 47 "../src/WindowTracker.vala"
	_tmp0_ = meta_window_get_gtk_application_id (window);
#line 47 "../src/WindowTracker.vala"
	id = _tmp0_;
#line 48 "../src/WindowTracker.vala"
	_tmp1_ = id;
#line 48 "../src/WindowTracker.vala"
	if (_tmp1_ == NULL) {
#line 49 "../src/WindowTracker.vala"
		result = NULL;
#line 49 "../src/WindowTracker.vala"
		return result;
#line 326 "WindowTracker.c"
	}
#line 52 "../src/WindowTracker.vala"
	_tmp2_ = id;
#line 52 "../src/WindowTracker.vala"
	_tmp3_ = gala_window_tracker_get_app_from_id (_tmp2_);
#line 52 "../src/WindowTracker.vala"
	result = _tmp3_;
#line 52 "../src/WindowTracker.vala"
	return result;
#line 336 "WindowTracker.c"
}

static pid_t*
_pid_t_dup (pid_t* self)
{
	pid_t* dup;
#line 59 "../src/WindowTracker.vala"
	dup = g_new0 (pid_t, 1);
#line 59 "../src/WindowTracker.vala"
	memcpy (dup, self, sizeof (pid_t));
#line 59 "../src/WindowTracker.vala"
	return dup;
#line 349 "WindowTracker.c"
}

static gpointer
__pid_t_dup0 (gpointer self)
{
#line 59 "../src/WindowTracker.vala"
	return self ? _pid_t_dup (self) : NULL;
#line 357 "WindowTracker.c"
}

static gboolean
_pid_t_equal (const pid_t * s1,
              const pid_t * s2)
{
#line 60 "../src/WindowTracker.vala"
	if (s1 == s2) {
#line 60 "../src/WindowTracker.vala"
		return TRUE;
#line 368 "WindowTracker.c"
	}
#line 60 "../src/WindowTracker.vala"
	if (s1 == NULL) {
#line 60 "../src/WindowTracker.vala"
		return FALSE;
#line 374 "WindowTracker.c"
	}
#line 60 "../src/WindowTracker.vala"
	if (s2 == NULL) {
#line 60 "../src/WindowTracker.vala"
		return FALSE;
#line 380 "WindowTracker.c"
	}
#line 60 "../src/WindowTracker.vala"
	return (*s1) == (*s2);
#line 384 "WindowTracker.c"
}

static void
_g_free0_ (gpointer var)
{
#line 61 "../src/WindowTracker.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 392 "WindowTracker.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 61 "../src/WindowTracker.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 400 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_pid (pid_t pid)
{
	GList* running_apps = NULL;
	GalaAppSystem* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GalaApp* result;
#line 56 "../src/WindowTracker.vala"
	_tmp0_ = gala_app_system_get_default ();
#line 56 "../src/WindowTracker.vala"
	_tmp1_ = gala_app_system_get_running_apps (_tmp0_);
#line 56 "../src/WindowTracker.vala"
	running_apps = _tmp1_;
#line 57 "../src/WindowTracker.vala"
	_tmp2_ = running_apps;
#line 419 "WindowTracker.c"
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
#line 57 "../src/WindowTracker.vala"
		app_collection = _tmp2_;
#line 57 "../src/WindowTracker.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 427 "WindowTracker.c"
			GalaApp* app = NULL;
#line 57 "../src/WindowTracker.vala"
			app = (GalaApp*) app_it->data;
#line 431 "WindowTracker.c"
			{
				GSList* app_pids = NULL;
				GalaApp* _tmp3_;
				GSList* _tmp4_;
				GSList* _tmp5_;
#line 58 "../src/WindowTracker.vala"
				_tmp3_ = app;
#line 58 "../src/WindowTracker.vala"
				_tmp4_ = gala_app_get_pids (_tmp3_);
#line 58 "../src/WindowTracker.vala"
				app_pids = _tmp4_;
#line 59 "../src/WindowTracker.vala"
				_tmp5_ = app_pids;
#line 445 "WindowTracker.c"
				{
					GSList* app_pid_collection = NULL;
					GSList* app_pid_it = NULL;
#line 59 "../src/WindowTracker.vala"
					app_pid_collection = _tmp5_;
#line 59 "../src/WindowTracker.vala"
					for (app_pid_it = app_pid_collection; app_pid_it != NULL; app_pid_it = app_pid_it->next) {
#line 453 "WindowTracker.c"
						pid_t* _tmp6_;
						pid_t* app_pid = NULL;
#line 59 "../src/WindowTracker.vala"
						_tmp6_ = __pid_t_dup0 ((pid_t*) app_pid_it->data);
#line 59 "../src/WindowTracker.vala"
						app_pid = _tmp6_;
#line 460 "WindowTracker.c"
						{
							pid_t* _tmp7_;
#line 60 "../src/WindowTracker.vala"
							_tmp7_ = app_pid;
#line 60 "../src/WindowTracker.vala"
							if (_pid_t_equal (_tmp7_, &pid) == TRUE) {
#line 467 "WindowTracker.c"
								GalaApp* _tmp8_;
#line 61 "../src/WindowTracker.vala"
								_tmp8_ = app;
#line 61 "../src/WindowTracker.vala"
								result = _tmp8_;
#line 61 "../src/WindowTracker.vala"
								_g_free0 (app_pid);
#line 61 "../src/WindowTracker.vala"
								(app_pids == NULL) ? NULL : (app_pids = (_g_slist_free__g_free0_ (app_pids), NULL));
#line 61 "../src/WindowTracker.vala"
								(running_apps == NULL) ? NULL : (running_apps = (g_list_free (running_apps), NULL));
#line 61 "../src/WindowTracker.vala"
								return result;
#line 481 "WindowTracker.c"
							}
#line 59 "../src/WindowTracker.vala"
							_g_free0 (app_pid);
#line 485 "WindowTracker.c"
						}
					}
				}
#line 57 "../src/WindowTracker.vala"
				(app_pids == NULL) ? NULL : (app_pids = (_g_slist_free__g_free0_ (app_pids), NULL));
#line 491 "WindowTracker.c"
			}
		}
	}
#line 66 "../src/WindowTracker.vala"
	result = NULL;
#line 66 "../src/WindowTracker.vala"
	(running_apps == NULL) ? NULL : (running_apps = (g_list_free (running_apps), NULL));
#line 66 "../src/WindowTracker.vala"
	return result;
#line 501 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_window_pid (GalaWindowTracker* self,
                                             MetaWindow* window)
{
	pid_t pid = 0;
	GalaApp* _tmp0_;
	GalaApp* result;
#line 69 "../src/WindowTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 70 "../src/WindowTracker.vala"
	if (meta_window_is_remote (window)) {
#line 71 "../src/WindowTracker.vala"
		result = NULL;
#line 71 "../src/WindowTracker.vala"
		return result;
#line 521 "WindowTracker.c"
	}
#line 74 "../src/WindowTracker.vala"
	pid = meta_window_get_pid (window);
#line 75 "../src/WindowTracker.vala"
	if (pid < ((pid_t) 1)) {
#line 76 "../src/WindowTracker.vala"
		result = NULL;
#line 76 "../src/WindowTracker.vala"
		return result;
#line 531 "WindowTracker.c"
	}
#line 79 "../src/WindowTracker.vala"
	_tmp0_ = gala_window_tracker_get_app_from_pid (pid);
#line 79 "../src/WindowTracker.vala"
	result = _tmp0_;
#line 79 "../src/WindowTracker.vala"
	return result;
#line 539 "WindowTracker.c"
}

static gboolean
gala_window_tracker_check_app_id_prefix (GalaApp* app,
                                         const gchar* prefix)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 82 "../src/WindowTracker.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 83 "../src/WindowTracker.vala"
	if (prefix == NULL) {
#line 84 "../src/WindowTracker.vala"
		result = TRUE;
#line 84 "../src/WindowTracker.vala"
		return result;
#line 557 "WindowTracker.c"
	}
#line 87 "../src/WindowTracker.vala"
	_tmp0_ = gala_app_get_id (app);
#line 87 "../src/WindowTracker.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/WindowTracker.vala"
	result = g_str_has_prefix (_tmp1_, prefix);
#line 87 "../src/WindowTracker.vala"
	return result;
#line 567 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_window_wmclass (GalaWindowTracker* self,
                                                 MetaWindow* window)
{
	gchar* app_prefix = NULL;
	const gchar* sandbox_id = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* wm_instance = NULL;
	const gchar* _tmp4_;
	GalaAppSystem* appsys = NULL;
	GalaAppSystem* _tmp5_;
	GalaApp* app = NULL;
	GalaAppSystem* _tmp6_;
	const gchar* _tmp7_;
	GalaApp* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GalaApp* _tmp10_;
	const gchar* wm_class = NULL;
	const gchar* _tmp14_;
	GalaAppSystem* _tmp15_;
	const gchar* _tmp16_;
	GalaApp* _tmp17_;
	gboolean _tmp18_ = FALSE;
	GalaApp* _tmp19_;
	GalaAppSystem* _tmp23_;
	const gchar* _tmp24_;
	GalaApp* _tmp25_;
	gboolean _tmp26_ = FALSE;
	GalaApp* _tmp27_;
	GalaAppSystem* _tmp31_;
	const gchar* _tmp32_;
	GalaApp* _tmp33_;
	gboolean _tmp34_ = FALSE;
	GalaApp* _tmp35_;
	GalaApp* result;
#line 90 "../src/WindowTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 91 "../src/WindowTracker.vala"
	app_prefix = NULL;
#line 92 "../src/WindowTracker.vala"
	_tmp0_ = meta_window_get_sandboxed_app_id (window);
#line 92 "../src/WindowTracker.vala"
	sandbox_id = _tmp0_;
#line 93 "../src/WindowTracker.vala"
	_tmp1_ = sandbox_id;
#line 93 "../src/WindowTracker.vala"
	if (_tmp1_ != NULL) {
#line 620 "WindowTracker.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 94 "../src/WindowTracker.vala"
		_tmp2_ = sandbox_id;
#line 94 "../src/WindowTracker.vala"
		_tmp3_ = g_strdup_printf ("%s.", _tmp2_);
#line 94 "../src/WindowTracker.vala"
		_g_free0 (app_prefix);
#line 94 "../src/WindowTracker.vala"
		app_prefix = _tmp3_;
#line 631 "WindowTracker.c"
	}
#line 133 "../src/WindowTracker.vala"
	_tmp4_ = meta_window_get_wm_class_instance (window);
#line 133 "../src/WindowTracker.vala"
	wm_instance = _tmp4_;
#line 134 "../src/WindowTracker.vala"
	_tmp5_ = gala_app_system_get_default ();
#line 134 "../src/WindowTracker.vala"
	appsys = _tmp5_;
#line 136 "../src/WindowTracker.vala"
	_tmp6_ = appsys;
#line 136 "../src/WindowTracker.vala"
	_tmp7_ = wm_instance;
#line 136 "../src/WindowTracker.vala"
	_tmp8_ = gala_app_system_lookup_startup_wmclass (_tmp6_, _tmp7_);
#line 136 "../src/WindowTracker.vala"
	app = _tmp8_;
#line 137 "../src/WindowTracker.vala"
	_tmp10_ = app;
#line 137 "../src/WindowTracker.vala"
	if (_tmp10_ != NULL) {
#line 653 "WindowTracker.c"
		GalaApp* _tmp11_;
		const gchar* _tmp12_;
#line 137 "../src/WindowTracker.vala"
		_tmp11_ = app;
#line 137 "../src/WindowTracker.vala"
		_tmp12_ = app_prefix;
#line 137 "../src/WindowTracker.vala"
		_tmp9_ = gala_window_tracker_check_app_id_prefix (_tmp11_, _tmp12_);
#line 662 "WindowTracker.c"
	} else {
#line 137 "../src/WindowTracker.vala"
		_tmp9_ = FALSE;
#line 666 "WindowTracker.c"
	}
#line 137 "../src/WindowTracker.vala"
	if (_tmp9_) {
#line 670 "WindowTracker.c"
		GalaApp* _tmp13_;
#line 138 "../src/WindowTracker.vala"
		_tmp13_ = app;
#line 138 "../src/WindowTracker.vala"
		result = _tmp13_;
#line 138 "../src/WindowTracker.vala"
		_g_free0 (app_prefix);
#line 138 "../src/WindowTracker.vala"
		return result;
#line 680 "WindowTracker.c"
	}
#line 142 "../src/WindowTracker.vala"
	_tmp14_ = meta_window_get_wm_class (window);
#line 142 "../src/WindowTracker.vala"
	wm_class = _tmp14_;
#line 143 "../src/WindowTracker.vala"
	_tmp15_ = appsys;
#line 143 "../src/WindowTracker.vala"
	_tmp16_ = wm_class;
#line 143 "../src/WindowTracker.vala"
	_tmp17_ = gala_app_system_lookup_startup_wmclass (_tmp15_, _tmp16_);
#line 143 "../src/WindowTracker.vala"
	app = _tmp17_;
#line 144 "../src/WindowTracker.vala"
	_tmp19_ = app;
#line 144 "../src/WindowTracker.vala"
	if (_tmp19_ != NULL) {
#line 698 "WindowTracker.c"
		GalaApp* _tmp20_;
		const gchar* _tmp21_;
#line 144 "../src/WindowTracker.vala"
		_tmp20_ = app;
#line 144 "../src/WindowTracker.vala"
		_tmp21_ = app_prefix;
#line 144 "../src/WindowTracker.vala"
		_tmp18_ = gala_window_tracker_check_app_id_prefix (_tmp20_, _tmp21_);
#line 707 "WindowTracker.c"
	} else {
#line 144 "../src/WindowTracker.vala"
		_tmp18_ = FALSE;
#line 711 "WindowTracker.c"
	}
#line 144 "../src/WindowTracker.vala"
	if (_tmp18_) {
#line 715 "WindowTracker.c"
		GalaApp* _tmp22_;
#line 145 "../src/WindowTracker.vala"
		_tmp22_ = app;
#line 145 "../src/WindowTracker.vala"
		result = _tmp22_;
#line 145 "../src/WindowTracker.vala"
		_g_free0 (app_prefix);
#line 145 "../src/WindowTracker.vala"
		return result;
#line 725 "WindowTracker.c"
	}
#line 149 "../src/WindowTracker.vala"
	_tmp23_ = appsys;
#line 149 "../src/WindowTracker.vala"
	_tmp24_ = wm_instance;
#line 149 "../src/WindowTracker.vala"
	_tmp25_ = gala_app_system_lookup_desktop_wmclass (_tmp23_, _tmp24_);
#line 149 "../src/WindowTracker.vala"
	app = _tmp25_;
#line 150 "../src/WindowTracker.vala"
	_tmp27_ = app;
#line 150 "../src/WindowTracker.vala"
	if (_tmp27_ != NULL) {
#line 739 "WindowTracker.c"
		GalaApp* _tmp28_;
		const gchar* _tmp29_;
#line 150 "../src/WindowTracker.vala"
		_tmp28_ = app;
#line 150 "../src/WindowTracker.vala"
		_tmp29_ = app_prefix;
#line 150 "../src/WindowTracker.vala"
		_tmp26_ = gala_window_tracker_check_app_id_prefix (_tmp28_, _tmp29_);
#line 748 "WindowTracker.c"
	} else {
#line 150 "../src/WindowTracker.vala"
		_tmp26_ = FALSE;
#line 752 "WindowTracker.c"
	}
#line 150 "../src/WindowTracker.vala"
	if (_tmp26_) {
#line 756 "WindowTracker.c"
		GalaApp* _tmp30_;
#line 151 "../src/WindowTracker.vala"
		_tmp30_ = app;
#line 151 "../src/WindowTracker.vala"
		result = _tmp30_;
#line 151 "../src/WindowTracker.vala"
		_g_free0 (app_prefix);
#line 151 "../src/WindowTracker.vala"
		return result;
#line 766 "WindowTracker.c"
	}
#line 155 "../src/WindowTracker.vala"
	_tmp31_ = appsys;
#line 155 "../src/WindowTracker.vala"
	_tmp32_ = wm_class;
#line 155 "../src/WindowTracker.vala"
	_tmp33_ = gala_app_system_lookup_desktop_wmclass (_tmp31_, _tmp32_);
#line 155 "../src/WindowTracker.vala"
	app = _tmp33_;
#line 156 "../src/WindowTracker.vala"
	_tmp35_ = app;
#line 156 "../src/WindowTracker.vala"
	if (_tmp35_ != NULL) {
#line 780 "WindowTracker.c"
		GalaApp* _tmp36_;
		const gchar* _tmp37_;
#line 156 "../src/WindowTracker.vala"
		_tmp36_ = app;
#line 156 "../src/WindowTracker.vala"
		_tmp37_ = app_prefix;
#line 156 "../src/WindowTracker.vala"
		_tmp34_ = gala_window_tracker_check_app_id_prefix (_tmp36_, _tmp37_);
#line 789 "WindowTracker.c"
	} else {
#line 156 "../src/WindowTracker.vala"
		_tmp34_ = FALSE;
#line 793 "WindowTracker.c"
	}
#line 156 "../src/WindowTracker.vala"
	if (_tmp34_) {
#line 797 "WindowTracker.c"
		GalaApp* _tmp38_;
#line 157 "../src/WindowTracker.vala"
		_tmp38_ = app;
#line 157 "../src/WindowTracker.vala"
		result = _tmp38_;
#line 157 "../src/WindowTracker.vala"
		_g_free0 (app_prefix);
#line 157 "../src/WindowTracker.vala"
		return result;
#line 807 "WindowTracker.c"
	}
#line 160 "../src/WindowTracker.vala"
	result = NULL;
#line 160 "../src/WindowTracker.vala"
	_g_free0 (app_prefix);
#line 160 "../src/WindowTracker.vala"
	return result;
#line 815 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_sandboxed_app_id (GalaWindowTracker* self,
                                                   MetaWindow* window)
{
	const gchar* id = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GalaApp* _tmp3_;
	GalaApp* result;
#line 163 "../src/WindowTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 164 "../src/WindowTracker.vala"
	_tmp0_ = meta_window_get_sandboxed_app_id (window);
#line 164 "../src/WindowTracker.vala"
	id = _tmp0_;
#line 165 "../src/WindowTracker.vala"
	_tmp1_ = id;
#line 165 "../src/WindowTracker.vala"
	if (_tmp1_ == NULL) {
#line 166 "../src/WindowTracker.vala"
		result = NULL;
#line 166 "../src/WindowTracker.vala"
		return result;
#line 844 "WindowTracker.c"
	}
#line 169 "../src/WindowTracker.vala"
	_tmp2_ = id;
#line 169 "../src/WindowTracker.vala"
	_tmp3_ = gala_window_tracker_get_app_from_id (_tmp2_);
#line 169 "../src/WindowTracker.vala"
	result = _tmp3_;
#line 169 "../src/WindowTracker.vala"
	return result;
#line 854 "WindowTracker.c"
}

static GalaApp*
gala_window_tracker_get_app_from_window_group (GalaWindowTracker* self,
                                               MetaWindow* window)
{
	MetaGroup* group = NULL;
	MetaGroup* _tmp0_;
	MetaGroup* _tmp1_;
	GSList* group_windows = NULL;
	MetaGroup* _tmp2_;
	GSList* _tmp3_;
	GSList* _tmp4_;
	GalaApp* result;
#line 172 "../src/WindowTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 173 "../src/WindowTracker.vala"
	if (meta_window_get_client_type (window) != META_WINDOW_CLIENT_TYPE_X11) {
#line 175 "../src/WindowTracker.vala"
		result = NULL;
#line 175 "../src/WindowTracker.vala"
		return result;
#line 879 "WindowTracker.c"
	}
#line 179 "../src/WindowTracker.vala"
	_tmp0_ = meta_window_x11_get_group (window);
#line 179 "../src/WindowTracker.vala"
	group = _tmp0_;
#line 183 "../src/WindowTracker.vala"
	_tmp1_ = group;
#line 183 "../src/WindowTracker.vala"
	if (_tmp1_ == NULL) {
#line 184 "../src/WindowTracker.vala"
		result = NULL;
#line 184 "../src/WindowTracker.vala"
		return result;
#line 893 "WindowTracker.c"
	}
#line 187 "../src/WindowTracker.vala"
	_tmp2_ = group;
#line 187 "../src/WindowTracker.vala"
	_tmp3_ = meta_group_list_windows (_tmp2_);
#line 187 "../src/WindowTracker.vala"
	group_windows = _tmp3_;
#line 188 "../src/WindowTracker.vala"
	_tmp4_ = group_windows;
#line 903 "WindowTracker.c"
	{
		GSList* group_window_collection = NULL;
		GSList* group_window_it = NULL;
#line 188 "../src/WindowTracker.vala"
		group_window_collection = _tmp4_;
#line 188 "../src/WindowTracker.vala"
		for (group_window_it = group_window_collection; group_window_it != NULL; group_window_it = group_window_it->next) {
#line 911 "WindowTracker.c"
			MetaWindow* group_window = NULL;
#line 188 "../src/WindowTracker.vala"
			group_window = (MetaWindow*) group_window_it->data;
#line 915 "WindowTracker.c"
			{
				MetaWindow* _tmp5_;
				MetaWindowType _tmp6_;
				MetaWindowType _tmp7_;
				GalaApp* _result_ = NULL;
				GHashTable* _tmp8_;
				MetaWindow* _tmp9_;
				gconstpointer _tmp10_;
				GalaApp* _tmp11_;
#line 189 "../src/WindowTracker.vala"
				_tmp5_ = group_window;
#line 189 "../src/WindowTracker.vala"
				_tmp6_ = meta_window_get_window_type (_tmp5_);
#line 189 "../src/WindowTracker.vala"
				_tmp7_ = _tmp6_;
#line 189 "../src/WindowTracker.vala"
				if (_tmp7_ != META_WINDOW_NORMAL) {
#line 190 "../src/WindowTracker.vala"
					continue;
#line 935 "WindowTracker.c"
				}
#line 193 "../src/WindowTracker.vala"
				_tmp8_ = self->priv->window_to_app;
#line 193 "../src/WindowTracker.vala"
				_tmp9_ = group_window;
#line 193 "../src/WindowTracker.vala"
				_tmp10_ = g_hash_table_lookup (_tmp8_, _tmp9_);
#line 193 "../src/WindowTracker.vala"
				_result_ = (GalaApp*) _tmp10_;
#line 194 "../src/WindowTracker.vala"
				_tmp11_ = _result_;
#line 194 "../src/WindowTracker.vala"
				if (_tmp11_ != NULL) {
#line 949 "WindowTracker.c"
					GalaApp* _tmp12_;
#line 195 "../src/WindowTracker.vala"
					_tmp12_ = _result_;
#line 195 "../src/WindowTracker.vala"
					result = _tmp12_;
#line 195 "../src/WindowTracker.vala"
					(group_windows == NULL) ? NULL : (group_windows = (g_slist_free (group_windows), NULL));
#line 195 "../src/WindowTracker.vala"
					return result;
#line 959 "WindowTracker.c"
				}
			}
		}
	}
#line 199 "../src/WindowTracker.vala"
	result = NULL;
#line 199 "../src/WindowTracker.vala"
	(group_windows == NULL) ? NULL : (group_windows = (g_slist_free (group_windows), NULL));
#line 199 "../src/WindowTracker.vala"
	return result;
#line 970 "WindowTracker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 215 "../src/WindowTracker.vala"
	return self ? g_object_ref (self) : NULL;
#line 978 "WindowTracker.c"
}

GalaApp*
gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                        MetaWindow* window)
{
	MetaWindow* transient_for = NULL;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	GalaApp* _result_ = NULL;
	gboolean _tmp4_ = FALSE;
	MetaWindowType _tmp5_;
	MetaWindowType _tmp6_;
	GalaApp* _tmp13_;
	GalaApp* _tmp14_;
	GalaApp* _tmp17_;
	GalaApp* _tmp18_;
	GalaApp* _tmp21_;
	GalaApp* _tmp22_;
	GalaApp* _tmp25_;
	GalaApp* _tmp26_;
	const gchar* startup_id = NULL;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	GalaApp* _tmp51_;
	GalaApp* _tmp52_;
	GalaApp* _tmp55_;
	GalaApp* result;
#line 202 "../src/WindowTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "../src/WindowTracker.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 203 "../src/WindowTracker.vala"
	_tmp0_ = meta_window_get_transient_for (window);
#line 203 "../src/WindowTracker.vala"
	transient_for = _tmp0_;
#line 204 "../src/WindowTracker.vala"
	_tmp1_ = transient_for;
#line 204 "../src/WindowTracker.vala"
	if (_tmp1_ != NULL) {
#line 1019 "WindowTracker.c"
		MetaWindow* _tmp2_;
		GalaApp* _tmp3_;
#line 205 "../src/WindowTracker.vala"
		_tmp2_ = transient_for;
#line 205 "../src/WindowTracker.vala"
		_tmp3_ = gala_window_tracker_get_app_for_window (self, _tmp2_);
#line 205 "../src/WindowTracker.vala"
		result = _tmp3_;
#line 205 "../src/WindowTracker.vala"
		return result;
#line 1030 "WindowTracker.c"
	}
#line 212 "../src/WindowTracker.vala"
	_tmp5_ = meta_window_get_window_type (window);
#line 212 "../src/WindowTracker.vala"
	_tmp6_ = _tmp5_;
#line 212 "../src/WindowTracker.vala"
	if (_tmp6_ == META_WINDOW_NORMAL) {
#line 212 "../src/WindowTracker.vala"
		_tmp4_ = TRUE;
#line 1040 "WindowTracker.c"
	} else {
#line 212 "../src/WindowTracker.vala"
		_tmp4_ = meta_window_is_remote (window);
#line 1044 "WindowTracker.c"
	}
#line 212 "../src/WindowTracker.vala"
	if (_tmp4_) {
#line 1048 "WindowTracker.c"
		GHashTable* _tmp7_;
		gconstpointer _tmp8_;
		GalaApp* _tmp9_;
#line 213 "../src/WindowTracker.vala"
		_tmp7_ = self->priv->window_to_app;
#line 213 "../src/WindowTracker.vala"
		_tmp8_ = g_hash_table_lookup (_tmp7_, window);
#line 213 "../src/WindowTracker.vala"
		_result_ = (GalaApp*) _tmp8_;
#line 214 "../src/WindowTracker.vala"
		_tmp9_ = _result_;
#line 214 "../src/WindowTracker.vala"
		if (_tmp9_ != NULL) {
#line 1062 "WindowTracker.c"
			GalaApp* _tmp10_;
			GalaApp* _tmp11_;
#line 215 "../src/WindowTracker.vala"
			_tmp10_ = _result_;
#line 215 "../src/WindowTracker.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 215 "../src/WindowTracker.vala"
			result = _tmp11_;
#line 215 "../src/WindowTracker.vala"
			return result;
#line 1073 "WindowTracker.c"
		}
	}
#line 219 "../src/WindowTracker.vala"
	if (meta_window_is_remote (window)) {
#line 1078 "WindowTracker.c"
		GalaApp* _tmp12_;
#line 220 "../src/WindowTracker.vala"
		_tmp12_ = gala_app_new_for_window (window);
#line 220 "../src/WindowTracker.vala"
		result = _tmp12_;
#line 220 "../src/WindowTracker.vala"
		return result;
#line 1086 "WindowTracker.c"
	}
#line 227 "../src/WindowTracker.vala"
	_tmp13_ = gala_window_tracker_get_app_from_window_wmclass (self, window);
#line 227 "../src/WindowTracker.vala"
	_result_ = _tmp13_;
#line 228 "../src/WindowTracker.vala"
	_tmp14_ = _result_;
#line 228 "../src/WindowTracker.vala"
	if (_tmp14_ != NULL) {
#line 1096 "WindowTracker.c"
		GalaApp* _tmp15_;
		GalaApp* _tmp16_;
#line 229 "../src/WindowTracker.vala"
		_tmp15_ = _result_;
#line 229 "../src/WindowTracker.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 229 "../src/WindowTracker.vala"
		result = _tmp16_;
#line 229 "../src/WindowTracker.vala"
		return result;
#line 1107 "WindowTracker.c"
	}
#line 235 "../src/WindowTracker.vala"
	_tmp17_ = gala_window_tracker_get_app_from_sandboxed_app_id (self, window);
#line 235 "../src/WindowTracker.vala"
	_result_ = _tmp17_;
#line 236 "../src/WindowTracker.vala"
	_tmp18_ = _result_;
#line 236 "../src/WindowTracker.vala"
	if (_tmp18_ != NULL) {
#line 1117 "WindowTracker.c"
		GalaApp* _tmp19_;
		GalaApp* _tmp20_;
#line 237 "../src/WindowTracker.vala"
		_tmp19_ = _result_;
#line 237 "../src/WindowTracker.vala"
		_tmp20_ = _g_object_ref0 (_tmp19_);
#line 237 "../src/WindowTracker.vala"
		result = _tmp20_;
#line 237 "../src/WindowTracker.vala"
		return result;
#line 1128 "WindowTracker.c"
	}
#line 243 "../src/WindowTracker.vala"
	_tmp21_ = gala_window_tracker_get_app_from_gapplication_id (window);
#line 243 "../src/WindowTracker.vala"
	_result_ = _tmp21_;
#line 244 "../src/WindowTracker.vala"
	_tmp22_ = _result_;
#line 244 "../src/WindowTracker.vala"
	if (_tmp22_ != NULL) {
#line 1138 "WindowTracker.c"
		GalaApp* _tmp23_;
		GalaApp* _tmp24_;
#line 245 "../src/WindowTracker.vala"
		_tmp23_ = _result_;
#line 245 "../src/WindowTracker.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 245 "../src/WindowTracker.vala"
		result = _tmp24_;
#line 245 "../src/WindowTracker.vala"
		return result;
#line 1149 "WindowTracker.c"
	}
#line 248 "../src/WindowTracker.vala"
	_tmp25_ = gala_window_tracker_get_app_from_window_pid (self, window);
#line 248 "../src/WindowTracker.vala"
	_result_ = _tmp25_;
#line 249 "../src/WindowTracker.vala"
	_tmp26_ = _result_;
#line 249 "../src/WindowTracker.vala"
	if (_tmp26_ != NULL) {
#line 1159 "WindowTracker.c"
		GalaApp* _tmp27_;
		GalaApp* _tmp28_;
#line 250 "../src/WindowTracker.vala"
		_tmp27_ = _result_;
#line 250 "../src/WindowTracker.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 250 "../src/WindowTracker.vala"
		result = _tmp28_;
#line 250 "../src/WindowTracker.vala"
		return result;
#line 1170 "WindowTracker.c"
	}
#line 254 "../src/WindowTracker.vala"
	_tmp29_ = meta_window_get_startup_id (window);
#line 254 "../src/WindowTracker.vala"
	startup_id = _tmp29_;
#line 255 "../src/WindowTracker.vala"
	_tmp30_ = startup_id;
#line 255 "../src/WindowTracker.vala"
	if (_tmp30_ != NULL) {
#line 1180 "WindowTracker.c"
		MetaStartupNotification* sn = NULL;
		MetaDisplay* _tmp31_;
		MetaStartupNotification* _tmp32_;
		GSList* sequences = NULL;
		MetaStartupNotification* _tmp33_;
		GSList* _tmp34_;
		GSList* _tmp35_;
#line 256 "../src/WindowTracker.vala"
		_tmp31_ = meta_window_get_display (window);
#line 256 "../src/WindowTracker.vala"
		_tmp32_ = meta_display_get_startup_notification (_tmp31_);
#line 256 "../src/WindowTracker.vala"
		sn = _tmp32_;
#line 257 "../src/WindowTracker.vala"
		_tmp33_ = sn;
#line 257 "../src/WindowTracker.vala"
		_tmp34_ = meta_startup_notification_get_sequences (_tmp33_);
#line 257 "../src/WindowTracker.vala"
		sequences = _tmp34_;
#line 258 "../src/WindowTracker.vala"
		_tmp35_ = sequences;
#line 1202 "WindowTracker.c"
		{
			GSList* sequence_collection = NULL;
			GSList* sequence_it = NULL;
#line 258 "../src/WindowTracker.vala"
			sequence_collection = _tmp35_;
#line 258 "../src/WindowTracker.vala"
			for (sequence_it = sequence_collection; sequence_it != NULL; sequence_it = sequence_it->next) {
#line 1210 "WindowTracker.c"
				MetaStartupSequence* sequence = NULL;
#line 258 "../src/WindowTracker.vala"
				sequence = (MetaStartupSequence*) sequence_it->data;
#line 1214 "WindowTracker.c"
				{
					const gchar* id = NULL;
					MetaStartupSequence* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					const gchar* _tmp39_;
					const gchar* appid = NULL;
					MetaStartupSequence* _tmp40_;
					const gchar* _tmp41_;
					const gchar* _tmp42_;
#line 259 "../src/WindowTracker.vala"
					_tmp36_ = sequence;
#line 259 "../src/WindowTracker.vala"
					_tmp37_ = meta_startup_sequence_get_id (_tmp36_);
#line 259 "../src/WindowTracker.vala"
					id = _tmp37_;
#line 260 "../src/WindowTracker.vala"
					_tmp38_ = id;
#line 260 "../src/WindowTracker.vala"
					_tmp39_ = startup_id;
#line 260 "../src/WindowTracker.vala"
					if (g_strcmp0 (_tmp38_, _tmp39_) != 0) {
#line 261 "../src/WindowTracker.vala"
						continue;
#line 1239 "WindowTracker.c"
					}
#line 264 "../src/WindowTracker.vala"
					_tmp40_ = sequence;
#line 264 "../src/WindowTracker.vala"
					_tmp41_ = meta_startup_sequence_get_application_id (_tmp40_);
#line 264 "../src/WindowTracker.vala"
					appid = _tmp41_;
#line 265 "../src/WindowTracker.vala"
					_tmp42_ = appid;
#line 265 "../src/WindowTracker.vala"
					if (_tmp42_ != NULL) {
#line 1251 "WindowTracker.c"
						GalaAppSystem* _tmp43_;
						const gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						GalaApp* _tmp47_;
						GalaApp* _tmp48_;
#line 266 "../src/WindowTracker.vala"
						_tmp43_ = gala_app_system_get_default ();
#line 266 "../src/WindowTracker.vala"
						_tmp44_ = appid;
#line 266 "../src/WindowTracker.vala"
						_tmp45_ = g_path_get_basename (_tmp44_);
#line 266 "../src/WindowTracker.vala"
						_tmp46_ = _tmp45_;
#line 266 "../src/WindowTracker.vala"
						_tmp47_ = gala_app_system_lookup_app (_tmp43_, _tmp46_);
#line 266 "../src/WindowTracker.vala"
						_result_ = _tmp47_;
#line 266 "../src/WindowTracker.vala"
						_g_free0 (_tmp46_);
#line 267 "../src/WindowTracker.vala"
						_tmp48_ = _result_;
#line 267 "../src/WindowTracker.vala"
						if (_tmp48_ != NULL) {
#line 1276 "WindowTracker.c"
							GalaApp* _tmp49_;
							GalaApp* _tmp50_;
#line 268 "../src/WindowTracker.vala"
							_tmp49_ = _result_;
#line 268 "../src/WindowTracker.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 268 "../src/WindowTracker.vala"
							result = _tmp50_;
#line 268 "../src/WindowTracker.vala"
							return result;
#line 1287 "WindowTracker.c"
						}
					}
				}
			}
		}
	}
#line 277 "../src/WindowTracker.vala"
	_tmp51_ = gala_window_tracker_get_app_from_window_group (self, window);
#line 277 "../src/WindowTracker.vala"
	_result_ = _tmp51_;
#line 278 "../src/WindowTracker.vala"
	_tmp52_ = _result_;
#line 278 "../src/WindowTracker.vala"
	if (_tmp52_ != NULL) {
#line 1302 "WindowTracker.c"
		GalaApp* _tmp53_;
		GalaApp* _tmp54_;
#line 279 "../src/WindowTracker.vala"
		_tmp53_ = _result_;
#line 279 "../src/WindowTracker.vala"
		_tmp54_ = _g_object_ref0 (_tmp53_);
#line 279 "../src/WindowTracker.vala"
		result = _tmp54_;
#line 279 "../src/WindowTracker.vala"
		return result;
#line 1313 "WindowTracker.c"
	}
#line 283 "../src/WindowTracker.vala"
	_tmp55_ = gala_app_new_for_window (window);
#line 283 "../src/WindowTracker.vala"
	result = _tmp55_;
#line 283 "../src/WindowTracker.vala"
	return result;
#line 1321 "WindowTracker.c"
}

static void
gala_window_tracker_tracked_window_changed (GalaWindowTracker* self,
                                            MetaWindow* window)
{
#line 287 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/WindowTracker.vala"
	g_return_if_fail (window != NULL);
#line 289 "../src/WindowTracker.vala"
	gala_window_tracker_disassociate_window (self, window);
#line 290 "../src/WindowTracker.vala"
	gala_window_tracker_track_window (self, window);
#line 1336 "WindowTracker.c"
}

static void
gala_window_tracker_tracked_window_notified (GalaWindowTracker* self,
                                             GObject* object,
                                             GParamSpec* pspec)
{
#line 293 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/WindowTracker.vala"
	g_return_if_fail (object != NULL);
#line 293 "../src/WindowTracker.vala"
	g_return_if_fail (pspec != NULL);
#line 294 "../src/WindowTracker.vala"
	gala_window_tracker_tracked_window_changed (self, G_TYPE_CHECK_INSTANCE_CAST (object, meta_window_get_type (), MetaWindow));
#line 1352 "WindowTracker.c"
}

static void
_gala_window_tracker_tracked_window_notified_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 305 "../src/WindowTracker.vala"
	gala_window_tracker_tracked_window_notified ((GalaWindowTracker*) self, _sender, pspec);
#line 1362 "WindowTracker.c"
}

static void
_gala_window_tracker_disassociate_window_meta_window_unmanaged (MetaWindow* _sender,
                                                                gpointer self)
{
#line 307 "../src/WindowTracker.vala"
	gala_window_tracker_disassociate_window ((GalaWindowTracker*) self, _sender);
#line 1371 "WindowTracker.c"
}

static void
gala_window_tracker_track_window (GalaWindowTracker* self,
                                  MetaWindow* window)
{
	GalaApp* app = NULL;
	GalaApp* _tmp0_;
	GalaApp* _tmp1_;
	GHashTable* _tmp2_;
	GalaApp* _tmp3_;
	GalaApp* _tmp4_;
	GalaApp* _tmp5_;
#line 297 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/WindowTracker.vala"
	g_return_if_fail (window != NULL);
#line 298 "../src/WindowTracker.vala"
	_tmp0_ = gala_window_tracker_get_app_for_window (self, window);
#line 298 "../src/WindowTracker.vala"
	app = _tmp0_;
#line 299 "../src/WindowTracker.vala"
	_tmp1_ = app;
#line 299 "../src/WindowTracker.vala"
	if (_tmp1_ == NULL) {
#line 300 "../src/WindowTracker.vala"
		_g_object_unref0 (app);
#line 300 "../src/WindowTracker.vala"
		return;
#line 1401 "WindowTracker.c"
	}
#line 303 "../src/WindowTracker.vala"
	_tmp2_ = self->priv->window_to_app;
#line 303 "../src/WindowTracker.vala"
	_tmp3_ = app;
#line 303 "../src/WindowTracker.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 303 "../src/WindowTracker.vala"
	g_hash_table_insert (_tmp2_, window, _tmp4_);
#line 305 "../src/WindowTracker.vala"
	g_signal_connect_object ((GObject*) window, "notify::wm-class", (GCallback) _gala_window_tracker_tracked_window_notified_g_object_notify, self, 0);
#line 306 "../src/WindowTracker.vala"
	g_signal_connect_object ((GObject*) window, "notify::gtk-application-id", (GCallback) _gala_window_tracker_tracked_window_notified_g_object_notify, self, 0);
#line 307 "../src/WindowTracker.vala"
	g_signal_connect_object (window, "unmanaged", (GCallback) _gala_window_tracker_disassociate_window_meta_window_unmanaged, self, 0);
#line 309 "../src/WindowTracker.vala"
	_tmp5_ = app;
#line 309 "../src/WindowTracker.vala"
	gala_app_add_window (_tmp5_, window);
#line 311 "../src/WindowTracker.vala"
	g_signal_emit (self, gala_window_tracker_signals[GALA_WINDOW_TRACKER_WINDOWS_CHANGED_SIGNAL], 0);
#line 297 "../src/WindowTracker.vala"
	_g_object_unref0 (app);
#line 1425 "WindowTracker.c"
}

static void
gala_window_tracker_disassociate_window (GalaWindowTracker* self,
                                         MetaWindow* window)
{
	GalaApp* app = NULL;
	GalaApp* _tmp0_;
	GalaApp* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GQuark _tmp4_;
	guint _tmp5_;
	GQuark _tmp6_;
	GalaApp* _tmp7_;
	GHashTable* _tmp8_;
#line 314 "../src/WindowTracker.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/WindowTracker.vala"
	g_return_if_fail (window != NULL);
#line 315 "../src/WindowTracker.vala"
	_tmp0_ = gala_window_tracker_get_app_for_window (self, window);
#line 315 "../src/WindowTracker.vala"
	app = _tmp0_;
#line 316 "../src/WindowTracker.vala"
	_tmp1_ = app;
#line 316 "../src/WindowTracker.vala"
	if (_tmp1_ == NULL) {
#line 317 "../src/WindowTracker.vala"
		_g_object_unref0 (app);
#line 317 "../src/WindowTracker.vala"
		return;
#line 1458 "WindowTracker.c"
	}
#line 320 "../src/WindowTracker.vala"
	g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp2_, NULL, FALSE);
#line 320 "../src/WindowTracker.vala"
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_tracker_disassociate_window_meta_window_unmanaged, self);
#line 321 "../src/WindowTracker.vala"
	g_signal_parse_name ("notify::wm-class", G_TYPE_OBJECT, &_tmp3_, &_tmp4_, TRUE);
#line 321 "../src/WindowTracker.vala"
	g_signal_handlers_disconnect_matched ((GObject*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, _tmp4_, NULL, (GCallback) _gala_window_tracker_tracked_window_notified_g_object_notify, self);
#line 322 "../src/WindowTracker.vala"
	g_signal_parse_name ("notify::gtk-application-id", G_TYPE_OBJECT, &_tmp5_, &_tmp6_, TRUE);
#line 322 "../src/WindowTracker.vala"
	g_signal_handlers_disconnect_matched ((GObject*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, _tmp6_, NULL, (GCallback) _gala_window_tracker_tracked_window_notified_g_object_notify, self);
#line 323 "../src/WindowTracker.vala"
	_tmp7_ = app;
#line 323 "../src/WindowTracker.vala"
	gala_app_remove_window (_tmp7_, window);
#line 324 "../src/WindowTracker.vala"
	_tmp8_ = self->priv->window_to_app;
#line 324 "../src/WindowTracker.vala"
	g_hash_table_remove (_tmp8_, window);
#line 326 "../src/WindowTracker.vala"
	g_signal_emit (self, gala_window_tracker_signals[GALA_WINDOW_TRACKER_WINDOWS_CHANGED_SIGNAL], 0);
#line 314 "../src/WindowTracker.vala"
	_g_object_unref0 (app);
#line 1484 "WindowTracker.c"
}

GalaWindowTracker*
gala_window_tracker_construct (GType object_type)
{
	GalaWindowTracker * self = NULL;
#line 7 "../src/WindowTracker.vala"
	self = (GalaWindowTracker*) g_object_new (object_type, NULL);
#line 7 "../src/WindowTracker.vala"
	return self;
#line 1495 "WindowTracker.c"
}

GalaWindowTracker*
gala_window_tracker_new (void)
{
#line 7 "../src/WindowTracker.vala"
	return gala_window_tracker_construct (GALA_TYPE_WINDOW_TRACKER);
#line 1503 "WindowTracker.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 13 "../src/WindowTracker.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1511 "WindowTracker.c"
}

static GObject *
gala_window_tracker_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowTracker * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 12 "../src/WindowTracker.vala"
	parent_class = G_OBJECT_CLASS (gala_window_tracker_parent_class);
#line 12 "../src/WindowTracker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 12 "../src/WindowTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker);
#line 13 "../src/WindowTracker.vala"
	_tmp0_ = g_direct_hash;
#line 13 "../src/WindowTracker.vala"
	_tmp1_ = g_direct_equal;
#line 13 "../src/WindowTracker.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_object_unref0_);
#line 13 "../src/WindowTracker.vala"
	_g_hash_table_unref0 (self->priv->window_to_app);
#line 13 "../src/WindowTracker.vala"
	self->priv->window_to_app = _tmp2_;
#line 12 "../src/WindowTracker.vala"
	return obj;
#line 1543 "WindowTracker.c"
}

static void
gala_window_tracker_class_init (GalaWindowTrackerClass * klass,
                                gpointer klass_data)
{
#line 7 "../src/WindowTracker.vala"
	gala_window_tracker_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/WindowTracker.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowTracker_private_offset);
#line 7 "../src/WindowTracker.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_tracker_constructor;
#line 7 "../src/WindowTracker.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_tracker_finalize;
#line 7 "../src/WindowTracker.vala"
	gala_window_tracker_signals[GALA_WINDOW_TRACKER_WINDOWS_CHANGED_SIGNAL] = g_signal_new ("windows-changed", GALA_TYPE_WINDOW_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1560 "WindowTracker.c"
}

static void
gala_window_tracker_instance_init (GalaWindowTracker * self,
                                   gpointer klass)
{
#line 7 "../src/WindowTracker.vala"
	self->priv = gala_window_tracker_get_instance_private (self);
#line 1569 "WindowTracker.c"
}

static void
gala_window_tracker_finalize (GObject * obj)
{
	GalaWindowTracker * self;
#line 7 "../src/WindowTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker);
#line 8 "../src/WindowTracker.vala"
	_g_hash_table_unref0 (self->priv->window_to_app);
#line 7 "../src/WindowTracker.vala"
	G_OBJECT_CLASS (gala_window_tracker_parent_class)->finalize (obj);
#line 1582 "WindowTracker.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_tracker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowTrackerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_tracker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowTracker), 0, (GInstanceInitFunc) gala_window_tracker_instance_init, NULL };
	GType gala_window_tracker_type_id;
	gala_window_tracker_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWindowTracker", &g_define_type_info, 0);
	GalaWindowTracker_private_offset = g_type_add_instance_private (gala_window_tracker_type_id, sizeof (GalaWindowTrackerPrivate));
	return gala_window_tracker_type_id;
}

GType
gala_window_tracker_get_type (void)
{
	static gsize gala_window_tracker_type_id__once = 0;
	if (g_once_init_enter (&gala_window_tracker_type_id__once)) {
		GType gala_window_tracker_type_id;
		gala_window_tracker_type_id = gala_window_tracker_get_type_once ();
		g_once_init_leave (&gala_window_tracker_type_id__once, gala_window_tracker_type_id);
	}
	return gala_window_tracker_type_id__once;
}

